﻿using ScheduleSamples.Common;
using ScheduleSamples.Data;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Grouped Items Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234231

namespace ScheduleSamples
{
    /// <summary>
    /// A page that displays a grouped collection of items.
    /// </summary>
    public sealed partial class MainPage : ScheduleSamples.Common.LayoutAwarePage
    {
        //private NavigationHelper navigationHelper;
        //private ObservableDictionary defaultViewModel = new ObservableDictionary();

        ///// <summary>
        ///// NavigationHelper is used on each page to aid in navigation and 
        ///// process lifetime management
        ///// </summary>
        //public NavigationHelper NavigationHelper
        //{
        //    get { return this.navigationHelper; }
        //}

        ///// <summary>
        ///// This can be changed to a strongly typed view model.
        ///// </summary>
        //public ObservableDictionary DefaultViewModel
        //{
        //    get { return this.defaultViewModel; }
        //}

        public MainPage()
        {
            this.InitializeComponent();
            //this.navigationHelper = new NavigationHelper(this);
            //this.navigationHelper.LoadState += navigationHelper_LoadState;
        }

        /// <summary>
        /// Populates the page with content passed during navigation.  Any saved state is also
        /// provided when recreating a page from a prior session.
        /// </summary>
        /// <param name="navigationParameter">The parameter value passed to
        /// <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested.
        /// </param>
        /// <param name="pageState">A dictionary of state preserved by this page during an earlier
        /// session.  This will be null the first time a page is visited.</param>
        protected override void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
            // TODO: Create an appropriate data model for your problem domain to replace the sample data
            var sampleItems = SampleDataSource.GetItems((String)navigationParameter);
            this.DefaultViewModel["AllItems"] = sampleItems;
        }

        ///// <summary>
        ///// Populates the page with content passed during navigation.  Any saved state is also
        ///// provided when recreating a page from a prior session.
        ///// </summary>
        ///// <param name="sender">
        ///// The source of the event; typically <see cref="NavigationHelper"/>
        ///// </param>
        ///// <param name="e">Event data that provides both the navigation parameter passed to
        ///// <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested and
        ///// a dictionary of state preserved by this page during an earlier
        ///// session.  The state will be null the first time a page is visited.</param>
        //private void navigationHelper_LoadState(object sender, LoadStateEventArgs e)
        //{
        //    // TODO: Create an appropriate data model for your problem domain to replace the sample data
        //    var sampleDataItems = SampleDataSource.GetItems("AllItems");
        //    this.DefaultViewModel["Items"] = sampleDataItems;
        //}

        /// <summary>
        /// Invoked when an item within a group is clicked.
        /// </summary>
        /// <param name="sender">The GridView (or ListView when the application is snapped)
        /// displaying the item clicked.</param>
        /// <param name="e">Event data that describes the item clicked.</param>
        void ItemView_ItemClick(object sender, ItemClickEventArgs e)
        {
            // Navigate to the appropriate destination page, configuring the new page
            // by passing required information as a navigation parameter
            var itemId = ((SampleDataItem)e.ClickedItem).UniqueId;
            this.Frame.Navigate(typeof(ItemDetailPage), itemId);
        }

        #region NavigationHelper registration

        /// The methods provided in this section are simply used to allow
        /// NavigationHelper to respond to the page's navigation methods.
        /// 
        /// Page specific logic should be placed in event handlers for the  
        /// <see cref="GridCS.Common.NavigationHelper.LoadState"/>
        /// and <see cref="GridCS.Common.NavigationHelper.SaveState"/>.
        /// The navigation parameter is available in the LoadState method 
        /// in addition to page state preserved during an earlier session.

        //protected override void OnNavigatedTo(NavigationEventArgs e)
        //{
        //    navigationHelper.OnNavigatedTo(e);
        //    if (e.NavigationMode != NavigationMode.Back && !string.IsNullOrEmpty((string)e.Parameter))
        //    {
        //        // apparently application had been launched by toast notification, so navigate to Save Local Data sample which creates such notifications
        //        this.Dispatcher.RunAsync(Windows.UI.Core.CoreDispatcherPriority.Normal, (()=>this.Frame.Navigate(typeof(ItemDetailPage), "Save Local Data")));
        //    }
        //}

        //protected override void OnNavigatedFrom(NavigationEventArgs e)
        //{
        //    navigationHelper.OnNavigatedFrom(e);
        //}

        #endregion
    }
}