﻿Class DataPort
    Private Shared _SymbolNames As String()
    Public Shared ReadOnly Property SymbolNames() As String()
        Get
            If _SymbolNames Is Nothing Then
                _SymbolNames = New String() {
"^DJI	Dow Jones Industrial.",
"^DJI3m	Dow Jones Industrial.",
"A	Agilent Technologies, Inc.",
"AA	Alcoa Inc.",
"AAC	Australia Acquisition Corp.",
"AACC	Asset Acceptance Capital Corp.",
"AACOU	Australia Acquisition Corp.",
"AACOW	Australia Acquisition Corp.",
"AAIT	iShares Trust iShares MSCI All Country Asia Information Technology Index Fund",
"AAME	Atlantic American Corporation",
"AAN	Aaron's,  Inc.",
"AAON	AAON, Inc.",
"AAP	Advance Auto Parts Inc",
"AAPL	Apple Inc.",
"AAT	American Assets Trust, Inc.",
"AAV	Advantage Oil & Gas Ltd",
"AAWW	Atlas Air Worldwide Holdings",
"AAXJ	iShares MSCI All Country Asia ex Japan Index Fund",
"AB	Alliance Capital Management Holding L.P.",
"ABAX	ABAXIS, Inc.",
"ABB	ABB Ltd",
"ABC	AmerisourceBergen Corporation (Holding Co)",
"ABCB	Ameris Bancorp",
"ABCD	Cambium Learning Group, Inc.",
"ABCO	The Advisory Board Company",
"ABD	Acco Brands Corporation",
"ABFS	Arkansas Best Corporation",
"ABG	Asbury Automotive Group Inc",
"ABH	AbitibiBowater Inc.",
"ABIO	ARCA biopharma, Inc.",
"ABM	ABM Industries Incorporated",
"ABMD	ABIOMED, Inc.",
"ABR	Arbor Realty Trust",
"ABT	Abbott Laboratories",
"ABTL	Autobytel Inc.",
"ABV	Companhia de Bebidas das Americas - AmBev",
"ABV/C	Companhia de Bebidas das Americas - AmBev",
"ABVA	Alliance Bankshares Corporation",
"ABVT	Abovenet Inc",
"ABX	Barrick Gold Corporation",
"ACAD	ACADIA Pharmaceuticals Inc.",
"ACAS	American Capital, Ltd.",
"ACAT	Arctic Cat Inc.",
"ACC	American Campus Communities Inc",
"ACCL	Accelrys, Inc.",
"ACE	Ace Limited",
"ACET	Aceto Corporation",
"ACFC	Atlantic Coast Federal Corporation",
"ACFN	Acorn Energy, Inc.",
"ACG	ALLIANCEBERNSTEIN INCOME FUND INC",
"ACGL	Arch Capital Group Ltd.",
"ACH	Aluminum Corporation of China Ltd",
"ACHC	Acadia Healthcare Company, Inc.",
"ACHN	Achillion Pharmaceuticals, Inc.",
"ACI	Arch Coal, Inc.",
"ACIW	ACI Worldwide, Inc.",
"ACLS	Axcelis Technologies, Inc.",
"ACM	Aecom Technology Corporation",
"ACN	Accenture plc.",
"ACNB	ACNB Corporation",
"ACO	Amcol International Corporation",
"ACOM	Ancestry.com, Inc.",
"ACOR	Acorda Therapeutics, Inc.",
"ACP	Avenue Income Credit Strategies Fund",
"ACP~	Avenue Income Credit Strategies Fund",
"ACPW	Active Power, Inc.",
"ACRX	AcelRx Pharmaceuticals, Inc.",
"ACTG	Acacia Research Corporation",
"ACTS	Actions Semiconductor Co., Ltd.",
"ACTV	The Active Network, Inc.",
"ACUR	Acura Pharmaceuticals, Inc.",
"ACW	Accuride Corporation New",
"ACWI	iShares MSCI ACWI Index Fund",
"ACWX	iShares MSCI ACWI ex US Index Fund",
"ACXM	Acxiom Corporation",
"ADAT	Authentidate Holding Corp.",
"ADBE	Adobe Systems Incorporated",
"ADC	Agree Realty Corporation",
"ADEP	Adept Technology, Inc.",
"ADES	ADA-ES, Inc.",
"ADGF	Adams Golf, Inc.",
"ADI	Analog Devices, Inc.",
"ADM	Archer-Daniels-Midland Company",
"ADP	Automatic Data Processing, Inc.",
"ADRA	BLDRS Asia 50 ADR Index Fund",
"ADRD	BLDRS Developed Markets 100 ADR Index Fund",
"ADRE	BLDRS Emerging Markets 50 ADR Index Fund",
"ADRU	BLDRS Europe 100 ADR Index Fund",
"ADS	Alliance Data Systems Corporation",
"ADSK	Autodesk, Inc.",
"ADTN	ADTRAN, Inc.",
"ADUS	Addus HomeCare Corporation",
"ADVS	Advent Software, Inc.",
"ADX	Adams Express Company (The)",
"ADY	Feihe International, Inc.",
"AEA	Advance America, Cash Advance Centers, Inc.",
"AEB	Aegon NV",
"AEC	Associated Estates Realty Corporation",
"AED	Aegon NV",
"AEE	Ameren Corporation",
"AEF	Aegon NV",
"AEG	Aegon NV",
"AEGN	Aegion Corp",
"AEGR	Aegerion Pharmaceuticals, Inc.",
"AEH	Aegon NV",
"AEHR	Aehr Test Systems",
"AEIS	Advanced Energy Industries, Inc.",
"AEK	Aegon NV",
"AEL	American Equity Investment Life Holding Company",
"AEM	Agnico-Eagle Mines Limited",
"AEO	American Eagle Outfitters, Inc.",
"AEP	American Electric Power Company, Inc.",
"AEPI	AEP Industries Inc.",
"AER	Aercap Holdings N.V.",
"AERL	Asia Entertainment & Resources Ltd",
"AES	The AES Corporation",
"AET	Aetna Inc.",
"AETI	American Electric Technologies, Inc.",
"AEV	Aegon NV",
"AEY	ADDvantage Technologies Group, Inc.",
"AEZS	AEterna Zentaris, Inc.",
"AF	Astoria Financial Corporation",
"AFAM	Almost Family Inc",
"AFB	Alliance National Municipal Income Fund Inc",
"AFC	Allied Capital Corporation",
"AFCB	Athens Bancshares Corporation",
"AFCE	AFC Enterprises, Inc.",
"AFE	American Financial Group, Inc.",
"AFF	American International Group, Inc.",
"AFFM	Affirmative Insurance Holdings, Inc.",
"AFFX	Affymetrix, Inc.",
"AFFY	Affymax, Inc.",
"AFG	American Financial Group, Inc.",
"AFL	Aflac Incorporated",
"AFOP	Alliance Fiber Optic Products, Inc.",
"AFQ	American Financial Group, Inc.",
"AFSI	AmTrust Financial Services, Inc.",
"AFT	Apollo Senior Floating Rate Fund Inc.",
"AG	First Majestic Silver Corp.",
"AGC	Advent Claymore Convertible Securities and Income Fund II",
"AGCO	AGCO Corporation",
"AGD	Alpine Global Dynamic Dividend Fund",
"AGEN	Agenus Inc.",
"AGII	Argo Group International Holdings, Ltd.",
"AGM	Federal Agricultural Mortgage Corporation",
"AGM/A	Federal Agricultural Mortgage Corporation",
"AGN	Allergan, Inc.",
"AGNC	American Capital Agency Corp.",
"AGO	Assured Guaranty Ltd.",
"AGP	AMERIGROUP Corporation",
"AGRO	Adecoagro S.A.",
"AGU	Agrium Inc.",
"AGYS	Agilysys, Inc.",
"AH	Accretive Health, Inc.",
"AHC	A.H. Belo Corporation",
"AHGP	Alliance Holdings GP, L.P.",
"AHL	Aspen Insurance Holdings Limited",
"AHPI	Allied Healthcare Products, Inc.",
"AHS	AMN Healthcare Services Inc",
"AHT	Ashford Hospitality Trust Inc",
"AI	Arlington Asset Investment Corp",
"AIG	American International Group, Inc.",
"AIG/WS	American International Group, Inc.",
"AIMC	Altra Holdings, Inc.",
"AIN	Albany International Corporation",
"AINV	Apollo Investment Corporation",
"AIQ	Alliance HealthCare Services, Inc.",
"AIR	AAR Corp.",
"AIRM	Air Methods Corporation",
"AIRT	Air T, Inc.",
"AIT	Applied Industrial Technologies, Inc.",
"AIV	Apartment Investment and Management Company",
"AIXG	Aixtron SE",
"AIZ	Assurant, Inc.",
"AJG	Arthur J. Gallagher & Co.",
"AKAM	Akamai Technologies, Inc.",
"AKO/A	Embotelladora Andina S.A.",
"AKO/B	Embotelladora Andina S.A.",
"AKP	Alliance California Municipal Income Fund Inc",
"AKR	Acadia Realty Trust",
"AKRX	Akorn, Inc.",
"AKS	AK Steel Holding Corporation",
"AL	Air Lease Corporation",
"ALB	Albemarle Corporation",
"ALC	Assisted Living Concepts, Inc. New",
"ALCO	Alico, Inc.",
"ALE	Allete, Inc.",
"ALEX	Alexander & Baldwin, Inc.",
"ALG	Alamo Group, Inc.",
"ALGN	Align Technology, Inc.",
"ALGT	Allegiant Travel Company",
"ALIM	Alimera Sciences, Inc.",
"ALJ	Alon USA Energy, Inc.",
"ALK	Alaska Air Group, Inc.",
"ALKS	Alkermes plc",
"ALL	Allstate Corporation (The)",
"ALLB	Alliance Bancorp, Inc. of Pennsylvania",
"ALLT	Allot Communications Ltd.",
"ALM/CL	Alabama Power Company",
"ALNC	Alliance Financial Corporation",
"ALNY	Alnylam Pharmaceuticals, Inc.",
"ALOG	Analogic Corporation",
"ALOT	Astro-Med, Inc.",
"ALR	Alere Inc.",
"ALRN	American Learning Corporation",
"ALSK	Alaska Communications Systems Group, Inc.",
"ALTE	Alterra Capital Holdings Limited",
"ALTH	Allos Therapeutics, Inc.",
"ALTI	Altair Nanotechnologies Inc.",
"ALTR	Altera Corporation",
"ALU	Alcatel Lucent",
"ALV	Autoliv, Inc.",
"ALVR	Alvarion Ltd.",
"ALX	Alexander's, Inc.",
"ALXA	Alexza Pharmaceuticals, Inc.",
"ALXN	Alexion Pharmaceuticals, Inc.",
"AM	American Greetings Corporation",
"AMAG	AMAG Pharmaceuticals, Inc.",
"AMAP	AutoNavi Holdings Limited",
"AMAT	Applied Materials, Inc.",
"AMBO	Ambow Education Holding Ltd.",
"AMBT	Ambient Corporation",
"AMCC	Applied Micro Circuits Corporation",
"AMCF	Andatee China Marine Fuel Services Corporation",
"AMCN	AirMedia Group Inc",
"AMCX	AMC Networks Inc.",
"AMD	Advanced Micro Devices, Inc.",
"AME	AMTEK, Inc.",
"AMED	Amedisys Inc",
"AMG	Affiliated Managers Group, Inc.",
"AMGN	Amgen Inc.",
"AMIC	American Independence Corp.",
"AMID	American Midstream Partners, LP",
"AMKR	Amkor Technology, Inc.",
"AMLN	Amylin Pharmaceuticals, Inc.",
"AMNB	American National Bankshares, Inc.",
"AMOT	Allied Motion Technologies, Inc.",
"AMOV	America Movil, S.A.B. de C.V.",
"AMP	AMERIPRISE FINANCIAL SERVICES, INC.",
"AMPE	Ampio Pharmaceuticals, Inc.",
"AMPL	Ampal-American Israel Corporation",
"AMRB	American River Bankshares",
"AMRC	Ameresco, Inc",
"AMRI	Albany Molecular Research, Inc.",
"AMRN	Amarin Corporation PLC",
"AMRS	Amyris, Inc.",
"AMSC	American Superconductor Corporation",
"AMSF	AMERISAFE, Inc.",
"AMSG	Amsurg Corp.",
"AMSWA	American Software, Inc.",
"AMT	American Tower Corporation (REIT)",
"AMTC	Ameritrans Capital Corporation",
"AMTCP	Ameritrans Capital Corporation",
"AMTD	TD Ameritrade Holding Corporation",
"AMTG	Apollo Residential Mortgage, Inc.",
"AMWD	American Woodmark Corporation",
"AMX	America Movil, S.A.B. de C.V.",
"AMZN	Amazon.com, Inc.",
"AN	AutoNation, Inc.",
"ANAC	Anacor Pharmaceuticals, Inc.",
"ANAD	ANADIGICS, Inc.",
"ANAT	American National Insurance Company",
"ANCB	Anchor Bancorp",
"ANCI	American Caresource Holdings Inc",
"ANCX	Access National Corporation",
"ANDE	The Andersons, Inc.",
"ANEN	Anaren, Inc.",
"ANF	Abercrombie & Fitch Company",
"ANGI	Angie's List, Inc.",
"ANGN	Angeion Corporation",
"ANGO	AngioDynamics, Inc.",
"ANH	Anworth Mortgage Asset  Corporation",
"ANIK	Anika Therapeutics Inc.",
"ANLY	Analysts International Corporation",
"ANN	ANN INC.",
"ANNB	Annapolis Bancorp Inc.",
"ANR	Alpha Natural Resources, inc.",
"ANSS	ANSYS, Inc.",
"ANTH	Anthera Pharmaceuticals, Inc.",
"ANTP	PHAZAR CORP",
"ANW	Aegean Marine Petroleum Network Inc.",
"AOB	American Oriental Bioengineering, Inc.",
"AOD	Alpine Total Dynamic Dividend Fund",
"AOI	Alliance One International, Inc.",
"AOL	AOL Inc.",
"AON	Aon Corporation",
"AONE	A123 Systems, Inc.",
"AOS	Smith (A.O.) Corporation",
"AOSL	Alpha and Omega Semiconductor Limited",
"AP	Ampco-Pittsburgh Corporation",
"APA	Apache Corporation",
"APAGF	Apco Oil and Gas International Inc.",
"APB	Asia Pacific Fund, Inc. (The)",
"APC	Anadarko Petroleum Corporation",
"APD	Air Products and Chemicals, Inc.",
"APEI	American Public Education, Inc.",
"APF	Morgan Stanley Asia-Pacific Fund, Inc.",
"APFC	American Pacific Corporation",
"APH	Amphenol Corporation",
"APKT	Acme Packet, Inc.",
"APL	Atlas Pipeline Partners, L.P.",
"APO	Apollo Global Management, LLC",
"APOG	Apogee Enterprises, Inc.",
"APOL	Apollo Group, Inc.",
"APPY	AspenBio Pharma, Inc.",
"APRI	Apricus Biosciences, Inc",
"APSA	Alto Palermo S.A.",
"APU	AmeriGas Partners, L.P.",
"APWC	Asia Pacific Wire & Cable Corporation Limited",
"ARAY	Accuray Incorporated",
"ARB	Arbitron Inc.",
"ARBA	Ariba, Inc.",
"ARC	American Reprographics Company",
"ARCC	Ares Capital Corporation",
"ARCI	Appliance Recycling Centers of America, Inc.",
"ARCL	Archipelago Learning, Inc.",
"ARCO	Arcos Dorados Holdings Inc.",
"ARCP	American Realty Capital Properties, Inc.",
"ARCT	American Realty Capital Trust, Inc.",
"ARCW	Arc Wireless Solutions, Inc.",
"ARDNA	Arden Group, Inc.",
"ARE	Alexandria Real Estate Equities, Inc.",
"AREX	Approach Resources Inc.",
"ARG	Airgas, Inc.",
"ARGN	Amerigon Incorporated",
"ARI	Apollo Commercial Real Estate Finance",
"ARIA	ARIAD Pharmaceuticals, Inc.",
"ARII	American Railcar Industries, Inc.",
"ARK	Senior High Income Portfolio, Inc.",
"ARKR	Ark Restaurants Corp.",
"ARL	American Realty Investors, Inc.",
"ARLP	Alliance Resource Partners, L.P.",
"ARMH	ARM Holdings, plc",
"ARN	Ares Capital Corporation",
"ARNA	Arena Pharmaceuticals, Inc.",
"ARO	Aeropostale Inc",
"AROW	Arrow Financial Corporation",
"ARP$	Atlas Resource Partners, L.P.",
"ARQL	ArQule, Inc.",
"ARR	Armour Residential R",
"ARRS	Arris Group Inc",
"ARRY	Array BioPharma Inc.",
"ARSD	Arabian American Development Company",
"ART	ARTIO GLOBAL INVESTORS INC.",
"ARTC	ArthroCare Corporation",
"ARTNA	Artesian Resources Corporation",
"ARTW	Art's-Way Manufacturing Co., Inc.",
"ARTX	Arotech Corporation",
"ARUN	Aruba Networks, Inc.",
"ARW	Arrow Electronics, Inc.",
"ARWR	Arrowhead Research Corporation",
"ARX	Aeroflex Holding Corp.",
"ARY	Ares Capital Corporation",
"ASA	ASA Gold and Precious Metals Limited",
"ASBB	ASB Bancorp, Inc.",
"ASBC	Associated Banc-Corp",
"ASBCW	Associated Banc-Corp",
"ASBI	Ameriana Bancorp",
"ASCA	Ameristar Casinos, Inc.",
"ASCMA	Ascent Capital Group, Inc.",
"ASEI	American Science and Engineering, Inc.",
"ASFI	Asta Funding, Inc.",
"ASG	Liberty All-Star Growth Fund, Inc.",
"ASGN	On Assignment, Inc.",
"ASH	Ashland Inc.",
"ASI	American Safety Insurance Holdings, Ltd.",
"ASIA	AsiaInfo-Linkage, Inc.",
"ASMI	ASM International N.V.",
"ASML	ASML Holding N.V.",
"ASNA	Ascena Retail Group, Inc.",
"ASP	American Strategic Income Portfolio",
"ASPS	Altisource Portfolio Solutions S.A.",
"ASR	Grupo Aeroportuario del Sureste, S.A. de C.V.",
"ASRV	AmeriServ Financial Inc.",
"ASRVP	AmeriServ Financial Inc.",
"ASTC	Astrotech Corporation",
"ASTE	Astec Industries, Inc.",
"ASTI	Ascent Solar Technologies, Inc.",
"ASTM	Aastrom Biosciences, Inc.",
"ASTX	Astex Pharmaceuticals, Inc.",
"ASUR	Asure Software Inc",
"ASX	Advanced Semiconductor Engineering, Inc.",
"ASYS	Amtech Systems, Inc.",
"AT	Atlantic Power Corporation",
"ATAI	ATA Inc.",
"ATAX	America First Tax Exempt Investors, L.P.",
"ATE	Advantest Corporation (Kabushiki Kaisha Advantest) ADS",
"ATEA	Astea International, Inc.",
"ATEC	Alphatec Holdings, Inc.",
"ATHN	athenahealth, Inc.",
"ATHX	Athersys, Inc.",
"ATI	Allegheny Technologies Incorporated",
"ATK	Alliant Techsystems Inc.",
"ATLO	Ames National Corporation",
"ATLS	Atlas Energy, L.P.",
"ATLS$	Atlas Energy, L.P.",
"ATMI	ATMI Inc.",
"ATML	Atmel Corporation",
"ATNI	Atlantic Tele-Network, Inc.",
"ATNY	API Technologies Corp.",
"ATO	Atmos Energy Corporation",
"ATPG	ATP Oil & Gas Corporation",
"ATR	AptarGroup, Inc.",
"ATRC	AtriCure, Inc.",
"ATRI	ATRION Corporation",
"ATRM	Aetrium Incorporated",
"ATRO	Astronics Corporation",
"ATSG	Air Transport Services Group, Inc",
"ATU	Actuant Corporation",
"ATV	Acorn International, Inc.",
"ATVI	Activision Blizzard, Inc",
"ATW	Atwood Oceanics, Inc.",
"ATX	Cross (A.T.) Company",
"AU	AngloGold Ashanti Ltd.",
"AUBN	Auburn National Bancorporation, Inc.",
"AUDC	AudioCodes Ltd.",
"AUO	AU Optronics Corp",
"AUQ	AuRico Gold Inc.",
"AUTH	AuthenTec, Inc.",
"AUXL	Auxilium Pharmaceuticals, Inc.",
"AUY	Yamana Gold, Inc.",
"AV	Aviva plc",
"AVA	Avista Corporation",
"AVAV	AeroVironment, Inc.",
"AVB	AvalonBay Communities, Inc.",
"AVCA	Advocat, Inc.",
"AVD	American Vanguard Corporation",
"AVEO	AVEO Pharmaceuticals, Inc.",
"AVF	American International Group, Inc.",
"AVG	AVG Technologies N.V.",
"AVGO	Avago Technologies Limited",
"AVHI	A V Homes, Inc.",
"AVID	Avid Technology, Inc.",
"AVII	AVI BioPharma, Inc.",
"AVK	Advent Claymore Convertible Securities and Income Fund",
"AVNR	Avanir Pharmaceuticals, Inc.",
"AVNW	Aviat Networks, Inc.",
"AVP	Avon Products, Inc.",
"AVT	Avnet, Inc.",
"AVV	Aviva plc",
"AVX	AVX Corporation",
"AVY	Avery Dennison Corporation",
"AWAY	HomeAway, Inc.",
"AWC	Alumina Ltd",
"AWF	Alliance World Dollar Government Fund II",
"AWH	Allied World Assurance Company Holdings, AG",
"AWI	Armstrong World Industries Inc",
"AWK	American Water Works",
"AWP	Alpine Global Premier Properties Fund",
"AWR	American States Water Company",
"AWRE	Aware, Inc.",
"AXAS	Abraxas Petroleum Corporation",
"AXE	Anixter International Inc.",
"AXFN	iShares MSCI ACWI ex US Financials Sector Index Fund",
"AXJS	iShares Trust iShares MSCI All Country Asia ex Japan Small Cap Index Fund",
"AXL	American Axle & Manufacturing Holdings, Inc.",
"AXP	American Express Company",
"AXR	AMREP Corporation",
"AXS	Axis Capital Holdings Limited",
"AXTI	AXT Inc",
"AYI	Acuity Brands Inc",
"AYN	Alliance New York Municipal Income Fund Inc",
"AYR	Aircastle Limited",
"AZN	Astrazeneca PLC",
"AZO	AutoZone, Inc.",
"AZPN	Aspen Technology, Inc.",
"AZZ	AZZ Incorporated",
"B	Barnes Group, Inc.",
"BA	Boeing Company (The)",
"BABY	Natus Medical Incorporated",
"BAC	Bank of America Corporation",
"BAC/WS/A	Bank of America Corporation",
"BAC/WS/B	Bank of America Corporation",
"BAF	BlackRock Income Investment Quality Trust",
"BAGL	Einstein Noah Restaurant Group, Inc.",
"BAH	Booz Allen Hamilton Holding Corporation",
"BAK	Copene-Petroquimica do Nordeste",
"BALT	Baltic Trading Limited",
"BAM	Brookfield Asset Management Inc",
"BAMM	Books-A-Million, Inc.",
"BANC	First PacTrust Bancorp, Inc.",
"BANF	BancFirst Corporation",
"BANFP	BancFirst Corporation",
"BANR	Banner Corporation",
"BAP	Credicorp Ltd.",
"BAS	Basic Energy Services, Inc.",
"BASI	Bioanalytical Systems, Inc.",
"BAX	Baxter International Inc.",
"BBBY	Bed Bath & Beyond Inc.",
"BBCN	BBCN Bancorp, Inc.",
"BBD	Banco Bradesco Sa",
"BBEP	BreitBurn Energy Partners, L.P.",
"BBF	BlackRock Municipal Income Investment Trust",
"BBG	Bill Barrett Corporation",
"BBGI	Beasley Broadcast Group, Inc.",
"BBK	Blackrock Municipal Bond Trust",
"BBL	BHP Billiton plc",
"BBN	BalckRock Build America Bond Trust",
"BBNK	Bridge Capital Holdings",
"BBOX	Black Box Corporation",
"BBRG	Bravo Brio Restaurant Group, Inc.",
"BBSI	Barrett Business Services, Inc.",
"BBT	BB&T Corporation",
"BBVA	Banco Bilbao Viscaya Argentaria S.A.",
"BBW	Build-A-Bear Workshop, Inc.",
"BBX	BankAtlantic Bancorp, Inc.",
"BBXT	BankAtlantic Bancorp, Inc.",
"BBY	Best Buy Co., Inc.",
"BC	Brunswick Corporation",
"BCA	Corpbanca",
"BCBP	BCB Bancorp, Inc. (NJ)",
"BCDS	BCD Semiconductor Manufacturing Limited",
"BCE	BCE, Inc.",
"BCEI	Bonanza Creek Energy, Inc.",
"BCF	Blackrock Real Asset Equity Trust",
"BCH	Banco De Chile",
"BCO	Brink's Company (The)",
"BCOM	B Communications Ltd.",
"BCOV	Brightcove Inc.",
"BCPC	Balchem Corporation",
"BCR	C.R. Bard, Inc.",
"BCRX	BioCryst Pharmaceuticals, Inc.",
"BCS	Barclays PLC",
"BCSB	BCSB Bancorp, Inc.",
"BCX	BlackRock Resources",
"BDC	Belden Inc",
"BDE	Black Diamond, Inc.",
"BDGE	Bridge Bancorp, Inc.",
"BDJ	Blackrock Enhanced Equity Dividend Trust",
"BDMS	Birner Dental Management Services, Inc.",
"BDN	Brandywine Realty Trust",
"BDSI	BioDelivery Sciences International, Inc.",
"BDX	Becton, Dickinson and Company",
"BEAM	Beam Inc.",
"BEAT	CardioNet, Inc.",
"BEAV	BE Aerospace, Inc.",
"BEBE	bebe stores, inc.",
"BECN	Beacon Roofing Supply, Inc.",
"BEE	Strategic Hotels & Resorts Inc",
"BELFA	Bel Fuse Inc.",
"BELFB	Bel Fuse Inc.",
"BEN	Franklin Resources, Inc.",
"BERK	Berkshire Bancorp, Inc.",
"BEST	Shiner International, Inc.",
"BF/A	Brown Forman Corporation",
"BF/B	Brown Forman Corporation",
"BFED	Beacon Federal Bancorp, Inc.",
"BFIN	BankFinancial Corporation",
"BFK	BlackRock Municipal Income Trust",
"BFLY	Bluefly, Inc.",
"BFO	Blackrock Florida Municipal 2020 Term Trust",
"BFR	BBVA Banco Frances S.A.",
"BFS	Saul Centers, Inc.",
"BFZ	BlackRock California Municipal Income Trust",
"BG	Bunge Limited",
"BGC	General Cable Corporation",
"BGCP	BGC Partners, Inc.",
"BGFV	Big 5 Sporting Goods Corporation",
"BGG	Briggs & Stratton Corporation",
"BGMD	BG Medicine, Inc.",
"BGR	BlackRock Energy and Resources Trust",
"BGS	B&G Foods Holdings Corp.",
"BGSCU	BGS Acquisition Corp.",
"BGT	Blackrock Global",
"BGX	Blackstone GSO Long Short Credit Income Fund",
"BGY	BLACKROCK INTERNATIONAL, LTD.",
"BH	Biglari Holdings Inc.",
"BHD	Blackrock Strategic Bond Trust",
"BHE	Benchmark Electronics, Inc.",
"BHI	Baker Hughes Incorporated",
"BHK	Blackrock Core Bond Trust",
"BHL	Blackrock Defined Opportunity Credit Trust",
"BHLB	Berkshire Hills Bancorp, Inc.",
"BHP	BHP Billiton Limited",
"BHY	Blackrock High Yield Trust (The)",
"BIB	ProShares Trust ProShares Ultra Nasdaq Biotechnology",
"BICK	First Trust Exchange-Traded Fund II First Trust BICK Index Fund",
"BID	Sotheby's",
"BIDU	Baidu, Inc.",
"BIDZ	Bidz.com, Inc.",
"BIE	Blackrock Municipal Bond Investment Trust",
"BIF	USLIFE Income Fund, Inc.",
"BIG	Big Lots, Inc.",
"BIIB	Biogen Idec Inc.",
"BIN	Progressive Waste Solutions Ltd.",
"BIO	Bio-Rad Laboratories, Inc.",
"BIO/B	Bio-Rad Laboratories, Inc.",
"BIOC	BioClinica, Inc",
"BIOD	Biodel Inc.",
"BIOF	BioFuel Energy Corp.",
"BIOS	BioScrip, Inc.",
"BIP	Brookfield Infrastructure Partners LP",
"BIRT	Actuate Corporation",
"BIS	ProShares Trust ProShares UltraShort Nasdaq Biotechnology",
"BITA	Bitauto Holdings Limited",
"BITS	Bitstream Inc.",
"BJRI	BJ's Restaurants, Inc.",
"BJZ	Blackrock California Municipal 2018 Term Trust",
"BK	Bank Of New York Mellon Corporation (The)",
"BKBK	Britton & Koontz Capital Corporation",
"BKCC	BlackRock Kelso Capital Corporation",
"BKD	Brookdale Senior Living Inc.",
"BKE	Buckle, Inc. (The)",
"BKEP	Blueknight Energy Partners L.P., L.L.C.",
"BKEPP	Blueknight Energy Partners L.P., L.L.C.",
"BKH	Black Hills Corporation",
"BKI	Buckeye Technologies, Inc.",
"BKK	Blackrock Municipal 2020 Term Trust",
"BKMU	Bank Mutual Corporation",
"BKN	BlackRock Investment Quality Municipal Trust Inc. (The)",
"BKOR	Oak Ridge Financial Services, Inc.",
"BKS	Barnes & Noble, Inc.",
"BKSC	Bank of South Carolina Corp.",
"BKT	BlackRock Income Trust Inc. (The)",
"BKU	BankUnited, Inc.",
"BKYF	The Bank of Kentucky Financial Corp.",
"BLC	Belo Corporation",
"BLDP	Ballard Power Systems, Inc.",
"BLDR	Builders FirstSource, Inc.",
"BLH	Blackrock New York Municipal 2018 Term Trust",
"BLIN	Bridgeline Digital, Inc.",
"BLK	BlackRock, Inc.",
"BLKB	Blackbaud, Inc.",
"BLL	Ball Corporation",
"BLMT	BSB Bancorp, Inc.",
"BLRX	BioLineRx Ltd.",
"BLT	Blount International, Inc.",
"BLTI	BioLase Technology, Inc.",
"BLW	Citigroup Inc.",
"BLX	Banco Latinoamericano de Comercio Exterior, S.A.",
"BMA	Banco Macro S.A.",
"BMC	BMC Software, Inc.",
"BME	Blackrock Health Sciences Trust",
"BMI	Badger Meter, Inc.",
"BMO	Bank Of Montreal",
"BMR	Biomed Realty Trust",
"BMRC	Bank of Marin Bancorp",
"BMRN	BioMarin Pharmaceutical Inc.",
"BMS	Bemis Company, Inc.",
"BMTC	Bryn Mawr Bank Corporation",
"BMTI	BioMimetic Therapeutics, Inc.",
"BMY	Bristol-Myers Squibb Company",
"BNA	BlackRock Income Opportunity Trust Inc. (The)",
"BNCL	Beneficial Mutual Bancorp, Inc.",
"BNCN	BNC Bancorp",
"BNHN	Benihana Inc.",
"BNJ	BlackRock New Jersey Municipal Income Trust",
"BNS	Bank of Nova Scotia (The)",
"BNSO	Bonso Electronics International, Inc.",
"BNY	BlackRock New York Investment Quality Municipal Trust Inc. (Th",
"BOBE	Bob Evans Farms, Inc.",
"BOCH	Bank of Commerce Holdings (CA)",
"BODY	Body Central Corp.",
"BOE	Blackrock Global",
"BOFI	BofI Holding, Inc.",
"BOH	Bank of Hawaii Corporation",
"BOKF	BOK Financial Corporation",
"BOLT	Bolt Technology Corporation",
"BONA	Bona Film Group Limited",
"BONT	The Bon-Ton Stores, Inc.",
"BOOM	Dynamic Materials Corporation",
"BOOT	LaCrosse Footwear, Inc.",
"BORN	China New Borun Corporation",
"BOSC	B.O.S. Better Online Solutions",
"BOTJ	Bank of the James Financial Group, Inc.",
"BOVA	Bank Of Virginia",
"BOX	SeaCube Container Leasing Ltd.",
"BOXC	Brookfield Canada Office Properties",
"BP	BP p.l.c.",
"BPAX	Biosante Pharmaceuticals, Inc.",
"BPFH	Boston Private Financial Holdings, Inc.",
"BPFHW	Boston Private Financial Holdings, Inc.",
"BPHX	BluePhoenix Solutions, Ltd.",
"BPI	Bridgepoint Education",
"BPK	Blackrock Municipal 2018 Term Trust",
"BPL	Buckeye Partners L.P.",
"BPO	Brookfield Office Properties Inc.",
"BPOP	Popular, Inc.",
"BPOPM	Popular, Inc.",
"BPOPN	Popular, Inc.",
"BPP	Blackrock Preferred Oopportunity Trust",
"BPT	BP Prudhoe Bay Royalty Trust",
"BPZ	BPZ Resources, Inc",
"BQH	Blackrock New York Municipal Bond Trust",
"BQR	BlackRock Ecosolutions Investment Trust",
"BR	Broadridge Financial Solutions, Inc.",
"BRC	Brady Corporation",
"BRCD	Brocade Communications Systems, Inc.",
"BRCM	Broadcom Corporation",
"BRE	BRE Properties, Inc.",
"BRFS	BRF-Brasil Foods S.A.",
"BRID	Bridgford Foods Corporation",
"BRK/A	Berkshire Hathaway Inc.",
"BRK/B	Berkshire Hathaway Inc.",
"BRKL	Brookline Bancorp, Inc.",
"BRKR	Bruker Corporation",
"BRKS	Brooks Automation, Inc.",
"BRLI	Bio-Reference Laboratories, Inc.",
"BRO	Brown & Brown, Inc.",
"BRP	Brookfield Residential Properties Inc.",
"BRS	Bristow Group Inc",
"BRT	BRT Realty Trust",
"BRY	Berry Petroleum Company",
"BSBR	Banco Santander Brasil SA",
"BSD	BlackRock Strategic Municipal Trust Inc. (The)",
"BSDM	BSD Medical Corporation",
"BSE	Blackrock New York Municipal Income Quality Trust",
"BSET	Bassett Furniture Industries, Incorporated",
"BSFT	BroadSoft, Inc.",
"BSI	Alon Holdings - Blue Square Israel Ltd.",
"BSL	Blackstone GSO Senior Floating Rate Term Fund",
"BSP	American Strategic Income Portfolio II",
"BSPM	Biostar Pharmaceuticals, Inc.",
"BSQR	BSQUARE Corporation",
"BSRR	Sierra Bancorp",
"BSTC	BioSpecifics Technologies Corp",
"BSX	Boston Scientific Corporation",
"BT	BT Group plc",
"BTA	BlackRock Long-Term Municipal Advantage Trust",
"BTE	Baytex Energy Corp",
"BTF	Boulder Total Return Fund, Inc.",
"BTFG	BancTrust Financial Group, Inc.",
"BTH	Blyth, Inc.",
"BTM	Oi S.A.",
"BTM/C	Oi S.A.",
"BTO	John Hancock Bank and Thrift Fund",
"BTU	Peabody Energy Corporation",
"BTUI	BTU International, Inc.",
"BTZ	Blackrock Preferred",
"BUD	Anheuser-Busch Inbev SA",
"BUI	BlackRock Utility and Infrastructure Trust",
"BUR	Burcon Nutrascience Corp",
"BUSE	First Busey Corporation",
"BV	Bazaarvoice, Inc.",
"BVN	Compania Mina Buenaventura, S.A.",
"BVSN	BroadVision, Inc.",
"BWA	BorgWarner Inc.",
"BWC	Babcock & Wilcox Company (The)",
"BWEN	Broadwind Energy, Inc.",
"BWF	Wells Fargo & Company",
"BWINA	Baldwin & Lyons, Inc.",
"BWINB	Baldwin & Lyons, Inc.",
"BWLD	Buffalo Wild Wings, Inc.",
"BWOW	Wowjoint Holdings Limited",
"BWOWU	Wowjoint Holdings Limited",
"BWOWW	Wowjoint Holdings Limited",
"BWP	Boardwalk Pipeline Partners L.P.",
"BWS	Brown Shoe Company, Inc.",
"BX	The Blackstone Group L.P.",
"BXC	BlueLinx Holdings Inc.",
"BXG	Bluegreen Corporation",
"BXP	Boston Properties, Inc.",
"BXS	BancorpSouth, Inc.",
"BYD	Boyd Gaming Corporation",
"BYFC	Broadway Financial Corporation",
"BYI	Bally Technologies, Inc.",
"BYM	Blackrock Municipal Income Quality Trust",
"BZ	Boise Inc",
"BZH	Beazer Homes USA, Inc.",
"BZMD	Beazer Homes USA, Inc.",
"BZU	Beazer Homes USA, Inc.",
"C	Citigroup Inc.",
"C/WS/A	Citigroup Inc.",
"C/WS/B	Citigroup Inc.",
"CA	CA Inc.",
"CAAS	China Automotive Systems, Inc.",
"CAB	Cabela's Inc",
"CAC	Camden National Corporation",
"CACB	Cascade Bancorp",
"CACC	Credit Acceptance Corporation",
"CACH	Cache, Inc.",
"CACI	CACI International, Inc.",
"CADC	China Advanced Construction Materials Group, Inc.",
"CADX	Cadence Pharmaceuticals, Inc.",
"CAE	CAE Inc",
"CAF	Morgan Stanley China A Share Fund Inc.",
"CAFI	Camco Financial Corporation",
"CAG	ConAgra Foods, Inc.",
"CAH	Cardinal Health, Inc.",
"CAJ	Canon, Inc.",
"CAKE	The Cheesecake Factory Incorporated",
"CALD	Callidus Software, Inc.",
"CALI	China Auto Logistics Inc.",
"CALL	magicJack VocalTec Ltd",
"CALM	Cal-Maine Foods, Inc.",
"CALX	Calix, Inc",
"CAM	Cameron International Corporation",
"CAMP	CalAmp Corp.",
"CAMT	Camtek Ltd.",
"CAP	Cai International, Inc.",
"CAR	Avis Budget Group, Inc.",
"CARB	Carbonite, Inc.",
"CART	Carolina Trust Bank",
"CARV	Carver Bancorp, Inc.",
"CARZ	First Trust Exchange-Traded Fund II First Trust NASDAQ Global Auto Index Fund",
"CAS	Castle (A.M.) & Co.",
"CASC	Cascade Corporation",
"CASH	Meta Financial Group, Inc.",
"CASM	CAS Medical Systems, Inc.",
"CASS	Cass Information Systems, Inc",
"CAST	ChinaCast Education Corporation",
"CASY	Caseys General Stores, Inc.",
"CAT	Caterpillar, Inc.",
"CATM	Cardtronics, Inc.",
"CATO	Cato Corporation (The)",
"CATY	Cathay General Bancorp",
"CAVM	Cavium, Inc.",
"CAZA	Cazador Acquisition Corporation Ltd.",
"CAZAU	Cazador Acquisition Corporation Ltd.",
"CAZAW	Cazador Acquisition Corporation Ltd.",
"CB	Chubb Corporation (The)",
"CBAK	China BAK Battery, Inc.",
"CBAN	Colony Bankcorp, Inc.",
"CBB	Cincinnati Bell Inc",
"CBD	Companhia Brasileira de Distribuicao",
"CBE	Cooper Industries, plc.",
"CBEY	Cbeyond, Inc.",
"CBG	CBRE Group, Inc.",
"CBI	Chicago Bridge & Iron Company N.V.",
"CBIN	Community Bank Shares of Indiana, Inc.",
"CBK	Christopher & Banks Corporation",
"CBKN	Capital Bank Corporation",
"CBL	CBL & Associates Properties, Inc.",
"CBLI	Cleveland BioLabs, Inc.",
"CBM	Cambrex Corporation",
"CBMX	CombiMatrix Corporation",
"CBMXW	CombiMatrix Corporation",
"CBNJ	Cape Bancorp, Inc.",
"CBNK	Chicopee Bancorp, Inc.",
"CBO	CBO (Listing Market - NYSE - Networks A/E)",
"CBOE	CBOE Holdings, Inc.",
"CBOU	Caribou Coffee Company, Inc.",
"CBPO	China Biologic Products, Inc.",
"CBR	Ciber, Inc.",
"CBRL	Cracker Barrel Old Country Store, Inc.",
"CBRX	Columbia Laboratories, Inc.",
"CBS	CBS Corporation",
"CBS/A	CBS Corporation",
"CBSH	Commerce Bancshares, Inc.",
"CBST	Cubist Pharmaceuticals, Inc.",
"CBT	Cabot Corporation",
"CBU	Community Bank System, Inc.",
"CBX	CBX (Listing Market NYSE Networks AE",
"CBZ	CBIZ, Inc.",
"CCBG	Capital City Bank Group",
"CCC	Calgon Carbon Corporation",
"CCCL	China Ceramics Co., Ltd.",
"CCCLU	China Ceramics Co., Ltd.",
"CCCLW	China Ceramics Co., Ltd.",
"CCE	Coca-Cola Enterprises, Inc.",
"CCG	Campus Crest Communities, Inc.",
"CCH	COCA COLA HELLENIC BOTTLING CO",
"CCI	Crown Castle International Corporation",
"CCIH	ChinaCache International Holdings Ltd.",
"CCIX	Coleman Cable, Inc.",
"CCJ	Cameco Corporation",
"CCK	Crown Cork & Seal Company, Inc.",
"CCL	Carnival Corporation",
"CCM	Concord Medical Services Holdings Limited",
"CCMP	Cabot Microelectronics Corporation",
"CCNE	CNB Financial Corporation",
"CCO	Clear Channel Outdoor Holdings, Inc.",
"CCOI	Cogent Communications Group, Inc.",
"CCRN	Cross Country Healthcare, Inc.",
"CCRT	CompuCredit Holdings Corporation",
"CCS	Comcast Corporation",
"CCSC	Country Style Cooking",
"CCU	Compania Cervecerias Unidas, S.A.",
"CCUR	Concurrent Computer Corporation",
"CCW	Comcast Corporation",
"CCXI	ChemoCentryx, Inc.",
"CCZ	Comcast Corporation",
"CDE	Coeur d'Alene Mines Corporation",
"CDI	CDI Corporation",
"CDII	CD International Enterprises, Inc.",
"CDNS	Cadence Design Systems, Inc.",
"CDR	Cedar Realty Trust, Inc.",
"CDTI	Clean Diesel Technologies, Inc.",
"CDXS	Codexis, Inc.",
"CDZI	Cadiz, Inc.",
"CE	Celanese Corporation",
"CEA	China Eastern Airlines Corporation Ltd.",
"CEBK	Central Bancorp, Inc",
"CEC	CEC Entertainment, Inc.",
"CECE	CECO Environmental Corp.",
"CECO	Career Education Corporation",
"CEDC	Central European Distribution Corporation",
"CEDU	ChinaEdu Corporation",
"CEE	Central Europe and Russia Fund, Inc. (The)",
"CEG	Constellation Energy Group, Inc.",
"CEL	Cellcom Israel, Ltd.",
"CELG	Celgene Corporation",
"CELL	Brightpoint, Inc.",
"CEM	ClearBridge Energy MLP Fund Inc.",
"CEMP	Cempra, Inc.",
"CENT	Central Garden & Pet Company",
"CENTA	Central Garden & Pet Company",
"CENX	Century Aluminum Company",
"CEO	CNOOC Limited",
"CERE	Ceres, Inc.",
"CERN	Cerner Corporation",
"CERP	Cereplast, Inc.",
"CERS	Cerus Corporation",
"CETV	Central European Media Enterprises Ltd.",
"CEVA	CEVA, Inc.",
"CF	CF Industries Holdings, Inc.",
"CFBK	Central Federal Corporation",
"CFFC	Community Financial Corp.",
"CFFI	C&F Financial Corporation",
"CFFN	Capitol Federal Financial",
"CFI	Culp, Inc.",
"CFK	CE Franklin Ltd.",
"CFN	CareFusion Corporation",
"CFNB	California First National Bancorp",
"CFNL	Cardinal Financial Corporation",
"CFR	Cullen/Frost Bankers, Inc.",
"CFX	Colfax Corporation",
"CGA	China Green Agriculture, Inc.",
"CGEI	China Growth Equity Investment Ltd.",
"CGEIU	China Growth Equity Investment Ltd.",
"CGEIW	China Growth Equity Investment Ltd.",
"CGEN	Compugen Ltd.",
"CGI	Celadon Group, Inc.",
"CGNX	Cognex Corporation",
"CGO	Calamos Global Total Return Fund",
"CGV	Compagnie Generale de Geophysique-Veritas",
"CGX	Consolidated Graphics, Inc.",
"CHA	China Telecom Corp Ltd",
"CHC	China Hydroelectric Corporation",
"CHC/WS	China Hydroelectric Corporation",
"CHCI	Comstock Homebuilding Companies, Inc.",
"CHCO	City Holding Company",
"CHD	Church & Dwight Company, Inc.",
"CHDN	Churchill Downs, Incorporated",
"CHDX	Chindex International, Inc.",
"CHE	Chemed Corp.",
"CHEF	The Chefs' Warehouse, Inc.",
"CHEV	Cheviot Financial Corp",
"CHFC	Chemical Financial Corporation",
"CHFN	Charter Financial Corp.",
"CHG	CH Energy Group, Inc.",
"CHH	Choice Hotels International, Inc.",
"CHI	Calamos Convertible Opportunities and Income Fund",
"CHK	Chesapeake Energy Corporation",
"CHKE	Cherokee Inc.",
"CHKM	Chesapeake Midstream Partmers, L.P.",
"CHKP	Check Point Software Technologies Ltd.",
"CHKR	Chesapeake Granite Wash Trust",
"CHL	China Mobile (Hong Kong) Ltd.",
"CHLN	China Housing & Land Development, Inc.",
"CHMP	Champion Industries, Inc.",
"CHMT	Chemtura Corp.",
"CHN	China Fund, Inc. (The)",
"CHNR	China Natural Resources, Inc.",
"CHOP	China Gerui Advanced Materials Group Limited",
"CHRM	Charm Communications Inc.",
"CHRS	Charming Shoppes, Inc.",
"CHRW	C.H. Robinson Worldwide, Inc.",
"CHS	Chico's FAS, Inc.",
"CHSCP	CHS Inc",
"CHSI	Catalyst Health Solutions, Inc",
"CHSP	Chesapeake Lodging Trust",
"CHT	Chunghwa Telecom Co Ltd",
"CHTP	Chelsea Therapeutics International, Ltd.",
"CHTR	Charter Communications, Inc.",
"CHU	China Unicom (Hong Kong) Ltd",
"CHUX	O'Charley's Inc.",
"CHW	Calamos Global Dynamic Income Fund",
"CHY	Calamos Convertible and High Income Fund",
"CHYR	Chyron Corporation",
"CI	Cigna Corporation",
"CIA	Citizens, Inc.",
"CIB	BanColombia S.A.",
"CIDM	Cinedigm Digital Cinema Corp",
"CIE	Cobalt International Energy, Inc.",
"CIEN	CIENA Corporation",
"CIF	Colonial Intermediate High Income Fund",
"CIG	Comp En De Mn Cemig ADS",
"CIG/C	Comp En De Mn Cemig ADS",
"CIGX	Star Scientific, Inc.",
"CII	Blackrock Capital and Income Strategies Fund Inc",
"CIM	Chimera Investment Corporation",
"CIMT	Cimatron, Limited",
"CINF	Cincinnati Financial Corporation",
"CIR	CIRCOR International, Inc.",
"CIS	Camelot Information Systems",
"CISG	CNinsure Inc.",
"CIT	CIT Group Inc (DEL)",
"CITZ	CFS Bancorp, Inc.",
"CIZN	Citizens Holding Company",
"CJES	C&J Energy Services, Inc.",
"CJJD	China Jo-Jo Drugstores, Inc.",
"CJS	Vale Cap Ltd",
"CJT	Vale Cap Ltd",
"CKEC	Carmike Cinemas, Inc.",
"CKH	SEACOR Holdings, Inc.",
"CKP	Checkpoint Systms, Inc.",
"CKSW	ClickSoftware Technologies Ltd.",
"CL	Colgate-Palmolive Company",
"CLB	Core Laboratories N.V.",
"CLBH	Carolina Bank Holdings Inc.",
"CLC	CLARCOR Inc.",
"CLCT	Collectors Universe, Inc.",
"CLD	Cloud Peak Energy Inc",
"CLDT	Chatham Lodging Trust (REIT)",
"CLDX	Celldex Therapeutics, Inc",
"CLF	Cliffs Natural Resources Inc.",
"CLFD	Clearfield, Inc.",
"CLGX	CoreLogic, Inc.",
"CLH	Clean Harbors, Inc.",
"CLI	Mack-Cali Realty Corporation",
"CLMS	Calamos Asset Management, Inc.",
"CLMT	Calumet Specialty Products Partners, L.P.",
"CLNE	Clean Energy Fuels Corp.",
"CLNT	Cleantech Solutions International, Inc.",
"CLNY	Colony Financial, Inc",
"CLP	Colonial Properties Trust",
"CLR	Continental Resources, Inc.",
"CLRO	ClearOne Communications Inc.",
"CLS	Celestica, Inc.",
"CLSN	Celsion Corporation",
"CLUB	Town Sports International Holdings, Inc.",
"CLVS	Clovis Oncology, Inc.",
"CLW	Clearwater Paper Corporation",
"CLWR	Clearwire Corporation",
"CLWT	Euro Tech Holdings Company Limited",
"CLX	Clorox Company (The)",
"CM	Canadian Imperial Bank of Commerce",
"CMA	Comerica Incorporated",
"CMA/WS	Comerica Incorporated",
"CMC	Commercial Metals Company",
"CMCO	Columbus McKinnon Corporation",
"CMCSA	Comcast Corporation",
"CMCSK	Comcast Corporation",
"CME	CME Group Inc.",
"CMFB	COMMERCEFIRST BANCORP INC",
"CMG	Chipotle Mexican Grill, Inc.",
"CMI	Cummins Inc.",
"CMK	Colonial Intermarket Income Trust I",
"CMLP	Crestwood Midstream Partners LP",
"CMLS	Cumulus Media Inc.",
"CMM	China Mass Media Corp",
"CMN	Cantel Medical Corp.",
"CMO	Capstead Mortgage Corporation",
"CMP	Compass Minerals Intl Inc",
"CMRE	Costamare Inc.",
"CMRG	Casual Male Retail Group, Inc.",
"CMS	CMS Energy Corporation",
"CMSB	CMS Bancorp, Inc.",
"CMTL	Comtech Telecommunications Corp.",
"CMU	Colonial Municipal Income Trust",
"CMVT	Comverse Technology, Inc.",
"CNA	CNA Financial Corporation",
"CNAF	Commercial National Financial Corporation",
"CNBC	Center Bancorp, Inc.",
"CNBKA	Century Bancorp, Inc.",
"CNC	Centene Corporation",
"CNDO	Coronado Biosciences, Inc.",
"CNET	ChinaNet Online Holdings, Inc.",
"CNH	CNH Global N.V.",
"CNI	Canadian National Railway Company",
"CNIT	China Information Technology, Inc.",
"CNK	Cinemark Holdings Inc",
"CNL	Cleco Corporation",
"CNMD	CONMED Corporation",
"CNO	CNO Financial Group, Inc.",
"CNP	CenterPoint Energy, Inc (Holding Co)",
"CNQ	Canadian Natural Resources Limited",
"CNQR	Concur Technologies, Inc.",
"CNS	Cohn & Steers Inc",
"CNSL	Consolidated Communications Holdings, Inc.",
"CNTF	China TechFaith Wireless Communication Technology Limited",
"CNTY	Century Casinos, Inc.",
"CNVO	Convio, Inc.",
"CNW	CNF, Inc.",
"CNX	CONSOL Energy Inc.",
"CNYD	China Yida Holding, Co.",
"CO	China Cord Blood Corporation.",
"COBK	Colonial Financial Services, Inc.",
"COBR	Cobra Electronics Corporation",
"COBZ	CoBiz Financial Inc.",
"COCO	Corinthian Colleges, Inc.",
"CODE	Spansion Inc",
"CODI	Compass Diversified Holdings",
"COF	Capital One Financial Corporation",
"COF/WS	Capital One Financial Corporation",
"COG	Cabot Oil & Gas Corporation",
"COGO	Cogo Group, Inc.",
"COH	Coach, Inc.",
"COHR	Coherent, Inc.",
"COHU	Cohu, Inc.",
"COKE	Coca-Cola Bottling Co. Consolidated",
"COL	Rockwell Collins, Inc.",
"COLB	Columbia Banking System, Inc.",
"COLM	Columbia Sportswear Company",
"COMV	Comverge, Inc.",
"CONN	Conn's, Inc.",
"COO	Cooper Companies, Inc. (The)",
"COOL	Majesco Entertainment Company",
"COP	ConocoPhillips",
"COR	CoreSite Realty Corporation",
"CORE	Core-Mark Holding Company, Inc.",
"CORT	Corcept Therapeutics Incorporated",
"COSI	Cosi, Inc.",
"COST	Costco Wholesale Corporation",
"COT	Cott Corporation",
"COV	Covidien plc.",
"COWN	Cowen Group, Inc.",
"COY	Blackrock Corporate High Yield Fund, Inc.",
"CP	Canadian Pacific Railway Limited",
"CPA	Copa Holdings, S.A.",
"CPAC	Cementos Pacasmayo S.A.A.",
"CPB	Campbell Soup Company",
"CPBC	Community Partners Bancorp",
"CPE	Callon Petroleum Company",
"CPF	CPB Inc.",
"CPGI	China Shengda Packaging Group, Inc.",
"CPHC	Canterbury Park Holding Corporation",
"CPHD	CEPHEID",
"CPIX	Cumberland Pharmaceuticals Inc.",
"CPK	Chesapeake Utilities Corporation",
"CPL	CPFL Energia S.A.",
"CPLA	Capella Education Company",
"CPLP	Capital Product Partners L.P.",
"CPN	Calpine Corporation",
"CPNO	Copano Energy, L.L.C.",
"CPO	Corn Products International, Inc.",
"CPP	Merrill Lynch Depositor, Inc.",
"CPRT	Copart, Inc.",
"CPRX	Catalyst Pharmaceutical Partners, Inc.",
"CPSI	Computer Programs and Systems, Inc.",
"CPSL	China Precision Steel, Inc.",
"CPSS	Consumer Portfolio Services, Inc.",
"CPST	Capstone Turbine Corporation",
"CPT	Camden Property Trust",
"CPTS	Conceptus, Inc.",
"CPV/CL	CBS Corporation",
"CPWM	Cost Plus, Inc.",
"CPWR	Compuware Corporation",
"CQB	Chiquita Brands International, Inc.",
"CR	Crane Company",
"CRAI	CRA International,Inc.",
"CRAY	Cray Inc",
"CRBC	Citizens Republic Bancorp, Inc.",
"CRD/A	Crawford & Company",
"CRD/B	Crawford & Company",
"CRDC	Cardica, Inc.",
"CRDN	Ceradyne, Inc.",
"CRDS	Crossroads Systems, Inc.",
"CRED	Credo Petroleum Corporation",
"CREE	Cree, Inc.",
"CREG	China Recycling Energy Corporation",
"CRESW	Cresud S.A.C.I.F. y A.",
"CRESY	Cresud S.A.C.I.F. y A.",
"CRFN	Crescent Financial Bancshares, Inc.",
"CRH	CRH PLC",
"CRI	Carter's, Inc.",
"CRIC	China Real Estate Information Corporation",
"CRIS	Curis, Inc.",
"CRK	Comstock Resources, Inc.",
"CRL	Charles River Laboratories International, Inc.",
"CRM	Salesforce.com Inc",
"CRMB	Crumbs Bake Shop, Inc.",
"CRMBU	Crumbs Bake Shop, Inc.",
"CRMBW	Crumbs Bake Shop, Inc.",
"CRME	Cardiome Pharma Corporation",
"CRMT	America's Car-Mart, Inc.",
"CRNT	Ceragon Networks Ltd.",
"CROX	Crocs, Inc.",
"CRP	Credit Suisse Guernsey BRH",
"CRR	Carbo Ceramics, Inc.",
"CRRB	Carrollton Bancorp",
"CRRC	Courier Corporation",
"CRS	Carpenter Technology Corporation",
"CRT	Cross Timbers Royalty Trust",
"CRTX	Cornerstone Therapeutics Inc.",
"CRUS	Cirrus Logic, Inc.",
"CRVL	CorVel Corp.",
"CRWN	Crown Media Holdings, Inc.",
"CRWS	Crown Crafts, Inc.",
"CRY	CryoLife, Inc.",
"CRYP	CryptoLogic Limited",
"CRZO	Carrizo Oil & Gas, Inc.",
"CS	Credit Suisse Group",
"CSA	Cogdell Spencer, Inc.",
"CSBC	Citizens South Banking Corporation",
"CSBK	Clifton Savings Bancorp, Inc.",
"CSC	Computer Sciences Corporation",
"CSCD	Cascade Microtech, Inc.",
"CSCO	Cisco Systems, Inc.",
"CSE	CapitalSource Inc",
"CSFL	CenterState Banks, Inc.",
"CSFS	The Cash Store Financial Services Inc.",
"CSGP	CoStar Group, Inc.",
"CSGS	CSG Systems International, Inc.",
"CSH	Cash America International, Inc.",
"CSI	Cutwater Select Income Fund",
"CSII	Cardiovascular Systems, Inc.",
"CSIQ	Canadian Solar Inc.",
"CSL	Carlisle Companies Incorporated",
"CSOD	Cornerstone OnDemand, Inc.",
"CSP	American Strategic Income Portfolio III",
"CSPI	CSP Inc.",
"CSQ	Calamos Strategic Total Return Fund",
"CSRE	CSR plc",
"CSS	CSS Industries, Inc.",
"CSTR	Coinstar, Inc.",
"CSU	Capital Senior Living Corporation",
"CSUN	China Sunergy Co., Ltd.",
"CSV	Carriage Services, Inc.",
"CSWC	Capital Southwest Corporation",
"CSX	CSX Corporation",
"CT	Capital Trust, Inc.",
"CTAS	Cintas Corporation",
"CTB	Cooper Tire & Rubber Company",
"CTBC	The Connecticut Bank and Trust Company",
"CTBI	Community Trust Bancorp, Inc.",
"CTC	IFM Investments Limited",
"CTCH	Commtouch Software Ltd.",
"CTCM	CTC Media, Inc.",
"CTCT	Constant Contact, Inc.",
"CTDC	China Technology Development Group Corporation",
"CTEL	City Telecom (H.K.) Limited",
"CTFO	China TransInfo Technology Corp.",
"CTGX	Computer Task Group, Incorporated",
"CTHR	Charles & Colvard Ltd",
"CTIB	CTI Industries Corporation",
"CTIC	Cell Therapeutics, Inc.",
"CTL	CenturyLink, Inc.",
"CTQ	Qwest Corporation",
"CTRN	Citi Trends, Inc.",
"CTRP	Ctrip.com International, Ltd.",
"CTS	CTS Corporation",
"CTSH	Cognizant Technology Solutions Corporation",
"CTW	Qwest Corporation",
"CTWS	Connecticut Water Service, Inc.",
"CTXS	Citrix Systems, Inc.",
"CU	First Trust Exchange-Traded Fund II First Trust ISE Global Copper Index Fund",
"CUB	Cubic Corporation",
"CUBA	The Herzfeld Caribbean Basin Fund, Inc.",
"CUBE	CubeSmart",
"CUI	CUI Global, Inc.",
"CUK	Carnival Plc ADS",
"CUTR	Cutera, Inc.",
"CUZ	Cousins Properties Incorporated",
"CV	Central Vermont Pub Svc",
"CVA	Covanta Holding Corporation",
"CVB	Lehman ABS Corporation",
"CVBF	CVB Financial Corporation",
"CVBK	Central Virginia Bankshares, Inc.",
"CVC	Cablevision Systems Corporation",
"CVCO	Cavco Industries, Inc.",
"CVCY	Central Valley Community Bancorp",
"CVD	Covance Inc.",
"CVE	Cenovus Energy Inc",
"CVG	Convergys Corporation",
"CVGI	Commercial Vehicle Group, Inc.",
"CVGW	Calavo Growers, Inc.",
"CVH	Coventry Health Care, Inc.",
"CVI	CVR Energy Inc.",
"CVLT	CommVault Systems, Inc.",
"CVLY	Codorus Valley Bancorp, Inc",
"CVO	Cenveo Inc",
"CVS	CVS Corporation",
"CVTI	Covenant Transportation Group, Inc.",
"CVV	CVD Equipment Corporation",
"CVVT	China Valves Technology, Inc.",
"CVX	Chevron Corporation",
"CW	Curtiss-Wright Corporation",
"CWBC	Community West Bancshares",
"CWCO	Consolidated Water Co. Ltd.",
"CWEI	Clayton Williams Energy, Inc.",
"CWH	CommonWealth REIT",
"CWHN	CommonWealth REIT",
"CWST	Casella Waste Systems, Inc.",
"CWT	California Water  Service Group Holding",
"CWTR	Coldwater Creek, Inc.",
"CWZ	Lehman ABS Corporation",
"CX	Cemex S.A.B. de C.V.",
"CXDC	China XD Plastics Company Limited",
"CXE	Colonial High Income Municipal Trust",
"CXH	Colonial Investment Grade Municipal Trust",
"CXO	Concho Resources Inc.",
"CXPO	Crimson Exploration Inc.",
"CXS	Crexus Investment Corp.",
"CXW	Corrections Corporation of America",
"CY	Cypress Semiconductor Corporation",
"CYAN	Cyanotech Corporation",
"CYBE	CyberOptics Corporation",
"CYBI	Cybex International, Inc.",
"CYBX	Cyberonics, Inc.",
"CYCC	Cyclacel Pharmaceuticals, Inc.",
"CYCCP	Cyclacel Pharmaceuticals, Inc.",
"CYD	China Yuchai International Limited",
"CYE	Blackrock Corporate High Yield Fund III, Inc",
"CYH	Community Health Systems, Inc.",
"CYMI	Cymer, Inc.",
"CYN	City National Corporation",
"CYNO	Cynosure, Inc.",
"CYOU	Changyou.com Limited",
"CYS	Cypress Sharpridge Investments Inc",
"CYT	Cytec Industries Inc.",
"CYTK	Cytokinetics, Incorporated",
"CYTR	CytRx Corporation",
"CYTX	Cytori Therapeutics Inc",
"CYTXW	Cytori Therapeutics Inc",
"CZFC	Citizens First Corporation",
"CZNC	Citizens & Northern Corp",
"CZR	Caesars Entertainment Corporation",
"CZWI	Citizens Community Bancorp, Inc.",
"CZZ	Cosan Limited",
"D	Dominion Resources, Inc.",
"DAC	Danaos Corporation",
"DAEG	Daegis Inc",
"DAIO	Data I/O Corporation",
"DAKT	Daktronics, Inc.",
"DAL	Delta Air Lines Inc. (New)",
"DAN	Dana Holding Corporation",
"DANG	E-Commerce China Dangdang Inc.",
"DAR	Darling International Inc.",
"DARA	DARA Biosciences, Inc.",
"DATE	Jiayuan.com International Ltd.",
"DAVE	Famous Dave's of America, Inc.",
"DB	Deutsche Bank AG",
"DBD	Diebold, Incorporated",
"DBL	DoubleLine Opportunistic Credit Fund",
"DBLE	Double Eagle Petroleum Company",
"DBLEP	Double Eagle Petroleum Company",
"DCA	Virtus Total Return Fund",
"DCE	Deutsche Bk Cap Fdg Tr X",
"DCI	Donaldson Company, Inc.",
"DCIX	Diana Containerships Inc.",
"DCM	NTT DOCOMO, Inc",
"DCO	Ducommun Incorporated",
"DCOM	Dime Community Bancshares, Inc.",
"DCT	DCT Industrial Trust Inc",
"DCTH	Delcath Systems, Inc.",
"DD	E.I. du Pont de Nemours and Company",
"DDD	3D Systems Corporation",
"DDE	Dover Downs Gaming & Entertainment Inc",
"DDF	Delaware Investments Dividend & Income Fund, Inc.",
"DDIC	DDi Corp.",
"DDMG	Digital Domain Media Group, Inc.",
"DDR	Developers Diversified Realty Corporation",
"DDS	Dillard's, Inc.",
"DDT	Dillard's, Inc.",
"DE	Deere & Company",
"DECK	Deckers Outdoor Corporation",
"DEER	Deer Consumer Products, Inc.",
"DEG	Etablissements Delhaize Freres et Cie &quot;Le Lion&quot; S.A.",
"DEI	Douglas Emmett, Inc.",
"DEL	Deltic Timber Corporation",
"DELL	Dell Inc.",
"DENN	Denny's Corporation",
"DEO	Diageo plc",
"DEPO	Depomed, Inc.",
"DEST	Destination Maternity Corporation",
"DEX	Delaware Enhanced Global Dividend",
"DEXO	Dex One Corporation",
"DF	Dean Foods Company",
"DFG	Delphi Financial Group, Inc.",
"DFP	Delphi Financial Group, Inc.",
"DFR	CIFC Corp.",
"DFS	Discover Financial Services",
"DFT	Dupont Fabros Technology, Inc.",
"DFZ	R.G. Barry Corporation",
"DG	Dollar General Corporation",
"DGAS	Delta Natural Gas Company, Inc.",
"DGI	DigitalGlobe, Inc",
"DGICA	Donegal Group, Inc.",
"DGICB	Donegal Group, Inc.",
"DGII	Digi International Inc.",
"DGIT	Digital Generation, Inc.",
"DGLY	Digital Ally, Inc.",
"DGX	Quest Diagnostics Incorporated",
"DHF	Dreyfus High Yield Strategies Fund",
"DHFT	Diamond Hill Financial Trends Fund, Inc.",
"DHG	DWS High Income Opportunities Fund, Inc.",
"DHI	D.R. Horton, Inc.",
"DHIL	Diamond Hill Investment Group, Inc.",
"DHR	Danaher Corporation",
"DHRM	Dehaier Medical Systems Limited",
"DHT	DHT Holdings, Inc.",
"DHX	Dice Holdings, Inc.",
"DIAL	Dial Global, Inc.",
"DIN	DineEquity, Inc",
"DIOD	Diodes Incorporated",
"DIS	Walt Disney Company (The)",
"DISCA	Discovery Communications, Inc",
"DISCB	Discovery Communications, Inc",
"DISCK	Discovery Communications, Inc",
"DISH	DISH Network Corporation",
"DITC	Ditech Networks, Inc.",
"DJCO	Daily Journal Corp. (S.C.)",
"DK	Delek US Holdings, Inc.",
"DKP	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"DKQ	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"DKS	Dick's Sporting Goods Inc",
"DKT	Deutsch Bk Contingent Cap Tr V",
"DL	China Distance Education Holdings Limited",
"DLB	Dolby Laboratories",
"DLGC	Dialogic, Inc.",
"DLIA	dELIA*s Inc.",
"DLLR	DFC Global Corp",
"DLPH	Delphi Automotive plc",
"DLR	Digital Realty Trust, Inc.",
"DLTR	Dollar Tree, Inc.",
"DLX	Deluxe Corporation",
"DM	Dolan Company (The)",
"DMD	Demand Media Inc.",
"DMED	D. Medical Industries Ltd.",
"DMLP	Dorchester Minerals, L.P.",
"DMND	Diamond Foods, Inc.",
"DMO	Western Asset Mortgage Defined Opportunity Fund Inc",
"DMRC	Digimarc Corporation",
"DNB	Dun & Bradstreet Corporation (The)",
"DNBF	DNB Financial Corp",
"DNDN	Dendreon Corporation",
"DNI	Dividend and Income Fund, Inc.",
"DNKN	Dunkin' Brands Group, Inc.",
"DNP	Duff & Phelps Utilities Income, Inc.",
"DNR	Denbury Resources, Inc. (Holding Company)",
"DNY	The Denali Fund",
"DO	Diamond Offshore Drilling, Inc.",
"DOLE	Dole Food Company, Inc",
"DOM	Dominion Resources Black Warrior Trust",
"DORM	Dorman Products, Inc.",
"DOV	Dover Corporation",
"DOVR	Dover Saddlery, Inc.",
"DOW	Dow Chemical Company (The)",
"DOX	Amdocs Limited",
"DPD	Dow 30 Premium",
"DPG	Duff & Phelps Global Utility Income Fund Inc.",
"DPM	DCP Midstream Partners, LP",
"DPO	Dow 30 Premium",
"DPS	Dr Pepper Snapple Group, Inc",
"DPZ	Domino's Pizza Inc",
"DQ	DAQQ New Energy Corp.",
"DRAD	Digirad Corporation",
"DRAM	Dataram Corporation",
"DRC	Dresser-Rand Group Inc.",
"DRCO	Dynamics Research Corporation",
"DRD	DRDGOLD Limited",
"DRE	Duke Realty Corporation",
"DRH	Diamondrock Hospitality Company",
"DRI	Darden Restaurants, Inc.",
"DRIV	Digital River, Inc.",
"DRL	Doral Financial Corporation",
"DRQ	Dril-Quip, Inc.",
"DRRX	Durect Corporation",
"DRU	Dominion Resources, Inc.",
"DRWI	DragonWave Inc",
"DRYS	DryShips Inc.",
"DSCI	Derma Sciences, Inc.",
"DSCO	Discovery Laboratories, Inc.",
"DSGX	The Descartes Systems Group Inc.",
"DSM	Dreyfus Strategic Municipal Bond Fund, Inc.",
"DSPG	DSP Group, Inc.",
"DST	DST Systems, Inc.",
"DSTI	DayStar Technologies, Inc.",
"DSU	Blackrock Debt Strategies Fund, Inc.",
"DSW	DSW Inc.",
"DSWL	Deswell Industries, Inc.",
"DSX	Diana Shipping inc.",
"DTE	DTE Energy Company",
"DTF	Duff & Phelps Utilities Tax-Free Income, Inc.",
"DTG	Dollar Thrifty Automotive Group, Inc.",
"DTK	Deutsche Bank AG",
"DTLK	Datalink Corporation",
"DTSI	DTS, Inc.",
"DTT	Deutsche Bank AG",
"DTV	DIRECTV",
"DTZ	DTE Energy Company",
"DUA	Deutsche Bank AG",
"DUC	Duff & Phelps Utility & Corporate Bond Trust, Inc.",
"DUCK	Duckwall-Alco Stores, Inc.",
"DUF	Duff & Phelps Corporation",
"DUK	Duke Energy Corporation",
"DUSA	DUSA Pharmaceuticals, Inc.",
"DV	DeVry Inc.",
"DVA	DaVita Inc.",
"DVAX	Dynavax Technologies Corporation",
"DVD	Dover Downs Entertainment, Inc.",
"DVF	Blackrock Diversified Income Strategies Fund, Inc.",
"DVM	Cohen & Steers Dividend Majors Fund",
"DVN	Devon Energy Corporation",
"DVOX	DynaVox Inc.",
"DVR	Cal Dive International, Inc.",
"DW	Drew Industries Incorporated",
"DWA	Dreamworks Animation SKG, Inc.",
"DWCH	Datawatch Corporation",
"DWSN	Dawson Geophysical Company",
"DX	Dynex Capital, Inc.",
"DXB	Deutsche Bank AG",
"DXCM	DexCom, Inc.",
"DXPE	DXP Enterprises, Inc.",
"DXYN	The Dixie Group, Inc.",
"DY	Dycom Industries, Inc.",
"DYAX	Dyax Corp.",
"DYII	Dynacq Healthcare, Inc.",
"DYN	Dynegy Inc.",
"DYNT	Dynatronics Corporation",
"DYSL	Dynasil Corporation of America",
"E	ENI S.p.A.",
"EA	Electronic Arts Inc.",
"EAA	Entergy Arkansas, Inc.",
"EAGL	Global Eagle Acquisition Corp.",
"EAGLU	Global Eagle Acquisition Corp.",
"EAGLW	Global Eagle Acquisition Corp.",
"EAT	Brinker International, Inc.",
"EBAY	eBay Inc.",
"EBF	Ennis, Inc.",
"EBIX	Ebix Inc",
"EBMT	Eagle Bancorp Montana, Inc.",
"EBR	Centrais Elc Braz Pfb B Elbras",
"EBR/B	Centrais Elc Braz Pfb B Elbras",
"EBS	Emergent Biosolutions, Inc.",
"EBSB	Meridian Interstate Bancorp, Inc.",
"EBTC	Enterprise Bancorp Inc",
"EBTX	Encore Bancshares, Inc.",
"EC	Ecopetrol S.A.",
"ECA	Encana Corporation",
"ECHO	Echo Global Logistics, Inc.",
"ECL	Ecolab Inc.",
"ECOL	US Ecology, Inc.",
"ECPG	Encore Capital Group Inc",
"ECT	ECA Marcellus Trust I",
"ECTE	Echo Therapeutics, Inc.",
"ECTY	Ecotality, Inc.",
"ECYT	Endocyte, Inc.",
"ED	Consolidated Edison Company of New York, Inc.",
"EDAC	Edac Technologies Corporation",
"EDAP	EDAP TMS S.A.",
"EDD	Morgan Stanley Emerging Markets Domestic Debt Fund, Inc.",
"EDE	Empire District Electric Company (The)",
"EDF	Stone Harbor Emerging Markets Income Fund",
"EDGR	EDGAR Online, Inc.",
"EDGW	Edgewater Technology, Inc.",
"EDMC	Education Management Corporation",
"EDN	Empresa Distribuidora Y Comercializadora Norte S.A. (Edenor)",
"EDR	Education Realty Trust Inc.",
"EDS	Exceed Company Ltd.",
"EDT	Entergy Texas Inc",
"EDU	New Oriental Education & Technology Group, Inc.",
"EDUC	Educational Development Corporation",
"EE	El Paso Electric Company",
"EEA	European Equity Fund, Inc. (The)",
"EEFT	Euronet Worldwide, Inc.",
"EEI	Ecology and Environment, Inc.",
"EEMA	iShares, Inc. iShares MSCI Emerging Markets Asia Index Fund",
"EEME	iShares, Inc. iShares MSCI Emerging Markets EMEA Index Fund",
"EEML	iShares Trust iShares MSCI Emerging Markets Latin America Index Fund",
"EEP	Enbridge Energy, L.P.",
"EEQ	Enbridge Energy Management LLC",
"EF	Edelman Financial Group Inc. (The)",
"EFC	Ellington Financial LLC",
"EFII	Electronics for Imaging, Inc.",
"EFM	Entergy Mississippi, Inc.",
"EFR	Eaton Vance Senior Floating-Rate Fund",
"EFSC	Enterprise Financial Services Corporation",
"EFT	Eaton Vance Floating Rate Income Trust",
"EFUT	eFuture Information Technology Inc.",
"EFX	Equifax, Inc.",
"EGAN	eGain Communications Corporation",
"EGBN	Eagle Bancorp, Inc.",
"EGF	Blackrock Enhanced Government Fund, Inc",
"EGHT	8x8 Inc",
"EGLE	Eagle Bulk Shipping Inc.",
"EGN	Energen Corporation",
"EGO	Eldorado Gold Corp",
"EGOV	NIC Inc.",
"EGP	EastGroup Properties, Inc.",
"EGRW	iShares, Inc. iShares MSCI Emerging Markets Growth Index Fund",
"EGY	Vaalco Energy Inc",
"EHI	Western Asset Global High Income Fund Inc",
"EHTH	eHealth, Inc.",
"EIG	Employers Holdings Inc",
"EIHI	Eastern Insurance Holdings, Inc.",
"EIX	Edison International",
"EJ	E-House (China) Holdings Limited",
"EL	Estee Lauder Companies, Inc. (The)",
"ELA	Entergy Louisiana, Inc.",
"ELB	Entergy Louisiana, Inc.",
"ELGX	Endologix  Inc",
"ELN	Elan Corporation, plc",
"ELNK	EarthLink, Inc.",
"ELON	Echelon Corporation",
"ELOS	Syneron Medical Ltd.",
"ELP	Companhia Paranaense de Energia (COPEL)",
"ELRC	Electro Rent Corporation",
"ELS	Equity Lifestyle Properties, Inc.",
"ELSE	Electro-Sensors, Inc.",
"ELT	Elster Group SE",
"ELTK	Eltek Ltd.",
"ELX	Emulex Corporation",
"ELY	Callaway Golf Company",
"EMC	EMC Corporation",
"EMCB	WisdomTree Trust WisdomTree Emerging Markets Corporate Bond Fund",
"EMCF	Emclaire Financial Corp",
"EMCI	EMC Insurance Group, Inc.",
"EMD	Western Asset Emerging Markets Income Fund, Inc",
"EMDI	iShares, Inc. iShares MSCI Emerging Markets Consumer Discrectionary Sector Index Fund",
"EME	EMCOR Group, Inc.",
"EMEY	iShares, Inc. iShares MSCI Emerging Markets Energy Sector Capped Index Fund",
"EMF	Templeton Emerging Markets Fund",
"EMFN	iShares MSCI Emerging Markets Financials Sector Index Fund",
"EMIF	iShares S&P Emerging Markets Infrastructure Index Fund",
"EMITF	Elbit Imaging Ltd.",
"EMKR	EMCORE Corporation",
"EML	Eastern Company (The)",
"EMMS	Emmis Communications Corporation",
"EMMSP	Emmis Communications Corporation",
"EMMT	iShares MSCI Emerging Markets Materials Sector Index Fund",
"EMN	Eastman Chemical Company",
"EMO	ClearBridge Energy MLP Opportunity Fund Inc.",
"EMQ	Entergy Mississippi, Inc.",
"EMR	Emerson Electric Company",
"EMZ	Entergy Mississippi, Inc.",
"ENB	Enbridge Inc",
"END	Endeavor International Corporation",
"ENDP	Endo Pharmaceuticals Holdings Inc.",
"ENG	ENGlobal Corporation",
"ENH	Endurance Specialty Holdings Ltd",
"ENI	Enersis S A",
"ENL	Reed Elsevier NV",
"ENMD	EntreMed, Inc.",
"ENOC	EnerNOC, Inc.",
"ENR	Energizer Holdings, Inc.",
"ENS	Enersys",
"ENSG	The Ensign Group, Inc.",
"ENTG	Entegris, Inc.",
"ENTR	Entropic Communications, Inc.",
"ENV	Envestnet, Inc",
"ENZ	Enzo Biochem, Inc.",
"ENZN	Enzon Pharmaceuticals, Inc.",
"EOC	Empresa Nacional de Electricidad S.A.",
"EOD	Wells Fargo Advantage Global Dividend Opportunity Fund",
"EOG	EOG Resources, Inc.",
"EOI	Eaton Vance Enhance Equity Income Fund",
"EONC	eOn Communications Corporation",
"EOS	Eaton Vance Enhanced Equity Income Fund II",
"EOSPN	EOS Preferred Corporation",
"EOT	Eaton Vance Municipal Income Trust",
"EP	El Paso Corporation",
"EPAM	EPAM Systems, Inc.",
"EPAX	Ambassadors Group, Inc.",
"EPAY	Bottomline Technologies, Inc.",
"EPB	El Paso Pipeline Partners LP",
"EPD	Enterprise Products Partners L.P.",
"EPHC	Epoch Holding Corporation",
"EPIQ	EPIQ Systems, Inc.",
"EPL	Energy Partners, Ltd.",
"EPOC	Epocrates, Inc.",
"EPR	Entertainment Properties Trust",
"EQIX	Equinix, Inc.",
"EQR	Equity Residential",
"EQS	Equus Total Return, Inc.",
"EQT	EQT Corporation",
"EQU	Equal Energy Ltd.",
"EQY	Equity One, Inc.",
"ERF	Enerplus Corporation",
"ERIC	Ericsson",
"ERIE	Erie Indemnity Company",
"ERII	Energy Recovery, Inc.",
"ERJ	Embraer-Empresa Brasileira de Aeronautica",
"EROC	Eagle Rock Energy Partners, L.P.",
"EROCW	Eagle Rock Energy Partners, L.P.",
"ERT	eResearch Technology Inc.",
"ES	EnergySolutions Inc",
"ESBF	ESB Financial Corporation",
"ESBK	The Elmira Savings Bank, FSB",
"ESC	Emeritus Corporation",
"ESCA	Escalade, Incorporated",
"ESD	Western Asset Emerging Markets Debt Fund Inc",
"ESE	ESCO Technologies Inc.",
"ESEA	Euroseas Ltd.",
"ESGR	Enstar Group Limited",
"ESI	ITT Educational Services, Inc.",
"ESIC	EasyLink Services International Corporation",
"ESIO	Electro Scientific Industries, Inc.",
"ESL	Esterline Technologies Corporation",
"ESLT	Elbit Systems Ltd.",
"ESMC	Escalon Medical Corp.",
"ESRX	Express Scripts, Inc.",
"ESS	Essex Property Trust, Inc.",
"ESSA	ESSA Bancorp, Inc.",
"ESSX	Essex Rental Corporation",
"ESV	ENSCO plc",
"ESYS	Elecsys Corporation",
"ETB	Eaton Vance Tax-Managed Buy-Write Income Fund",
"ETE	Energy Transfer Equity, L.P.",
"ETFC	E*TRADE Financial Corporation",
"ETG	Eaton Vance Tax-Advantaged Global Dividend Income Fund",
"ETH	Ethan Allen Interiors Inc.",
"ETJ	Eaton Vance Risk-Managed Diversified Equity Income Fund",
"ETM	Entercom Communications Corporation",
"ETN	Eaton Corporation",
"ETO	Eaton Vance Tax-Advantage Global Dividend Opp",
"ETP	ENERGY TRANSFER PARTNERS",
"ETR	Entergy Corporation",
"ETRM	EnteroMedics Inc.",
"ETV	Eaton Vance Corporation",
"ETW	Eaton Vance Corporation",
"ETY	Eaton Vance Tax-Managed Diversified Equity Income Fund",
"EUFN	iShares MSCI Europe Financials Sector Index Fund",
"EV	Eaton Vance Corporation",
"EVAL	iShares, Inc. iShares MSCI Emerging Markets Value Index Fund",
"EVBS	Eastern Virginia Bankshares, Inc.",
"EVC	Entravision Communications Corporation",
"EVEP	EV Energy Partners, L.P.",
"EVF	Eaton Vance Senior Income Trust",
"EVG	Eaton Vance Short Diversified Income Fund",
"EVN	Eaton Vance Municipal Income Trust",
"EVOL	Evolving Systems, Inc.",
"EVR	Evercore Partners Inc",
"EVT	Eaton Vance Tax Advantaged Dividend Income Fund",
"EW	Edwards Lifesciences Corporation",
"EWBC	East West Bancorp, Inc.",
"EXAC	Exactech, Inc.",
"EXAM	ExamWorks Group, Inc.",
"EXAR	Exar Corporation",
"EXAS	EXACT Sciences Corporation",
"EXBD	The Corporate Executive Board Company",
"EXC	Exelon Corporation",
"EXD	Eaton Vance Tax-Advantaged Bond",
"EXEL	Exelixis, Inc.",
"EXFO	EXFO Inc",
"EXG	Eaton Vance Tax-Managed Global Diversified Equity Income Fund",
"EXH	Exterran Holdings, Inc.",
"EXK	Endeavour Silver Corporation",
"EXL	Excel Trust, Inc.",
"EXLP	Exterran Partners, L.P.",
"EXLS	ExlService Holdings, Inc.",
"EXM	Excel Maritime Carriers Ltd.",
"EXP	Eagle Materials Inc",
"EXPD	Expeditors International of Washington, Inc.",
"EXPE	Expedia, Inc.",
"EXPO	Exponent, Inc.",
"EXPR	Express, Inc.",
"EXR	Extra Space Storage Inc",
"EXTR	Extreme Networks, Inc.",
"EXXI	Energy XXI (Bermuda) Limited",
"EZCH	EZchip Semiconductor Limited",
"EZPW	EZCORP, Inc.",
"F	Ford Motor Company",
"F/WS	Ford Motor Company",
"FABK	First Advantage Bancorp",
"FAC	Liberte Investors Inc.",
"FACE	Physicians Formula Holdings, Inc.",
"FAF	First American Corporation (The)",
"FALC	FalconStor Software, Inc.",
"FAM	First Trust/Aberdeen Global Opportunity Income Fund",
"FARM	Farmer Brothers Company",
"FARO	FARO Technologies, Inc.",
"FAST	Fastenal Company",
"FAV	First Trust Active Dividend Income Fund",
"FB	Facebook Inc.",
"FBC	Flagstar Bancorp, Inc.",
"FBHS	Beam Inc.",
"FBIZ	First Business Financial Services, Inc.",
"FBMI	Firstbank Corporation",
"FBMS	The First Bancshares, Inc.",
"FBN	Furniture Brands International, Inc.",
"FBNC	First Bancorp",
"FBNK	First Connecticut Bancorp, Inc.",
"FBP	First BanCorp.",
"FBR	Fibria Celulose S.A.",
"FBRC	FBR & Co",
"FBSI	First Bancshares, Inc.",
"FBSS	Fauquier Bankshares, Inc.",
"FC	Franklin Covey Company",
"FCAL	First California Financial Group, Inc.",
"FCAP	First Capital, Inc.",
"FCBC	First Community Bancshares, Inc.",
"FCCO	First Community Corporation",
"FCCY	1st Constitution Bancorp (NJ)",
"FCE/A	Forest City Enterprises Inc",
"FCE/B	Forest City Enterprises Inc",
"FCEL	FuelCell Energy, Inc.",
"FCF	First Commonwealth Financial Corporation",
"FCFC	FirstCity Financial Corporation",
"FCFS	First Cash Financial Services, Inc.",
"FCH	FelCor Lodging Trust Incorporated",
"FCHI	iShares FTSE China (HK Listed) Index Fund",
"FCLF	First Clover Leaf Financial Corp.",
"FCN	FTI Consulting, Inc.",
"FCNCA	First Citizens BancShares, Inc.",
"FCS	Fairchild Semiconductor International, Inc.",
"FCT	First Trust Senior Floating Rate Income Fund II",
"FCTY	1st Century Bancshares, Inc",
"FCVA	First Capital Bancorp, Inc. (VA)",
"FCX	Freeport-McMoran Copper & Gold, Inc.",
"FCY	Forest City Enterprises Inc",
"FCZA	First Citizens Banc Corp.",
"FDEF	First Defiance Financial Corp.",
"FDI	Fort Dearborn Income Securities, Inc.",
"FDML	Federal-Mogul Corporation",
"FDO	Family Dollar Stores, Inc.",
"FDP	Fresh Del Monte Produce, Inc.",
"FDS	FactSet Research Systems Inc.",
"FDUS	Fidus Investment Corporation",
"FDX	FedEx Corporation",
"FE	FirstEnergy Corporation",
"FEFN	iShares MSCI Far East Financials Sector Index Fund",
"FEIC	FEI Company",
"FEIM	Frequency Electronics, Inc.",
"FELE	Franklin Electric Co., Inc.",
"FENG	Phoenix New Media Limited",
"FEO	First Trust/Aberdeen Emerging Opportunity Fund",
"FES	Forbes Energy Services Ltd",
"FF	FutureFuel Corp.",
"FFA	First Trust",
"FFBC	First Financial Bancorp.",
"FFBCW	First Financial Bancorp.",
"FFBH	First Federal Bancshares of Arkansas, Inc.",
"FFC	Flaherty & Crumrine/Claymore Preferred Securities Income Fd In",
"FFCH	First Financial Holdings, Inc.",
"FFCO	FedFirst Financial Corporation",
"FFD	Morgan Stanley Frontier Emerging markets Fund, Inc.",
"FFDF	FFD Financial Corporation",
"FFEX	Frozen Food Express Industries, Inc.",
"FFFD	North Central Bancshares, Inc.",
"FFG	FBL Financial Group, Inc.",
"FFHL	Fuwei Films (Holdings) Co., Ltd.",
"FFIC	Flushing Financial Corporation",
"FFIN	First Financial Bankshares, Inc.",
"FFIV	F5 Networks, Inc.",
"FFKT	Farmers Capital Bank Corporation",
"FFKY	First Financial Service Corporation",
"FFN	FriendFinder Networks Inc.",
"FFNM	First Federal of Northern Michigan Bancorp, Inc.",
"FFNW	First Financial Northwest, Inc.",
"FGB	First Trust Specialty Finance and Financial Opportunities Fund",
"FGC	FPL Group Capital Inc",
"FGE	FPL Group Capital Inc",
"FGP	Ferrellgas Partners, L.P.",
"FHCO	Female Health Company (The)",
"FHN	First Tennessee National Corporation",
"FHY	First Trust Strategic High Income Fund II",
"FIBK	First Interstate BancSystem, Inc.",
"FICO	Fair, Isaac and Company, Incorporated",
"FIF	First Trust Energy Infrastructure Fund",
"FIG	Fortress Investment Group LLC",
"FII	Federated Investors, Inc.",
"FINL	The Finish Line, Inc.",
"FIO	Fusion-io, Inc.",
"FIRE	Sourcefire, Inc.",
"FIS	Fidelity National Information Services, Inc.",
"FISI	Financial Institutions, Inc.",
"FISV	Fiserv, Inc.",
"FITB	Fifth Third Bancorp",
"FITBP	Fifth Third Bancorp",
"FIX	Comfort Systems USA, Inc.",
"FIZZ	National Beverage Corp.",
"FJA	Merrill Lynch Depositor, Inc.",
"FL	Footlocker Inc",
"FLC	Flaherty & Crumrine/Claymore Total Return Fund Inc",
"FLDM	Fluidigm Corporation",
"FLEX	Flextronics International Ltd.",
"FLIC	The First of Long Island Corporation",
"FLIR	FLIR Systems, Inc.",
"FLML	Flamel Technologies S.A.",
"FLO	Flowers Foods, Inc.",
"FLOW	Flow International Corporation",
"FLR	Fluor Corporation",
"FLS	Flowserve Corporation",
"FLT	FleetCor Technologies, Inc.",
"FLWS	1-800 FLOWERS.COM, Inc.",
"FLXS	Flexsteel Industries, Inc.",
"FLY	Fly Leasing Limited",
"FMBI	First Midwest Bancorp, Inc.",
"FMC	FMC Corporation",
"FMCN	Focus Media Holding Limited",
"FMD	First Marblehead Corporation (The)",
"FMER	FirstMerit Corporation",
"FMFC	First M & F Corporation",
"FMN	Federated Premier Municipal Income Fund",
"FMNB	Farmers National Banc Corp.",
"FMO	Fiduciary/Claymore MLP Opportunity Fund",
"FMS	Fresenius Medical Care Corporation",
"FMX	Fomento Economico Mexicano S.A.B. de C.V.",
"FMY	First Trust",
"FN	Fabrinet",
"FNB	F.N.B. Corporation",
"FNBN	FNB United Corp.",
"FNF	Fidelity National Financial, Inc.",
"FNFG	First Niagara Financial Group Inc.",
"FNGN	Financial Engines, Inc.",
"FNLC	First Bancorp, Inc (ME)",
"FNSR	Finisar Corporation",
"FNV	Franco Nev Corp",
"FOE	Ferro Corporation",
"FOF	Cohen & Steers Closed-End Opportunity Fund, Inc.",
"FOLD	Amicus Therapeutics, Inc.",
"FONE	First Trust NASDAQ CEA Smartphone Index Fund",
"FONR	Fonar Corporation",
"FOR	Forestar Group Inc",
"FORD	Forward Industries, Inc.",
"FORM	FormFactor, Inc.",
"FORR	Forrester Research, Inc.",
"FORTY	Formula Systems (1985) Ltd.",
"FOSL	Fossil, Inc.",
"FPO	First Potomac Realty Trust",
"FPT	Federated Premier Intermediate Municipal Income Fund",
"FR	First Industrial Realty Trust, Inc.",
"FRA	Blackrock Floating Rate Income Strategies Fund Inc",
"FRAN	Francesca's Holdings Corporation",
"FRB	Blackrock Floating Rate Income Strategies Fund II Inc",
"FRBK	Republic First Bancorp, Inc.",
"FRC	FIRST REPUBLIC BANK",
"FRCCO	First Republic Preferred Capital Corporation",
"FRED	Fred's, Inc.",
"FREE	FreeSeas Inc.",
"FRF	Fortegra Financial Corporation",
"FRM	Furmanite Corporation",
"FRME	First Merchants Corporation",
"FRNK	Franklin Financial Corporation",
"FRO	Frontline Ltd.",
"FRP	FairPoint Communications, Inc.",
"FRT	Federal Realty Investment Trust",
"FRX	Forest Laboratories, Inc.",
"FSBI	Fidelity Bancorp, Inc.",
"FSBK	First South Bancorp Inc",
"FSC	Fifth Street Finance Corp.",
"FSCI	Fisher Communications, Inc.",
"FSD	First Trust High Income Long Short Fund",
"FSFG	First Savings Financial Group, Inc.",
"FSGI	First Security Group, Inc.",
"FSII	FSI International, Inc.",
"FSIN	Fushi Copperweld, Inc.",
"FSL	Freescale Semiconductor Holdings I, LTD",
"FSLR	First Solar, Inc.",
"FSM	Fortuna Silver Mines Inc.",
"FSR	Flagstone Reinsurance Holdings S.A.",
"FSRV	FirstService Corporation",
"FSS	Federal Signal Corporation",
"FST	Forest Oil Corporation",
"FSTR	L.B. Foster Company",
"FSYS	Fuel Systems Solutions, Inc.",
"FT	Franklin Universal Trust",
"FTE	France Telecom S.A.",
"FTEK	Fuel Tech, Inc.",
"FTI	FMC Technologies, Inc.",
"FTK	Flotek Industries, Inc.",
"FTNT	Fortinet, Inc.",
"FTR	Frontier Communications Company",
"FTT	Federated Enhanced Treasury Income Fund",
"FUBC	1st United Bancorp, Inc. (FL)",
"FUEL	SMF Energy Corporation",
"FUL	H. B. Fuller Company",
"FULL	Full Circle Capital Corporation",
"FULT	Fulton Financial Corporation",
"FUN	Cedar Fair, L.P.",
"FUNC	First United Corporation",
"FUND	Royce Focus Trust, Inc.",
"FUR	Winthrop Realty Trust",
"FURX	Furiex Pharmaceuticals, Inc.",
"FVE	Five Star Quality Care, Inc.",
"FWF	Wells Fargo & Company",
"FWLT	Foster Wheeler AG.",
"FWRD	Forward Air Corporation",
"FX	FX Alliance Inc.",
"FXCB	Fox Chase Bancorp, Inc.",
"FXCM	FXCM Inc.",
"FXEN	FX Energy, Inc.",
"G	Genpact Limited",
"GA	Giant Interactive Group Inc",
"GAB	Gabelli Equity Trust, Inc. (The)",
"GABC	German American Bancorp, Inc.",
"GAGA	Le Gaga Holdings Limited",
"GAI	Global-Tech Advanced Innovations Inc.",
"GAIA	Gaiam, Inc.",
"GAIN	Gladstone Investment Corporation",
"GAINP	Gladstone Investment Corporation",
"GALE	Galena Biopharma, Inc.",
"GAM	General American Investors, Inc.",
"GAME	Shanda Games Limited",
"GAR	Georgia Power Company",
"GAS	AGL Resources, Inc.",
"GASS	StealthGas, Inc.",
"GAT	Georgia Power Company",
"GB	Greatbatch, Inc.",
"GBAB	Guggenheim Build America Bonds Managed Duration Trust",
"GBCI	Glacier Bancorp, Inc.",
"GBDC	Golub Capital BDC, Inc.",
"GBL	Gamco Investors, Inc.",
"GBLI	Global Indemnity plc",
"GBNK	Guaranty Bancorp",
"GBX	Greenbrier Companies, Inc. (The)",
"GCA	Global Cash Access Holdings, Inc.",
"GCAP	GAIN Capital Holdings, Inc.",
"GCBC	Greene County Bancorp, Inc.",
"GCF	Global Income & Currency Fund Inc.",
"GCFB	Granite City Food And Brewery Ltd.",
"GCH	Greater China Fund, Inc.",
"GCI	Gannett Co., Inc.",
"GCO	Genesco Inc.",
"GCOM	Globecomm Systems Inc.",
"GCTS	GCT Semiconductor, Inc.",
"GCV	Gabelli Convertible and Income Securities Fund, Inc. (The)",
"GCVRZ	Sanofi",
"GD	General Dynamics Corporation",
"GDF	Western Asset Global Partners Income Fund, Inc.",
"GDI	Gardner Denver, Inc.",
"GDL	The GDL Fund",
"GDO	Western Asset Global Corporate Defined Opportunity Fund Inc.",
"GDOT	Green Dot Corporation",
"GDP	Goodrich Petroleum Corporation",
"GDV	Gabelli Dividend",
"GE	General Electric Company",
"GEA	General Electric Capital Corporation",
"GEC	General Electric Capital Corporation",
"GED	General Electric Capital Corporation",
"GEF	Greif Bros. Corporation",
"GEF/B	Greif Bros. Corporation",
"GEG	General Electric Capital Corporation",
"GEJ	General Electric Capital Corporation",
"GEL	Genesis Energy, L.P.",
"GEN	GenOn Energy, Inc.",
"GENC	Gencor Industries Inc.",
"GENE	Genetic Technologies Ltd",
"GENT	Gentium SpA",
"GEO	Geo Group Inc (The)",
"GEOI	GeoResources, Inc.",
"GEOY	GeoEye, Inc.",
"GEP	General Electric Capital Corporation",
"GEQ	Guggenheim Equal Weight Enhanced Equity Income Fund",
"GER	General Electric Capital Corporation",
"GERN	Geron Corporation",
"GES	Guess?, Inc.",
"GET	Gaylord Entertainment Company",
"GEVA	Synageva BioPharma Corp.",
"GEVO	Gevo, Inc.",
"GF	New Germany Fund, Inc. (The)",
"GFA	Gafisa SA",
"GFED	Guaranty Federal Bancshares, Inc.",
"GFF	Griffon Corporation",
"GFI	Gold Fields Ltd.",
"GFIG	GFI Group Inc.",
"GFN	General Finance Corporation",
"GFNCL	General Finance Corporation",
"GFNCZ	General Finance Corporation",
"GFW	American Financial Group, Inc.",
"GFY	Western Asset Variable Rate Strategic Fund Inc.",
"GFZ	American Financial Group, Inc.",
"GG	Goldcorp Incorporated",
"GGAL	Grupo Financiero Galicia S.A.",
"GGB	Gerdau S.A.",
"GGC	Georgia Gulf Corporation",
"GGE	Guggenheim Enhanced Equity Strategy Fund",
"GGG	Graco Inc.",
"GGP	General Growth Properties, Inc.",
"GGS	Global Geophysical Services, Inc.",
"GGT	Gabelli Multi-Media Trust Inc. (The)",
"GHDX	Genomic Health, Inc.",
"GHI	Global High Income Dollar Fund, Inc.",
"GHL	Greenhill",
"GIB	CGI Group, Inc.",
"GIFI	Gulf Island Fabrication, Inc.",
"GIGA	Giga-tronics Incorporated",
"GIGM	GigaMedia Limited",
"GIII	G-III Apparel Group, LTD.",
"GIL	Gildan Activewear, Inc.",
"GILD	Gilead Sciences, Inc.",
"GILT	Gilat Satellite Networks Ltd.",
"GIM	Templeton Global Income Fund, Inc.",
"GIS	General Mills, Inc.",
"GIVN	Given Imaging Ltd.",
"GJD	SYNTHETIC FIXED INCOME SECURITIES INC",
"GJH	SYNTHETIC FIXED INCOME SECURITIES INC",
"GJI	SYNTHETIC FIXED INCOME SECURITIES INC",
"GJJ	SYNTHETIC FIXED INCOME SECURITIES INC",
"GJK	SYNTHETIC FIXED INCOME SECURITIES INC",
"GJM	GMAC LLC",
"GJN	SYNTHETIC FIXED INCOME SECURITIES INC",
"GJO	SYNTHETIC FIXED INCOME SECURITIES INC",
"GJP	Synthetic Fixed-Income Securities, Inc.",
"GJR	Synthetic Fixed-Income Securities, Inc.",
"GJS	SYNTHETIC FIXED INCOME SECURITIES INC",
"GJT	Synthetic Fixed-Income Securities, Inc.",
"GJV	Synthetic Fixed-Income Securities, Inc.",
"GKK	Gramercy Capital Corp",
"GKM	GMAC LLC",
"GKNT	Geeknet, Inc.",
"GKSR	G&K Services, Inc.",
"GLAD	Gladstone Capital Corporation",
"GLBS	Globus Maritime Limited",
"GLBZ	Glen Burnie Bancorp",
"GLCH	Gleacher & Company, Inc.",
"GLDC	Golden Enterprises, Inc.",
"GLDD	Great Lakes Dredge & Dock Corporation",
"GLF	GulfMark Offshore, Inc.",
"GLGL	GLG Life Tech Corp",
"GLNG	Golar LNG Limited",
"GLP	Global Partners LP",
"GLPW	Global Power Equipment Group Inc",
"GLRE	Greenlight Reinsurance, Ltd.",
"GLT	Glatfelter",
"GLUU	Glu Mobile Inc.",
"GLW	Corning Incorporated",
"GM	General Motors Company",
"GM/WS/A	General Motors Company",
"GM/WS/B	General Motors Company",
"GMA	GMAC LLC",
"GMAN	Gordmans Stores, Inc.",
"GMCR	Green Mountain Coffee Roasters, Inc.",
"GME	Gamestop Corporation",
"GMET	GeoMet, Inc.",
"GMETP	GeoMet, Inc.",
"GMK	GRUMA, S.A. de C.V.",
"GMLP	Golar LNG Partners LP",
"GMT	GATX Corporation",
"GMXR	GMX Resources, Inc.",
"GNC	GNC Holdings, Inc.",
"GNCMA	General Communication, Inc.",
"GNE	IDT Corporation",
"GNI	Great Northern Iron Ore Properties",
"GNK	Genco Shipping & Trading Limited",
"GNMA	iShares Trust iShares Barclays GNMA Bond Fund",
"GNMK	GenMark Diagnostics, Inc.",
"GNOM	Complete Genomics, Inc.",
"GNRC	Generac Holdlings Inc.",
"GNT	GAMCO Natural Resources, Gold & Income Tust by Gabelli",
"GNTX	Gentex Corporation",
"GNVC	GenVec, Inc.",
"GNW	Genworth Financial Inc",
"GOF	Guggenheim Strategic Opportunities Fund",
"GOL	Gol Linhas Aereas Inteligentes S.A.",
"GOLD	Randgold Resources Limited",
"GOLF	Golfsmith International Holdings, Inc.",
"GOM	GMAC LLC",
"GOOD	Gladstone Commercial Corporation",
"GOODN	Gladstone Commercial Corporation",
"GOODO	Gladstone Commercial Corporation",
"GOODP	Gladstone Commercial Corporation",
"GOOG	Google Inc.",
"GOV	Government Properties Income Trust",
"GPC	Genuine Parts Company",
"GPI	Group 1 Automotive, Inc.",
"GPIC	Gaming Partners International Corporation",
"GPK	Graphic Packaging Holding Company",
"GPM	Guggenheim Enhanced Equity Income Fund",
"GPN	Global Payments Inc.",
"GPOR	Gulfport Energy Corporation",
"GPRC	Guanwei Recycling Corp.",
"GPRE	Green Plains Renewable Energy, Inc.",
"GPRO	Gen-Probe Incorporated",
"GPS	Gap, Inc. (The)",
"GPX	GP Strategies Corporation",
"GR	Goodrich Corporation (The)",
"GRA	W.R. Grace & Co.",
"GRFS	Grifols, S.A.",
"GRID	First Trust NASDAQ Clean Edge Smart Grid Infrastructure Index Fund",
"GRIF	Griffin Land & Nurseries, Inc.",
"GRMH	GrayMark Healthcare, Inc.",
"GRMN	Garmin Ltd.",
"GRNB	Green Bankshares, Inc.",
"GRO	Agria Corporation",
"GROW	U.S. Global Investors, Inc.",
"GRPN	Groupon, Inc.",
"GRR	Asia Tigers Fund, Inc. (The)",
"GRRF	China Grentech Corporation Limited",
"GRT	Glimcher Realty Trust",
"GRVY	GRAVITY Co., Ltd.",
"GRX	The Gabelli Healthcare & Wellness Trust",
"GS	Goldman Sachs Group, Inc. (The)",
"GSAT	Globalstar, Inc.",
"GSBC	Great Southern Bancorp, Inc.",
"GSE	GSE Holding, Inc.",
"GSF	Goldman Sachs Group, Inc. (The)",
"GSH	Guangshen Railway Company Limited",
"GSI	General Steel Holdings, Inc.",
"GSIG	GSI Group, Inc.",
"GSIT	GSI Technology, Inc.",
"GSJ	Goldman Sachs Group, Inc. (The)",
"GSJK	Compressco Partners, L.P.",
"GSK	GlaxoSmithKline PLC",
"GSL	Global Ship Lease, Inc.",
"GSM	Globe Specialty Metals Inc.",
"GSOL	Global Sources Ltd.",
"GSVC	GSV Capital Corp",
"GT	Goodyear Tire & Rubber Company (The)",
"GTAT	GT Advanced Technologies, Inc.",
"GTI	GrafTech International Ltd",
"GTIM	Good Times Restaurants Inc.",
"GTIV	Gentiva Health Services, Inc.",
"GTLS	Chart Industries, Inc.",
"GTN	Gray Television, Inc.",
"GTN/A	Gray Television, Inc.",
"GTS	Triple-S Management Corporation",
"GTSI	GTSI Corp.",
"GTXI	GTx, Inc.",
"GTY	Getty Realty Corporation",
"GU	Gushan Environmental Energy Limited",
"GUA	Gulf Power Company",
"GUID	Guidance Software, Inc.",
"GUL	Gulf Power Company",
"GULF	WisdomTree Middle East Dividend Fund",
"GURE	Gulf Resources, Inc.",
"GUT	Gabelli Utility Trust (The)",
"GVA	Granite Construction Incorporated",
"GWAY	Greenway Medical Technologies, Inc.",
"GWF	Wells Fargo & Company",
"GWR	Genesee & Wyoming, Inc.",
"GWRE	Guidewire Software, Inc.",
"GWW	W.W. Grainger, Inc.",
"GXP	Great Plains Energy Inc",
"GY	GenCorp Inc.",
"GYA	Corporate Asset Backed Corp CABCO",
"GYB	CABCO Series 2004-101 Trust",
"GYC	Corporate Asset Backed Corp CABCO",
"GYRO	Gyrodyne Company of America, Inc.",
"GZT	Gazit-Globe Ltd.",
"H	Hyatt Hotels Corporation",
"HA	Hawaiian Holdings, Inc.",
"HAE	Haemonetics Corporation",
"HAFC	Hanmi Financial Corporation",
"HAIN	The Hain Celestial Group, Inc.",
"HAL	Halliburton Company",
"HALL	Hallmark Financial Services, Inc.",
"HALO	Halozyme Therapeutics, Inc.",
"HAR	Harman International Industries, Incorporated",
"HARL	Harleysville Savings Bank",
"HAS	Hasbro, Inc.",
"HAST	Hastings Entertainment, Inc.",
"HAUP	Hauppauge Digital, Inc.",
"HAV	Helios Advantage Income Fund, Inc.",
"HAVNP	New York Community Bancorp, Inc.",
"HAYN	Haynes International, Inc.",
"HBAN	Huntington Bancshares Incorporated",
"HBANP	Huntington Bancshares Incorporated",
"HBC	HSBC Holdings plc",
"HBCP	Home Bancorp, Inc.",
"HBHC	Hancock Holding Company",
"HBI	Hanesbrands Inc.",
"HBIO	Harvard Bioscience, Inc.",
"HBM	HudBay Minerals Inc",
"HBNC	Horizon Bancorp (IN)",
"HBNK	Hampden Bancorp, Inc.",
"HBOS	Heritage Financial Group",
"HCA	HCA Holdings, Inc.",
"HCBK	Hudson City Bancorp, Inc.",
"HCC	HCC Insurance Holdings, Inc.",
"HCCI	Heritage-Crystal Clean, Inc.",
"HCF	Pyxis Credit Stategies Fund",
"HCII	Homeowners Choice, Inc.",
"HCIIP	Homeowners Choice, Inc.",
"HCIIW	Homeowners Choice, Inc.",
"HCKT	The Hackett Group, Inc.",
"HCN	Health Care REIT, Inc.",
"HCOM	Hawaiian Telcom Holdco, Inc.",
"HCP	HCP, Inc.",
"HCS	HSBC Holdings plc",
"HCSG	Healthcare Services Group, Inc.",
"HD	Home Depot, Inc. (The)",
"HDB	HDFC Bank Limited",
"HDNG	Hardinge, Inc.",
"HDSN	Hudson Technologies, Inc.",
"HDY	HyperDynamics Corporation",
"HE	Hawaiian Electric Industries, Inc.",
"HEAT	SmartHeat Inc.",
"HEES	H&E Equipment Services, Inc.",
"HEI	Heico Corporation",
"HEI/A	Heico Corporation",
"HEK	Heckmann Corporation",
"HELE	Helen of Troy Limited",
"HEOP	Heritage Oaks Bancorp",
"HEP	Holly Energy Partners, L.P.",
"HEQ	John Hancock Hedged Equity & Income Fund",
"HERO	Hercules Offshore, Inc.",
"HES	Hess Corporation",
"HF	HFF, Inc.",
"HFBC	HopFed Bancorp, Inc.",
"HFBL	Home Federal Bancorp, Inc. of Louisiana",
"HFC	HollyFrontier Corporation",
"HFFC	HF Financial Corp.",
"HFWA	Heritage Financial Corporation",
"HGG	HHGregg, Inc.",
"HGIC	Harleysville Group Inc.",
"HGR	Hanger Orthopedic Group, Inc.",
"HGSH	China HGS Real Estate, Inc.",
"HGSI	Human Genome Sciences, Inc.",
"HGT	Hugoton Royalty Trust",
"HHC	Howard Hughes Corporation (The)",
"HHGP	Hudson Highland Group, Inc.",
"HHS	Harte-Hanks, Inc.",
"HHY	Helios High Yield Fund",
"HI	Hillenbrand Inc",
"HIBB	Hibbett Sports, Inc.",
"HIF	Western Asset High Income Fund Inc.",
"HIFS	Hingham Institution for Savings",
"HIG	Hartford Financial Services Group, Inc. (The)",
"HIG/WS	Hartford Financial Services Group, Inc. (The)",
"HIH	Helios High Income Fund, Inc",
"HIHO	Highway Holdings Limited",
"HII	Huntington Ingalls Industries, Inc.",
"HIL	Hill International, Inc.",
"HILL	Dot Hill Systems Corporation",
"HIMX	Himax Technologies, Inc.",
"HIO	Western Asset High Income Opportunity Fund, Inc.",
"HIS	CIGNA High Income Shares",
"HIT	Hitachi, Ltd.",
"HITK	Hi-Tech Pharmacal Co., Inc.",
"HITT	Hittite Microwave Corporation",
"HIW	Highwoods Properties, Inc.",
"HIX	Western Asset High Income Fund II Inc.",
"HJA	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"HJG	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"HJJ	MS Structured Asset Corp SATURNS Goldman Sachs",
"HJL	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"HJN	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"HJO	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"HJR	MS Structured Asset Corp.",
"HJT	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"HJV	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"HK	Halcon Resources Corporation",
"HKAC	Hicks Acquisition Company II, Inc.",
"HKACU	Hicks Acquisition Company II, Inc.",
"HKACW	Hicks Acquisition Company II, Inc.",
"HL	Hecla Mining Company",
"HLF	Herbalife LTD.",
"HLIT	Harmonic Inc.",
"HLS	HealthSouth Corporation",
"HLSS	Home Loan Servicing Solutions, Ltd.",
"HLX	Helix Energy Solutions Group, Inc.",
"HLYS	Heelys, Inc.",
"HMA	Health Management Associates, Inc.",
"HMC	Honda Motor Company, Ltd.",
"HME	Home Properties, Inc.",
"HMH	Helios Multi-Sector High Income Fund, Inc.",
"HMIN	Home Inns & Hotels Management Inc.",
"HMN	Horace Mann Educators Corporation",
"HMNF	HMN Financial, Inc.",
"HMNY	Helios & Matheson Information Technology Inc",
"HMPR	Hampton Roads Bankshares Inc",
"HMST	HomeStreet, Inc.",
"HMSY	HMS Holdings Corp",
"HMY	Harmony Gold Mining Co. Ltd.",
"HNH	Handy & Harman Ltd.",
"HNI	HON INDUSTRIES Inc.",
"HNP	Huaneng Power Intl",
"HNR	Harvest Natural Resources Inc",
"HNRG	Hallador Energy Company",
"HNSN	Hansen Medical, Inc.",
"HNT	Health Net Inc.",
"HNZ	H.J. Heinz Company",
"HOFT	Hooker Furniture Corporation",
"HOG	Harley-Davidson, Inc.",
"HOGS	Zhongpin Inc.",
"HOKU	Hoku Corporation",
"HOLI	Hollysys Automation Technologies, Ltd.",
"HOLL	Hollywood Media Corp.",
"HOLX	Hologic, Inc.",
"HOMB	Home BancShares, Inc.",
"HOME	Home Federal Bancorp, Inc.",
"HON	Honeywell International Inc.",
"HOOK	Craft Brew Alliance, Inc.",
"HOS	Hornbeck Offshore Services",
"HOT	Starwood Hotels & Resorts Worldwide, Inc.",
"HOTT	Hot Topic, Inc.",
"HOV	Hovnanian Enterprises Inc",
"HOVNP	Hovnanian Enterprises Inc",
"HOVU	Hovnanian Enterprises Inc",
"HP	Helmerich & Payne, Inc.",
"HPCCP	Huntington Preferred Capital, Inc.",
"HPF	John Hancock Pfd Income Fund II",
"HPI	John Hancock Preferred Income Fund",
"HPJ	Hong Kong Highpower Technology",
"HPOL	Harris Interactive, Inc.",
"HPP	Hudson Pacific Properties, Inc.",
"HPQ	Hewlett-Packard Company",
"HPS	John Hancock Preferred Income Fund III",
"HPT	Hospitality Properites Trust",
"HPY	Heartland Payment Systems, Inc.",
"HQH	H&Q Healthcare Investors",
"HQL	H&Q Life Sciences Investors",
"HR	Healthcare Realty Trust Incorporated",
"HRB	H&R Block, Inc.",
"HRC	Hill-Rom Holdings Inc",
"HRG	Harbinger Group Inc",
"HRL	Hormel Foods Corporation",
"HRS	Harris Corporation",
"HRZN	Horizon Technology Finance Corporation",
"HSA	Helios Strategic Income Fd, Inc",
"HSC	Harsco Corporation",
"HSFT	HiSoft Technology International Limited",
"HSIC	Henry Schein, Inc.",
"HSII	Heidrick & Struggles International, Inc.",
"HSKA	Heska Corporation",
"HSM	Hyperion Strategic Mortgage Income Fund (The)",
"HSNI	HSN, Inc.",
"HSOL	Hanwha SolarOne Co., Ltd.",
"HSP	Hospira Inc",
"HST	Host Marriott Financial Trust",
"HSTM	HealthStream, Inc.",
"HSY	Hershey Company (The)",
"HT	Hersha Hospitality Trust",
"HTBK	Heritage Commerce Corp",
"HTCH	Hutchinson Technology Incorporated",
"HTCO	Hickory Tech Corporation",
"HTD	John Hancock Tax Advantaged Dividend Income Fund",
"HTGC	Hercules Technology Growth Capital, Inc.",
"HTH	Hilltop Holdings Inc.",
"HTHT	China Lodging Group, Limited",
"HTLD	Heartland Express, Inc.",
"HTLF	Heartland Financial USA, Inc.",
"HTR	Hyperion Brookfield Total Return Fund, Inc.",
"HTS	Hatteras Financial Corp",
"HTWR	Heartware International, Inc.",
"HTY	John Hancock Tax-Advantaged Global Shareholder Yield Fund",
"HTZ	Hertz Global Holdings, Inc",
"HUB/A	Hubbell Inc A",
"HUB/B	Hubbell Inc A",
"HUBG	Hub Group, Inc.",
"HUM	Humana Inc.",
"HUN	Huntsman Corporation",
"HURC	Hurco Companies, Inc.",
"HURN	Huron Consulting Group Inc.",
"HVB	Hudson Valley Holding Corp.",
"HVT	Haverty Furniture Companies, Inc.",
"HVT/A	Haverty Furniture Companies, Inc.",
"HW	Headwaters Incorporated",
"HWAY	Healthways, Inc.",
"HWBK	Hawthorn Bancshares, Inc.",
"HWCC	Houston Wire & Cable Company",
"HWD	Harry Winston Diamond Corporation",
"HWKN	Hawkins, Inc.",
"HXL	Hexcel Corporation",
"HXM	Desarrolladora Homex",
"HYB	New America High Income Fund, Inc. (The)",
"HYF	Managed High Yield Plus Fund, Inc.",
"HYGS	Hydrogenics Corporation",
"HYH	Lehman ABS Corporation",
"HYI	Western Asset High Yield Defined Opportunity Fund Inc.",
"HYK	Lehman ABS Corporation",
"HYL	Lehman ABS Corporation",
"HYM/CL	Lehman ABS Corporation",
"HYT	Blackrock Corporate High Yield Fund VI Inc",
"HYV	Blackrock Corporate High Yield Fund V Inc",
"HYY	Structured Products Corp 6.25 Verizon Gbl",
"HZD	Zion Oil & Gas Inc",
"HZK	Structured Products Corp 6.25 Verizon Gbl",
"HZNP	Horizon Pharma, Inc.",
"HZO	MarineMax, Inc.",
"IACI	IAC/InterActiveCorp",
"IAE	ING Asia Pacific High Dividend Equity Income Fund",
"IAG	Iamgold Corporation",
"IART	Integra LifeSciences Holdings Corporation",
"IBA	Industrias Bachoco, S.A. de C.V.",
"IBB	iShares NASDAQ Biotechnology Index Fund",
"IBCA	Intervest Bancshares Corp.",
"IBCP	Independent Bank Corporation",
"IBCPO	Independent Bank Corporation",
"IBI	Interline Brands, Inc.",
"IBKC	IBERIABANK Corporation",
"IBKR	Interactive Brokers Group, Inc.",
"IBM	International Business Machines Corporation",
"IBN	ICICI Bank Limited",
"IBOC	International Bancshares Corporation",
"ICA	Empresas Ica Soc Contrladora",
"ICAD	icad inc.",
"ICB	MS Income Securities, Inc.",
"ICCC	ImmuCell Corporation",
"ICE	IntercontinentalExchange, Inc.",
"ICFI	ICF International, Inc.",
"ICGE	ICG Group, Inc.",
"ICLN	iShares S&P Global Clean Energy Index Fund",
"ICLR	ICON plc",
"ICON	Iconix Brand Group, Inc.",
"ICS	Invesco California Municipal Securities",
"ICUI	ICU Medical, Inc.",
"IDA	IDACORP, Inc.",
"IDCC	InterDigital, Inc.",
"IDE	ING Infrastructure Industrial and Material Fund",
"IDG	ING Group, N.V.",
"IDIX	Idenix Pharmaceuticals, Inc.",
"IDRA	Idera Pharmaceuticals, Inc.",
"IDSA	Industrial Services of America, Inc.",
"IDSY	I.D. Systems, Inc.",
"IDT	IDT Corporation",
"IDTI	Integrated Device Technology, Inc.",
"IDXX	IDEXX Laboratories, Inc.",
"IEP	Icahn Enterprises L.P.",
"IESC	Integrated Electrical Services, Inc.",
"IEX	IDEX Corporation",
"IFAS	iShares FTSE EPRA/NAREIT Asia Index Fund",
"IFEU	iShares FTSE EPRA/NAREIT Europe Index Fund",
"IFF	Internationa Flavors & Fragrances, Inc.",
"IFGL	iShares FTSE EPRA/NAREIT Global Real Estate ex-U.S. Index Fund",
"IFN	India Fund, Inc. (The)",
"IFNA	iShares FTSE EPRA/NAREIT North America Index Fund",
"IFON	InfoSonics Corp",
"IFSIA	Interface, Inc.",
"IFSM	iShares FTSE Developed Small Cap ex-North America Index Fund",
"IFT	Imperial Holdings, Inc.",
"IGA	ING Global Advantage and Premium Opportunity Fund",
"IGD	ING Global Equity Dividend and Premium Opportunity Fund",
"IGI	Western Asset Investment Grade Defined Opportunity Trust Inc.",
"IGK	ING Group, N.V.",
"IGLD	Internet Gold Golden Lines Ltd.",
"IGOI	iGo, Inc",
"IGOV	iShares S&P/Citigroup International Treasury Bond Fund",
"IGR	CBRE Clarion Global Real Estate Income Fund",
"IGT	International Game Technology",
"IGTE	iGATE Corporation",
"IHC	Independence Holding Company",
"IHD	ING Emerging Markets High Dividend Equity Fund",
"IHG	Intercontinental Hotels Group",
"IHS	IHS Inc.",
"IIC	Invesco California Municipal Income Trust",
"IID	ING International High Dividend Equity Income Fund",
"IIF	Morgan Stanley India Investment Fund, Inc.",
"III	Information Services Group, Inc.",
"IIIN	Insteel Industries, Inc.",
"IIJI	Internet Initiative Japan, Inc.",
"IILG	Interval Leisure Group, Inc.",
"IIM	Invesco Value Municipal Income Trust",
"IIN	IntriCon Corporation",
"IIT	PT Indosat Tbk",
"IIVI	II-VI Incorporated",
"IKAN	Ikanos Communications, Inc.",
"IKJ	Bank of America Corporation",
"IKL	Bank of America Corporation",
"IKM	Bank of America Corporation",
"IKNX	Ikonics Corporation",
"IKR	Bank of America Corporation",
"IL	IntraLinks Holdings, Inc.",
"ILMN	Illumina, Inc.",
"IM	Ingram Micro Inc.",
"IMAX	Imax Corporation",
"IMC	Invesco Value Municipal Bond Trust",
"IMF	Western Asset Inflation Management Fund Inc",
"IMGN	ImmunoGen, Inc.",
"IMI	Intermolecular, Inc.",
"IMKTA	Ingles Markets, Incorporated",
"IMMR	Immersion Corporation",
"IMMU	Immunomedics, Inc.",
"IMN	Imation Corporation",
"IMOS	ChipMOS TECHNOLOGIES (Bermuda) LTD.",
"IMPV	Imperva, Inc.",
"IMRS	Imris Inc",
"IMS	Invesco Value Municipal Securities",
"IMT	Invesco Value Municipal Trust",
"IN	UNOVA, Inc.",
"INAP	Internap Network Services Corporation",
"INB	Cohen & Steers Global Income Builder, Inc.",
"INCB	Indiana Community Bancorp",
"INCY	Incyte Corporation",
"IND	ING Group, N.V.",
"INDB	Independent Bank Corp.",
"INDY	iShares S&P India Nifty 50 Index Fund",
"INF	Brookfield Global Listed Infrastructure Income Fund",
"INFA	Informatica Corporation",
"INFI	Infinity Pharmaceuticals, Inc.",
"INFN	Infinera Corporation",
"INFY	Infosys Limited",
"ING	ING Group, N.V.",
"ININ	Interactive Intelligence Group, Inc.",
"INMD	IntegraMed America, Inc.",
"INN	Summit Hotel Properties, Inc.",
"INOC	Innotrac Corporation",
"INOD	Innodata Isogen Inc",
"INPH	Interphase Corporation",
"INSM	Insmed, Inc.",
"INSP	InfoSpace, Inc.",
"INT	World Fuel Services Corporation",
"INTC	Intel Corporation",
"INTG	The Intergroup Corporation",
"INTL	INTL FCStone Inc.",
"INTT	inTest Corporation",
"INTU	Intuit Inc.",
"INTX	Intersections, Inc.",
"INVE	Identive Group, Inc.",
"INVN	InvenSense, Inc.",
"INWK	InnerWorkings, Inc.",
"INXN	InterXion Holding N.V.",
"INZ	ING Group, N.V.",
"IO	Ion Geophysical Corporation",
"IOC	InterOil Corporation",
"IOSP	Innospec Inc.",
"IP	International Paper Company",
"IPAR	Inter Parfums, Inc.",
"IPAS	iPass Inc.",
"IPCC	Infinity Property and Casualty Corporation",
"IPCI	Intellipharmaceutics International Inc.",
"IPCM	IPC The Hospitalist Company, Inc.",
"IPG	Interpublic Group of Companies, Inc. (The)",
"IPGP	IPG Photonics Corporation",
"IPHI	Inphi Corporation",
"IPHS	Innophos Holdings, Inc.",
"IPI	Intrepid Potash, Inc",
"IPSU	Imperial Sugar Company",
"IPXL	Impax Laboratories, Inc.",
"IQC	Invesco California Municipal Securities",
"IQI	Invesco Quality Municipal Income Trust",
"IQM	Invesco Quality Municipal Securities",
"IQN	Invesco New York Quality Municipal Securities",
"IQNT	Neutral Tandem, Inc.",
"IQT	Invesco Quality Municipal Investment Trust",
"IR	Ingersoll-Rand plc (Ireland)",
"IRBT	iRobot Corporation",
"IRC	Inland Real Estate Corporation",
"IRDM	Iridium Communications Inc",
"IRDMU	Iridium Communications Inc",
"IRDMW	Iridium Communications Inc",
"IRDMZ	Iridium Communications Inc",
"IRE	Governor and Company of the Bank of Ireland (The)",
"IRET	Investors Real Estate Trust",
"IRETP	Investors Real Estate Trust",
"IRF	International Rectifier Corporation",
"IRIS	IRIS International, Inc.",
"IRIX	IRIDEX Corporation",
"IRL	Irish Investment Fund, Inc. (The)",
"IRM	Iron Mountain Incorporated",
"IROQ	IF Bancorp, Inc.",
"IRR	ING Risk Managed Natural Resources Fund",
"IRS	IRSA Inversiones Y Representaciones S.A.",
"IRWD	Ironwood Pharmaceuticals, Inc.",
"ISBC	Investors Bancorp, Inc.",
"ISCA	International Speedway Corporation",
"ISF	ING Group, N.V.",
"ISG	ING Group, N.V.",
"ISH	International Shipholding Corporation",
"ISHG	iShares S&P/Citigroup 1-3 Year International Treasury Bond Fund",
"ISIG	Insignia Systems, Inc.",
"ISIL	Intersil Corporation",
"ISIS	Isis Pharmaceuticals, Inc.",
"ISLE	Isle of Capri Casinos, Inc.",
"ISM	SLM Corporation",
"ISNS	Image Sensing Systems, Inc.",
"ISP	ING Group, N.V.",
"ISRG	Intuitive Surgical, Inc.",
"ISRL	Isramco, Inc.",
"ISS	iSoftStone Holdings Limited",
"ISSC	Innovative Solutions and Support, Inc.",
"ISSI	Integrated Silicon Solution, Inc.",
"ISTA	ISTA Pharmaceuticals, Inc.",
"IT	Gartner, Inc.",
"ITC	ITC Holdings Corp.",
"ITG	Investment Technology Group, Inc.",
"ITIC	Investors Title Company",
"ITMN	InterMune, Inc.",
"ITRI	Itron, Inc.",
"ITRN	Ituran Location and Control Ltd.",
"ITT	ITT Corporation",
"ITUB	Itau Unibanco Banco Holding SA",
"ITW	Illinois Tool Works Inc.",
"IVAC	Intevac, Inc.",
"IVAN	Ivanhoe Energy, Inc.",
"IVC	Invacare Corporation",
"IVN	Ivanhoe Mines Ltd",
"IVR	INVESCO MORTGAGE CAPITAL INC",
"IVZ	Invesco Plc",
"IX	Orix Corp Ads",
"IXYS	IXYS Corporation",
"JACK	Jack In The Box Inc.",
"JADE	LJ International, Inc.",
"JAG	Jaguar Mining Inc",
"JAH	Jarden Corporation",
"JAKK	JAKKS Pacific, Inc.",
"JASO	JA Solar Holdings, Co., Ltd.",
"JAX	J. Alexander's Corporation",
"JAXB	Jacksonville Bancorp, Inc.",
"JAZZ	Jazz Pharmaceuticals plc",
"JBHT	J.B. Hunt Transport Services, Inc.",
"JBI	Lehman ABS Cp 7.857%",
"JBJ	Lehman ABS Corporation",
"JBK	Lehman ABS Corporation",
"JBL	Jabil Circuit, Inc.",
"JBLU	JetBlue Airways Corporation",
"JBN	Select Asset Inc.",
"JBO	Lehman ABS Corporation",
"JBR	Select Asset Inc.",
"JBSS	John B. Sanfilippo & Son, Inc.",
"JBT	John Bean Technologies Corporation",
"JCDA	Jacada Ltd.",
"JCE	Nuveen Core Equity Alpha Fund",
"JCI	Johnson Controls, Inc.",
"JCOM	j2 Global, Inc.",
"JCP	J.C. Penney Company, Inc. Holding Company",
"JCS	Communications Systems, Inc.",
"JCTCF	Jewett-Cameron Trading Company",
"JDAS	JDA Software Group, Inc.",
"JDD	Nuveen Diversified Dividend and Income Fund",
"JDSU	JDS Uniphase Corporation",
"JE	Just Energy Group, Inc.",
"JEC	Jacobs Engineering Group Inc.",
"JEF	Jefferies Group, Inc.",
"JEQ	Japan Equity Fund, Inc. (The)",
"JFBC	Jeffersonville Bancorp",
"JFBI	Jefferson Bancshares, Inc.",
"JFC	JF China Region  Fund, Inc.",
"JFR	Nuveen Floating Rate Income Fund",
"JGG	Nuveen Global Government Enhanced Income Fund",
"JGT	Nuveen Multi-Currency Short-Term Government Income Fund",
"JGV	Nuveen Global Value Opportunities Fund",
"JHI	John Hancock Investors Trust",
"JHP	Nuveen Quality Preferred Income Fund 3",
"JHS	John Hancock Income Securities Trust",
"JHX	James Hardie Industries SE",
"JIVE	Jive Software, Inc.",
"JJSF	J & J Snack Foods Corp.",
"JKHY	Jack Henry & Associates, Inc.",
"JKS	JinkoSolar Holding Company Limited",
"JLA	Nuveen Equity Premium Advantage Fund",
"JLL	Jones Lang LaSalle Incorporated",
"JLS	Nuveen Mortgage Opportunity Term Fund",
"JMBA	Jamba, Inc.",
"JMF	Nuveen Energy MLP Total Return Fund",
"JMP	JMP Group Inc",
"JMT	Nuven Mortgage Opportunity Term Fund 2",
"JNGW	Jingwei International Limited",
"JNJ	Johnson & Johnson",
"JNPR	Juniper Networks, Inc.",
"JNS	Janus Capital Group, Inc",
"JNY	Jones Group, Inc. (The)",
"JOBS	51job, Inc.",
"JOE	St. Joe Company (The)",
"JOEZ	Joe's Jeans Inc.",
"JOF	Japan Smaller Capitalization Fund Inc",
"JOSB	Jos. A. Bank Clothiers, Inc.",
"JOUT	Johnson Outdoors Inc.",
"JOY	Joy Global Inc.",
"JPC	Nuveen Preferred and Convertible Income Fund",
"JPG	Nuveen Equity Premium and Growth Fund",
"JPM	J P Morgan Chase & Co",
"JPM/WS	J P Morgan Chase & Co",
"JPS	Nuveen Quality Preferred Income Fund 2",
"JPZ	Nuveen Equity Premium Income Fund",
"JQC	Nuveen Preferred and Convertible Income Fund 2",
"JRCC	James River Coal Company",
"JRJC	China Finance Online Co. Limited",
"JRN	Journal Communications, Inc.",
"JRO	Nuveen Floating Rate Income Opportuntiy Fund",
"JSD	Nuveen Short Duration Credit Opportunities Fund",
"JSDA	Jones Soda Co.",
"JSM	SLM Corporation",
"JSN	Nuveen Equity Premium Opportunity Fund",
"JST	Jinpan International Limited",
"JTA	Nuveen Tax-Advantaged Total Return Strategy Fund",
"JTD	Nuveen Tax-Advantaged Dividend Growth Fund",
"JTP	Nuveen Quality Preferred Income Fund",
"JVA	Coffee Holding Co., Inc.",
"JW/A	John Wiley & Sons, Inc.",
"JW/B	John Wiley & Sons, Inc.",
"JWF	Wells Fargo & Company",
"JWN	Nordstrom, Inc.",
"JXSB	Jacksonville Bancorp Inc.",
"JZC	Lehman ABS Corporation",
"JZH	Lehman ABS Corporation",
"JZJ	Lehman ABS Corporation",
"JZK	Lehman ABS Corporation",
"JZL	Lehman ABS Corporation",
"JZS	Lehman ABS Corporation",
"JZT	Lehman ABS Corp",
"JZV	Lehman ABS Corporation",
"K	Kellogg Company",
"KAI	Kadant Inc",
"KALU	Kaiser Aluminum Corporation",
"KAMN	Kaman Corporation",
"KAR	KAR Auction Services, Inc",
"KB	KB Financial Group Inc",
"KBALB	Kimball International, Inc.",
"KBH	KB Home",
"KBR	KBR, Inc.",
"KBW	KBW Inc",
"KCAP	Kohlberg Capital Corporation",
"KCC	Lehman ABS Corporation",
"KCG	Knight Capital Group, Inc.",
"KCLI	Kansas City Life Insurance Company",
"KCP	Kenneth Cole Productions, Inc.",
"KCW	Lehman ABS Corporation",
"KDN	Kaydon Corporation",
"KED	Kayne Anderson Energy Development Company",
"KEF	Korea Equity Fund, Inc.",
"KEF/WD	Korea Equity Fund, Inc.",
"KEG	Key Energy Services, Inc.",
"KELYA	Kelly Services, Inc.",
"KELYB	Kelly Services, Inc.",
"KEM	Kemet Corporation",
"KEP	Korea Electric Power Corporation",
"KEQU	Kewaunee Scientific Corporation",
"KERX	Keryx Biopharmaceuticals, Inc.",
"KEX	Kirby Corporation",
"KEY	KeyCorp",
"KEYN	Keynote Systems, Inc.",
"KEYW	The KEYW Holding Corporation",
"KF	Korea Fund, Inc. (The)",
"KFFB	Kentucky First Federal Bancorp",
"KFFG	Kaiser Federal Financial Group, Inc.",
"KFH	KKR Financial Holdings LLC",
"KFN	KKR Financial Holdings LLC",
"KFRC	Kforce, Inc.",
"KFS	Kingsway Financial Services, Inc.",
"KFT	Kraft Foods Inc.",
"KFY	Korn/Ferry International",
"KGC	Kinross Gold Corporation",
"KGJI	Kingold Jewelry Inc.",
"KH	China Kanghui Holdings",
"KHI	Scudder High Income Trust",
"KID	Kid Brands, Inc.",
"KIM	Kimco Realty Corporation",
"KINS	Kingstone Companies, Inc",
"KIOR	KiOR, Inc.",
"KIPO	Keating Capital, Inc.",
"KIPS	Kips Bay Medical, Inc.",
"KIRK	Kirkland's, Inc.",
"KITD	KIT digital, Inc.",
"KKD	Krispy Kreme Doughnuts, Inc.",
"KKR	KKR & Co. L.P.",
"KLAC	KLA-Tencor Corporation",
"KLIC	Kulicke and Soffa Industries, Inc.",
"KMB	Kimberly-Clark Corporation",
"KMF	Kayne Anderson Midstream Energy Fund, Inc",
"KMGB	KMG Chemicals, Inc.",
"KMI	Kinder Morgan, Inc.",
"KMM	Scudder Multi-Market Income Trust",
"KMP	Kinder Morgan Energy Partners, L.P.",
"KMPR	Kemper Corporation",
"KMR	Kinder Morgan Management, LLC",
"KMT	Kennametal Inc.",
"KMX	CarMax Inc",
"KND	Kindred Healthcare, Inc.",
"KNDI	Kandi Technolgies, Corp.",
"KNL	Knoll, Inc.",
"KNM	Konami Corporation",
"KNO	Lehman ABS Corporation",
"KNOL	Knology, Inc.",
"KNR	Lehman ABS Corporation",
"KNSY	Kensey Nash Corporation",
"KNX	Knight Transportation, Inc.",
"KNXA	Kenexa Corporation",
"KO	Coca-Cola Company (The)",
"KOF	Coca Cola Femsa S.A.B. de C.V.",
"KOG	Kodiak Oil",
"KONA	Kona Grill, Inc.",
"KONE	Kingtone Wirelessinfo Solution Holding Ltd",
"KONG	KongZhong Corporation",
"KOOL	THERMOGENESIS Corp.",
"KOP	Koppers Holdings Inc.",
"KOPN	Kopin Corporation",
"KORS	Michael Kors Holdings Limited",
"KOS	Kosmos Energy Ltd.",
"KOSS	Koss Corporation",
"KR	Kroger Company (The)",
"KRA	Kraton Performance Polymers, Inc",
"KRC	Kilroy Realty Corporation",
"KRG	Kite Realty Group Trust",
"KRJ	Lehman ABS Corporation",
"KRNY	Kearny Financial",
"KRO	Kronos Worldwide Inc",
"KS	KapStone Paper and Packaging Corporation",
"KSA	Lehman ABS Corporation",
"KSK	Lehman ABS Corporation",
"KSM	Scudder Strategic Municiple Income Trust",
"KSS	Kohl's Corporation",
"KST	Scudder Strategic Income Trust",
"KSU	Kansas City Southern",
"KSW	KSW Inc",
"KSWS	K-Swiss Inc.",
"KT	Korea Telecom Corporation",
"KTCC	Key Tronic Corporation",
"KTEC	Key Technology, Inc.",
"KTF	Scudder Municiple Income Trust",
"KTH	Lehman ABS Corporation",
"KTN	Lehman ABS Corporation",
"KTOS	Kratos Defense & Security Solutions, Inc.",
"KTP	Lehman ABS Corporation",
"KUB	Kubota Corporation",
"KUTV	Ku6 Media Co., Ltd.",
"KV/A	K-V Pharmaceutical Company",
"KV/B	K-V Pharmaceutical Company",
"KVHI	KVH Industries, Inc.",
"KW	Kennedy-Wilson Holdings Inc.",
"KWK	Quicksilver Resources Inc.",
"KWR	Quaker Chemical Corporation",
"KYE	Kayne Anderson Energy Total Return Fund, Inc.",
"KYN	Kayne Anderson MLP Investment Company",
"KYO	Kyocera Corporation",
"L	Loews Corporation",
"LABC	Louisiana Bancorp, Inc.",
"LABL	Multi-Color Corporation",
"LACO	Lakes Entertainment, Inc.",
"LAD	Lithia Motors, Inc.",
"LAKE	Lakeland Industries, Inc.",
"LAMR	Lamar Advertising Company",
"LANC	Lancaster Colony Corporation",
"LARK	Landmark Bancorp Inc.",
"LAS	Lentuo International Inc.",
"LAWS	Lawson Products, Inc.",
"LAYN	Layne Christensen Company",
"LAZ	Lazard Ltd.",
"LBAI	Lakeland Bancorp, Inc.",
"LBF	Scudder Global High Income Fund, Inc.",
"LBIX	Leading Brands Inc",
"LBTYA	Liberty Global, Inc.",
"LBTYB	Liberty Global, Inc.",
"LBTYK	Liberty Global, Inc.",
"LCAV	LCA-Vision Inc.",
"LCC	US Airways Group, Inc. New",
"LCM	Advent/Claymore Enhanced Growth & Income Fund",
"LCNB	LCNB Corporation",
"LCRY	LeCroy Corporation",
"LCUT	Lifetime Brands, Inc.",
"LDF	Latin American Discovery Fund, Inc. (The)",
"LDK	LDK Solar Co. Ltd.",
"LDL	Lydall, Inc.",
"LDR	Landauer, Inc.",
"LEA	Lear Corporation",
"LEAP	Leap Wireless International, Inc.",
"LECO	Lincoln Electric Holdings, Inc.",
"LEDR	Market Leader, Inc",
"LEDS	SemiLEDS Corporation",
"LEE	Lee Enterprises, Incorporated",
"LEG	Leggett & Platt, Incorporated",
"LEN	Lennar Corporation",
"LEN/B	Lennar Corporation",
"LEO	Dreyfus Strategic Municipals, Inc.",
"LF	Leapfrog Enterprises Inc",
"LFC	China Life Insurance Company Limited",
"LFL	Lan Chile S.A.",
"LFUS	Littelfuse, Inc.",
"LG	Laclede Group, Inc.",
"LGCY	Legacy Reserves LP",
"LGF	Lions Gate Entertainment Corporation",
"LGI	Lazard Global Total Return and Income Fund",
"LGND	Ligand Pharmaceuticals Incorporated",
"LH	Laboratory Corporation of America Holdings",
"LHCG	LHC Group",
"LHO	LaSalle Hotel Properties",
"LIFE	Life Technologies Corporation",
"LII	Lennox International, Inc.",
"LIME	Lime Energy Co.",
"LINC	Lincoln Educational Services Corporation",
"LINE	Linn Energy, LLC",
"LINTA	Liberty Interactive Corporation",
"LINTB	Liberty Interactive Corporation",
"LION	Fidelity Southern Corporation",
"LIOX	Lionbridge Technologies, Inc.",
"LIVE	LiveDeal, Inc.",
"LIWA	Lihua International, Inc.",
"LIZ	Liz Claiborne, Inc.",
"LKFN	Lakeland Financial Corporation",
"LKQX	LKQ Corporation",
"LL	Lumber Liquidators Holdings, Inc",
"LLEN	L&L Energy, Inc.",
"LLL	L-3 Communications Holdings, Inc.",
"LLNW	Limelight Networks, Inc.",
"LLTC	Linear Technology Corporation",
"LLY	Eli Lilly and Company",
"LM	Legg Mason, Inc.",
"LMAT	LeMaitre Vascular, Inc.",
"LMCA	Liberty Media Corporation",
"LMCB	Liberty Media Corporation",
"LMIA	LMI Aerospace, Inc.",
"LMLP	LML Payment Systems, Inc.",
"LMNR	Limoneira Co",
"LMNX	Luminex Corporation",
"LMOS	Lumos Networks Corp.",
"LMT	Lockheed Martin Corporation",
"LNBB	LNB Bancorp, Inc.",
"LNC	Lincoln National Corporation",
"LNC/WS	Lincoln National Corporation",
"LNCE	Lance, Inc.",
"LNCR	Lincare Holdings Inc.",
"LNDC	Landec Corporation",
"LNET	LodgeNet Interactive Corporation",
"LNKD	LinkedIn Corporation",
"LNN	Lindsay Corporation",
"LNT	Alliant Energy Corporation",
"LO	Lorillard, Inc",
"LOAN	Manhattan Bridge Capital, Inc",
"LOCM	Local.com Corporation",
"LOGI	Logitech International S.A.",
"LOGM	LogMein, Inc.",
"LOJN	LoJack Corporation",
"LONG	eLong, Inc.",
"LOOK	LookSmart, Ltd.",
"LOOP	LoopNet, Inc.",
"LOPE	Grand Canyon Education, Inc.",
"LOR	Lazard World Dividend & Income Fund, Inc.",
"LORL	Loral Space and Communications, Inc.",
"LOW	Lowe's Companies, Inc.",
"LPHI	Life Partners Holdings Inc",
"LPI	Laredo Petroleum Holdings, Inc.",
"LPL	LG Display Co., Limited American Depositary Shares",
"LPLA	LPL Investment Holdings Inc.",
"LPNT	LifePoint Hospitals, Inc.",
"LPR	Lone Pine Resources Inc.",
"LPS	Lender Processing Services, Inc",
"LPSB	LaPorte Bancorp, Inc.",
"LPSN	LivePerson, Inc.",
"LPTH	LightPath Technologies, Inc.",
"LPX	Louisiana-Pacific Corporation",
"LQDT	Liquidity Services, Inc.",
"LRAD	LRAD Corporation",
"LRCX	Lam Research Corporation",
"LRE	LRR Energy, L.P.",
"LRN	K12 Inc",
"LRY	Liberty Property Trust",
"LSBI	LSB Financial Corp.",
"LSBK	Lake Shore Bancorp, Inc.",
"LSCC	Lattice Semiconductor Corporation",
"LSE	Caplease Funding Inc",
"LSI	LSI Logic Corporation",
"LSTR	Landstar System, Inc.",
"LTBR	Lightbridge Corporation",
"LTC	LTC Properties, Inc.",
"LTD	Limited Brands, Inc.",
"LTM	Life Time Fitness",
"LTON	Linktone Ltd.",
"LTRE	Learning Tree International, Inc.",
"LTRX	Lantronix, Inc.",
"LTXC	LTX-Credence Corporation",
"LUB	Luby's, Inc.",
"LUFK	Lufkin Industries, Inc.",
"LUK	Leucadia National Corporation",
"LULU	lululemon athletica inc.",
"LUNA	Luna Innovations Incorporated",
"LUV	Southwest Airlines Company",
"LUX	Luxottica Group, S.p.A.",
"LVB	Steinway Musical Instruments, Inc.",
"LVLT	Level 3 Communications, Inc.",
"LVS	Las Vegas Sands Corp.",
"LWAY	Lifeway Foods, Inc.",
"LXK	Lexmark International, Inc.",
"LXP	Lexington Realty Trust",
"LXRX	Lexicon Pharmaceuticals, Inc.",
"LXU	Lsb Industries Inc.",
"LYB	LyondellBasell Industries NV",
"LYG	Lloyds Banking Group Plc",
"LYTS	LSI Industries Inc.",
"LYV	Live Nation Entertainment, Inc.",
"LZB	La-Z-Boy Incorporated",
"LZEN	Lizhan Environmental Corporation",
"M	Macy's Inc",
"MA	Mastercard Incorporated",
"MAA	Mid-America Apartment Communities, Inc.",
"MAC	Macerich Company (The)",
"MAG	Magnetek, Inc.",
"MAGS	Magal Security Systems Ltd.",
"MAIN	Main Street Capital Corporation",
"MAKO	MAKO Surgical Corp.",
"MALL	PC Mall, Inc.",
"MAN	ManpowerGroup",
"MANH	Manhattan Associates, Inc.",
"MANT	ManTech International Corporation",
"MAPP	MAP Pharmaceuticals, Inc.",
"MAR	Marriot International",
"MARK	Remark Media, Inc.",
"MARPS	Marine Petroleum Trust",
"MAS	Masco Corporation",
"MASC	Material Sciences Corporation",
"MASI	Masimo Corporation",
"MAT	Mattel, Inc.",
"MATR	Mattersight Corporation",
"MATW	Matthews International Corporation",
"MAV	Pioneer Municipal High Income Advantage Trust",
"MAXY	Maxygen, Inc.",
"MAY	Malaysia Fund, Inc (The)",
"MAYS	J. W. Mays, Inc.",
"MBFI	MB Financial Inc.",
"MBI	MBIA, Inc.",
"MBLX	Metabolix, Inc.",
"MBND	Multiband Corporation",
"MBRG	Middleburg Financial Corporation",
"MBT	Mobile TeleSystems",
"MBTF	M B T Financial Corp",
"MBVT	Merchants Bancshares, Inc.",
"MBWM	Mercantile Bank Corporation",
"MCA	Blackrock MuniYield California Insured Fund, Inc.",
"MCBC	Macatawa Bank Corporation",
"MCBF	Monarch Community Bancorp, Inc.",
"MCBI	MetroCorp Bancshares, Inc.",
"MCC	Medley Capital Corporation",
"MCD	McDonald's Corporation",
"MCEP	Mid-Con Energy Partners, LP",
"MCGC	MCG Capital Corporation",
"MCHP	Microchip Technology Incorporated",
"MCHX	Marchex, Inc.",
"MCI	Babson Capital Corporate Investors",
"MCK	McKesson Corporation",
"MCN	Madison/Claymore Covered Call & Equity Strategy Fund",
"MCO	Moody's Corporation",
"MCOX	Mecox Lane Limited",
"MCP	Molycorp, Inc",
"MCR	MFS Charter Income Trust",
"MCRI	Monarch Casino & Resort, Inc.",
"MCRL	Micrel, Incorporated",
"MCRS	MICROS Systems, Inc.",
"MCS	Marcus Corporation (The)",
"MCY	Mercury General Corporation",
"MD	Mednax, Inc",
"MDAS	MedAssets, Inc.",
"MDC	M.D.C. Holdings, Inc.",
"MDCA	MDC Partners Inc.",
"MDCI	Medical Action Industries Inc.",
"MDCO	The Medicines Company",
"MDF	Metropolitan Health Networks, Inc.",
"MDH	MHI Hospitality Corporation",
"MDP	Meredith Corporation",
"MDR	McDermott International, Inc.",
"MDRX	Allscripts Healthcare Solutions, Inc.",
"MDS	Midas, Inc.",
"MDSO	Medidata Solutions, Inc.",
"MDT	Medtronic, Inc.",
"MDTH	MedCath Corporation",
"MDU	Mdu Res Group Inc",
"MDVN	Medivation, Inc.",
"MEAD	Meade Instruments Corp.",
"MEAS	Measurement Specialties, Inc.",
"MED	MEDIFAST INC",
"MEDW	MEDIWARE Information Systems, Inc.",
"MEG	Media General, Inc.",
"MEI	Methode Electronics, Inc.",
"MELA	MELA Sciences, Inc",
"MELI	MercadoLibre, Inc.",
"MEMP	Memorial Production Partners LP",
"MEMS	MEMSIC, Inc.",
"MEN	Blackrock MuniEnhanced Fund, Inc.",
"MENT	Mentor Graphics Corporation",
"MEOH	Methanex Corporation",
"MERC	Mercer International Inc.",
"MERU	Meru Networks, Inc.",
"MET	MetLife, Inc.",
"METR	Metro Bancorp, Inc",
"MFA	America First Mortgage Investments, Inc.",
"MFB	Maidenform Brands, Inc.",
"MFC	Manulife Financial Corp",
"MFD	Macquarie/First Trust Global",
"MFG	Mizuho Financial Group, Inc.",
"MFI	MicroFinancial Incorporated",
"MFL	Blackrock MuniHoldings Investment Quality Fund",
"MFLR	Mayflower Bancorp, Inc.",
"MFLX	Multi-Fineline Electronix, Inc.",
"MFM	MFS Municipal Income Trust",
"MFNC	Mackinac Financial Corporation",
"MFRI	MFRI, Inc.",
"MFRM	Mattress Firm Holding Corp.",
"MFSF	MutualFirst Financial Inc.",
"MFT	Blackrock MuniYield Investment QualityFund",
"MFV	MFS Special Value Trust",
"MG	Mistras Group Inc",
"MGA	Magna International, Inc.",
"MGAM	Multimedia Games Holding Company, Inc.",
"MGEE	MGE Energy Inc.",
"MGF	MFS Government Markets Income Trust",
"MGI	Moneygram International, Inc.",
"MGIC	Magic Software Enterprises Ltd.",
"MGLN	Magellan Health Services, Inc.",
"MGM	MGM Resorts International",
"MGPI	MGP Ingredients, Inc.",
"MGRC	McGrath RentCorp",
"MGU	Macquarie Global Infrastructure Total Return Fund Inc.",
"MGYR	Magyar Bancorp, Inc.",
"MHD	Blackrock MuniHoldings Fund, Inc.",
"MHF	Western Asset Municipal High Income Fund, Inc.",
"MHGC	Morgans Hotel Group Co.",
"MHI	Pioneer Municipal High Income Trust",
"MHK	Mohawk Industries, Inc.",
"MHLD	Maiden Holdings, Ltd.",
"MHN	Blackrock MuniHoldings New York Quality Fund, Inc.",
"MHNA	Maiden Holdings, Ltd.",
"MHO	M/I Homes, Inc.",
"MHP	McGraw-Hill Companies, Inc. (The)",
"MHR	Magnum Hunter Resources Corporation",
"MHS	MedcoHealth Solutions Inc",
"MHY	Western Asset Managed High Income Fund, Inc.",
"MIC	Macquarie Infrastructure Company LLC",
"MIDD	The Middleby Corporation",
"MIG	Meadowbrook Insurance Group, Inc.",
"MIL	MFC Industrial Ltd.",
"MILL	Miller Energy Resources, Inc.",
"MIM	MI Developments Inc",
"MIN	MFS Intermediate Income Trust",
"MIND	Mitcham Industries, Inc.",
"MINI	Mobile Mini, Inc.",
"MIPS	MIPS Technologies, Inc.",
"MITK	Mitek Systems, Inc.",
"MITL	Mitel Networks Corporation",
"MITT	AG Mortgage Investment Trust, Inc.",
"MIY	Blackrock MuniYield Michigan Quality Fund, Inc.",
"MJH	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"MJI	Blackrock MuniYield New Jersey Quality Fund, Inc.",
"MJN	Mead Johnson Nutrition Company",
"MKC	McCormick & Company, Incorporated",
"MKC/V	McCormick & Company, Incorporated",
"MKL	Markel Corporation",
"MKS	MS Structured Asset Corp Saturns GE Cap Corp Series 2002-14",
"MKSI	MKS Instruments, Inc.",
"MKTAY	Makita Corp.",
"MKTG	Responsys, Inc.",
"MKTX	MarketAxess Holdings, Inc.",
"MKV	Markel Corporation",
"MLAB	Mesa Laboratories, Inc.",
"MLG	MetLife, Inc.",
"MLHR	Herman Miller, Inc.",
"MLI	Mueller Industries, Inc.",
"MLM	Martin Marietta Materials, Inc.",
"MLNK	ModusLink Global Solutions, Inc",
"MLNX	Mellanox Technologies, Ltd.",
"MLP	Maui Land & Pineapple Company, Inc.",
"MLR	Miller Industries, Inc.",
"MLU	MetLife, Inc.",
"MLVF	Malvern Federal Bancorp, Inc.",
"MMC	Marsh & McLennan Companies, Inc.",
"MMI	Motorola, Inc.",
"MMLP	Martin Midstream Partners L.P.",
"MMM	3M Company",
"MMP	Magellan Midstream Partners L.P.",
"MMR	McMoRan Exploration Company",
"MMS	Maximus, Inc.",
"MMSI	Merit Medical Systems, Inc.",
"MMT	MFS Multimarket Income Trust",
"MMU	Western Asset Managed Municipals Fund, Inc.",
"MMUS	MakeMusic, Inc.",
"MMYT	MakeMyTrip Limited",
"MN	Manning & Napier, Inc.",
"MNDO	MIND C.T.I. Ltd.",
"MNE	Blackrock Muni New York Intermediate Duration Fund Inc",
"MNEL	Mission NewEnergy Limited",
"MNGL	Blue Wolf Mongolia Holdings Corp.",
"MNGLU	Blue Wolf Mongolia Holdings Corp.",
"MNGLW	Blue Wolf Mongolia Holdings Corp.",
"MNI	McClatchy Company (The)",
"MNKD	MannKind Corporation",
"MNOV	MediciNova, Inc.",
"MNP	Western Asset Municipal Partners Fund, Inc.",
"MNR	Monmouth Real Estate Investment Corporation",
"MNRK	Monarch Financial Holdings, Inc.",
"MNRKP	Monarch Financial Holdings, Inc.",
"MNRO	Monro Muffler Brake, Inc.",
"MNST	Monster Beverage Corporation",
"MNTA	Momenta Pharmaceuticals, Inc.",
"MNTG	MTR Gaming Group, Inc.",
"MNTX	Manitex International, Inc.",
"MO	Altria Group",
"MOBI	Sky-mobi Limited",
"MOCO	MOCON, Inc.",
"MOD	Modine Manufacturing Company",
"MODL	MModal Inc.",
"MOFG	MidWestOne Financial Group, Inc.",
"MOG/A	Moog Inc.",
"MOG/B	Moog Inc.",
"MOH	Molina Healthcare Inc",
"MOLX	Molex Incorporated",
"MOLXA	Molex Incorporated",
"MON	Monsanto Company",
"MORN	Morningstar, Inc.",
"MOS	Mosaic Company (The)",
"MOSY	MoSys, Inc.",
"MOTR	Motricity, Inc.",
"MOV	Movado Group Inc.",
"MOVE	Move, Inc.",
"MPA	Blackrock MuniYield Pennsylvania Quality Fund",
"MPAA	Motorcar Parts of America, Inc.",
"MPAC	MOD-PAC CORP.",
"MPB	Mid Penn Bancorp",
"MPC	Marathon Petroleum Corporation",
"MPEL	Melco Crown Entertainment Limited",
"MPET	Magellan Petroleum Corporation",
"MPG	MPG Office Trust, Inc.",
"MPJ	Mississippi Power Company",
"MPR	Met-Pro Corporation",
"MPV	Babson Capital Participation Investors",
"MPW	Medical Properties Trust, Inc.",
"MPWR	Monolithic Power Systems, Inc.",
"MPX	Marine Products Corporation",
"MQT	Blackrock MuniYield Quality Fund II, Inc.",
"MQY	Blackrock MuniYield Quality Fund, Inc.",
"MR	Mindray Medical International Limited",
"MRCY	Mercury Computer Systems",
"MRF	American Income Fund, Inc.",
"MRGE	Merge Healthcare Incorporated.",
"MRH	Montpelier Re Holdings Ltd.",
"MRK	Merck & Company, Inc.",
"MRLN	Marlin Business Services Corp.",
"MRO	Marathon Oil Corporation",
"MRTN	Marten Transport, Ltd.",
"MRVL	Marvell Technology Group Ltd.",
"MRX	Medicis Pharmaceutical Corporation",
"MS	Morgan Stanley",
"MSA	Mine Safety Appliances Company",
"MSB	Mesabi Trust",
"MSBF	MSB Financial Corp.",
"MSCC	Microsemi Corporation",
"MSCI	MSCI Inc",
"MSD	Morgan Stanley Emerging Markets Debt Fund, Inc.",
"MSDXP	BB&T Corporation",
"MSEX	Middlesex Water Company",
"MSF	Morgan Stanley Emerging Markets Fund, Inc.",
"MSFG	MainSource Financial Group, Inc.",
"MSFT	Microsoft Corporation",
"MSG	The Madison Square Garden Company",
"MSHL	Marshall Edwards, Inc.",
"MSI	Motorola, Inc.",
"MSJ	Morgan Stanley",
"MSK	Morgan Stanley",
"MSLI	Merus Labs International Inc.",
"MSM	MSC Industrial Direct Company, Inc.",
"MSO	Martha Stewart Living Omnimedia, Inc.",
"MSON	MISONIX, Inc.",
"MSP	Madison Strategic Sector Premium Fund",
"MSPD	Mindspeed Technologies, Inc.",
"MSTR	MicroStrategy Incorporated",
"MSW	Mission West Properties, Inc.",
"MSY	Invesco High Yield Investments Fund",
"MSZ	Morgan Stanley",
"MT	ArcelorMittal",
"MTB	M&T Bank Corporation",
"MTD	Mettler-Toledo International, Inc.",
"MTDR	Matador Resources Company",
"MTE	Mahanagar Telephone Nigam Ltd",
"MTEX	Mannatech, Incorporated",
"MTG	MGIC Investment Corporation",
"MTGE	American Capital Mortgage Investment Corp.",
"MTH	Meritage Corporation",
"MTL	Mechel Steel Group OAO",
"MTN	Vail Resorts, Inc.",
"MTOR	Meritor, Inc.",
"MTOX	Medtox Scientific, Inc.",
"MTP	MLP & Strategic Equity Fund Inc.",
"MTR	Mesa Royalty Trust",
"MTRN	Materion Corporation",
"MTRX	Matrix Service Company",
"MTS	Montgomery Street Income Securities, Inc.",
"MTSC	MTS Systems Corporation",
"MTSL	MER Telemanagement Solutions Ltd.",
"MTSN	Mattson Technology, Inc.",
"MTT	Western Asset Municipal Defined Opportunity Trust Inc",
"MTU	Mitsubishi UFJ Financial Group Inc",
"MTW	Manitowoc Company, Inc. (The)",
"MTX	Minerals Technologies Inc.",
"MTZ	MasTec, Inc.",
"MU	Micron Technology, Inc.",
"MUA	Blackrock MuniAssets Fund, Inc.",
"MUC	Blackrock MuniHoldings California Quality Fund,  Inc.",
"MUE	Blackrock MuniHoldings Quality Fund II, Inc.",
"MUH	Blackrock MuniHoldings Fund II, Inc.",
"MUI	Blackrock Muni Intermediate Duration Fund Inc",
"MUJ	Blackrock MuniHoldings New Jersey Insured Fund, Inc.",
"MUR	Murphy Oil Corporation",
"MUS	Blackrock MuniHoldings Quality Fund, Inc.",
"MUSA	Metals USA Holdings Corp.",
"MUX	McEwen Mining Inc.",
"MVC	MVC Capital",
"MVIS	Microvision, Inc.",
"MVISW	Microvision, Inc.",
"MVO	MV Oil Trust",
"MVT	Blackrock MuniVest Fund II, Inc.",
"MW	Men's Wearhouse, Inc. (The)",
"MWA	MUELLER WATER PRODUCTS",
"MWE	MarkWest Energy Partners, LP",
"MWG	Morgan Stanley",
"MWIV	MWI Veterinary Supply, Inc.",
"MWO	Morgan Stanley",
"MWR	Morgan Stanley",
"MWV	Meadwestvaco Corporation",
"MWW	Monster Worldwide, Inc.",
"MX	MagnaChip Semiconductor Corporation",
"MXE	Mexico Equity and Income Fund, Inc. (The)",
"MXF	Mexico Fund, Inc. (The)",
"MXIM	Maxim Integrated Products, Inc.",
"MXL	MaxLinear, Inc",
"MXT	Maxcom Telecomunicaciones SAB de CV",
"MXWL	Maxwell Technologies, Inc.",
"MY	China Ming Yang Wind Power Group Limited",
"MYC	Blackrock MuniYield California Fund, Inc.",
"MYD	Blackrock MuniYield Fund, Inc.",
"MYE	Myers Industries, Inc.",
"MYF	Blackrock MuniYield Investment Fund",
"MYGN	Myriad Genetics, Inc.",
"MYI	Blackrock MuniYield Quality Fund III, Inc.",
"MYJ	Blackrock MuniYield New Jersey Fund, Inc.",
"MYL	Mylan Inc.",
"MYM	Blackrock MuniYield Michigan Quality Fund II, Inc.",
"MYN	Blackrock MuniYield New York Quality Fund, Inc.",
"MYRG	MYR Group, Inc.",
"MYRX	Myrexis, Inc",
"MZF	Managed Duration Investment Grade Municipal Fund",
"N	Netsuite Inc",
"NABI	Nabi Biopharmaceuticals",
"NAC	Nuveen California Dividend Advantage Municipal Fund",
"NAD	Nuveen Dividend Advantage Municipal Fund",
"NAFC	Nash-Finch Company",
"NAI	AGIC International & Premium Strategy Fund",
"NAII	Natural Alternatives International, Inc.",
"NAN	Nuveen New York Dividend Advantage Municipal Fund",
"NANO	Nanometrics Incorporated",
"NANX	Nanophase Technologies Corporation",
"NASB	NASB Financial Inc.",
"NAT	Nordic American Tankers Limited",
"NATH	Nathan's Famous, Inc.",
"NATI	National Instruments Corporation",
"NATL	National Interstate Corporation",
"NATR	Nature's Sunshine Products, Inc.",
"NAUH	National American University Holdings, Inc.",
"NAV	Navistar International Corporation",
"NAVG	The Navigators Group, Inc.",
"NAVR	Navarre Corporation",
"NAZ	Nuveen Arizona Premium Income Municipal Fund, Inc.",
"NBB	Nuveen Build America Bond Fund",
"NBBC	NewBridge Bancorp",
"NBD	Nuveen Build America Bond Opportunity Fund",
"NBG	National Bank of Greece SA",
"NBIX	Neurocrine Biosciences, Inc.",
"NBL	Noble Energy Inc.",
"NBN	Northeast Bancorp",
"NBR	Nabors Industries Ltd.",
"NBTB	NBT Bancorp Inc.",
"NBTF	NB&T FINANCIAL GROUP INC",
"NC	NACCO Industries, Inc.",
"NCA	Nuveen California Municipal Value Fund, Inc.",
"NCBC	New Century Bancorp, Inc. (NC)",
"NCI	Navigant Consulting, Inc.",
"NCIT	NCI, Inc.",
"NCL	Nuveen Insured California Premium Income Municipal Fund II, In",
"NCMI	National CineMedia, Inc.",
"NCO	Nuveen California Municipal Market Opportunity Fund, Inc.",
"NCP	Nuveen California Performance Plus Municipal Fund, Inc.",
"NCR	NCR Corporation",
"NCS	NCI Building Systems, Inc.",
"NCT	Newcastle Investment Corporation",
"NCTY	The9 Limited",
"NCV	AGIC Convertible & Income Fund",
"NCZ	AGIC Convertible & Income Fund II",
"NDAQ	The NASDAQ OMX Group, Inc.",
"NDRO	Enduro Royalty Trust",
"NDSN	Nordson Corporation",
"NDZ	Nordion Inc.",
"NE	Noble Corporation",
"NEBS	New England Bancshares, Inc.",
"NECB	Northeast Community Bancorp, Inc.",
"NED	Noah Education Holdings Ltd.",
"NEE	NextEra Energy, Inc.",
"NEI	Network Engines, Inc",
"NEM	Newmont Mining Corporation (Holding Company)",
"NEOG	Neogen Corporation",
"NEPT	Neptune Technologies & Bioresources Inc",
"NETC	NET Servicos de Comunicacao S.A.",
"NEU	NewMarket Corporation",
"NEV	Nuveen Enhanced Municipal Value Fund",
"NEWL	NewLead Holdings Ltd.",
"NEWP	Newport Corporation",
"NEWS	NewStar Financial, Inc.",
"NEWT	Newtek Business Services Inc.",
"NEXS	Nexxus Lighting, Inc.",
"NFBK	Northfield Bancorp, Inc.",
"NFEC	NF Energy Saving Corporation",
"NFG	National Fuel Gas Company",
"NFJ	NFJ Dividend, Interest & Premium Strategy Fund",
"NFLX	Netflix, Inc.",
"NFP	National Financial Partners Corporation",
"NFSB	Newport Bancorp, Inc.",
"NFX	Newfield Exploration Company",
"NGG	National Grid Transco, PLC",
"NGL	NGL ENERGY PARTNERS LP",
"NGLS	Targa Resources Partners LP",
"NGPC	NGP Capital Resources Company",
"NGS	Natural Gas Services Group, Inc.",
"NGSX	NeurogesX, Inc.",
"NGT	Eastern American Natural Gas Trust",
"NGZ	AGIC Global Equity & Convertible Income Fund",
"NHI	National Health Investors, Inc.",
"NHTB	New Hampshire Thrift Bancshares, Inc.",
"NI	NiSource, Inc",
"NICE	NICE-Systems Limited",
"NICK	Nicholas Financial, Inc.",
"NIE	AGIC Equity & Convertible Income Fund",
"NIF	Nuveen Premier Municipal Opportunity Fund, Inc.",
"NIHD	NII Holdings, Inc.",
"NILE	Blue Nile, Inc.",
"NIM	Nuveen Select Maturities Municipal Fund",
"NINE	Ninetowns Internet Technology Group Company Limited",
"NIO	Nuveen Municipal Opportunity Fund, Inc.",
"NJ	Nidec Corporation (Nihon Densan Kabushiki Kaisha)",
"NJR	NewJersey Resources Corporation",
"NKA	Niska Gas Storage Partners LLC",
"NKBP	China Nuokang Bio-Pharmaceutical Inc.",
"NKE	Nike, Inc.",
"NKSH	National Bankshares, Inc.",
"NKTR	Nektar Therapeutics",
"NL	NL Industries, Inc.",
"NLNK	NewLink Genetics Corporation",
"NLS	Nautilus Group, Inc. (The)",
"NLSN	Nielsen Holdings N.V.",
"NLST	Netlist, Inc.",
"NLY	Annaly Capital Management Inc",
"NM	Navios Maritime Holdings Inc.",
"NMA	Nuveen Municipal Advantage Fund, Inc.",
"NMAR	Nautilus Marine Acquisition Corp.",
"NMARW	Nautilus Marine Acquisition Corp.",
"NMD	Nuveen Municipal High Income Opportunity Fund",
"NMFC	New Mountain Finance Corporation",
"NMI	Nuveen Municipal Income Fund, Inc.",
"NMM	Navios Maritime Partners LP",
"NMO	Nuveen Municipal Market Opportunity Fund, Inc.",
"NMP	Nuveen Michigan Premium Income Municipal Fund, Inc.",
"NMR	Nomura Holdings Inc ADR",
"NMRX	Numerex Corp.",
"NMT	Nuveen Massachusetts Premium Income Municipal Fund",
"NMY	Nuveen Maryland Premium Income Municipal Fund",
"NNA	Navios Maritime Acquisition Corporation",
"NNA/U	Navios Maritime Acquisition Corporation",
"NNA/WS	Navios Maritime Acquisition Corporation",
"NNBR	NN, Inc.",
"NNC	Nuveen North Carolina Premium Income Municipal Fund",
"NNF	Nuveen New York Premium Income Municipal Fund, Inc.",
"NNI	Nelnet, Inc.",
"NNJ	Nuveen New Jersey Premium Income Municipal Fund, Inc.",
"NNN	National Retail Properties",
"NNP	Nuveen New York Performance Plus Municipal Fund, Inc.",
"NNY	Nuveen New York Municipal Value Fund, Inc.",
"NOA	North American Energy Partners, Inc.",
"NOAH	Noah Holdings Ltd.",
"NOBH	Nobility Homes, Inc.",
"NOC	Northrop Grumman Corporation",
"NOIZ	Micronetics, Inc.",
"NOK	Nokia Corporation",
"NOOF	New Frontier Media, Inc.",
"NOR	Noranda Aluminum Holding Corporation",
"NOV	National-Oilwell, Inc.",
"NOVB	North Valley Bancorp",
"NP	Neenah Paper, Inc.",
"NPBC	National Penn Bancshares, Inc.",
"NPBCO	National Penn Bancshares, Inc.",
"NPC	Nuveen Insured California Premium Income Fund, Inc.",
"NPD	China Nepstar Chain Drugstore Ltd",
"NPF	Nuveen Premier Municipal Income Fund, Inc.",
"NPI	Nuveen Premium Income Municipal Fund, Inc.",
"NPK	National Presto Industries, Inc.",
"NPM	Nuveen Premium Income Municipal Fund II, Inc.",
"NPO	Enpro Industries",
"NPP	Nuveen Performance Plus Municipal Fund, Inc.",
"NPSP	NPS Pharmaceuticals, Inc.",
"NPT	Nuveen Premium Income Municipal Fund IV, Inc.",
"NPTN	NeoPhotonics Corporation",
"NPV	Nuveen Virginia Premium Income Municipal Fund",
"NPX	Nuveen Premium Income Municipal Opportunity Fund",
"NPY	Nuveen Pennsylvania Premium Income Municipal Fund II",
"NQ	NetQin Mobile Inc.",
"NQC	Nuveen California Investment Quality Municipal Fund, Inc.",
"NQI	Nuveen Quality Municipal Fund, Inc.",
"NQJ	Nuveen New Jersey Investment Quality Municipal Fund, Inc.",
"NQM	Nuveen Investment Quality Municipal Fund, Inc.",
"NQN	Nuveen New York Investment Quality Municipal Fund, Inc.",
"NQP	Nuveen Pennsylvania Investment Quality Municipal Fund, Inc.",
"NQS	Nuveen Select Quality Municipal Fund, Inc.",
"NQU	Nuveen Quality Income Municipal Fund, Inc.",
"NR	Newpark Resources, Inc.",
"NRC	National Rural Utilities Cooperative Finance Corp",
"NRCI	National Research Corporation",
"NRF	Northstar Realty Finance Corp.",
"NRG	NRG Energy, Inc.",
"NRGM	Inergy Midstream, L.P.",
"NRGY	Inergy, L.P.",
"NRIM	Northrim BanCorp Inc",
"NRP	Natural Resource Partners LP",
"NRT	North European Oil Royality Trust",
"NRU	National Rural Utilities Cooperative Finance Corp",
"NS	Nustar Energy L.P.",
"NSC	Norfolk Souther Corporation",
"NSEC	National Security Group, Inc.",
"NSH	Nustar GP Holdings, LLC",
"NSIT	Insight Enterprises, Inc.",
"NSL	Nuveen Senior Income Fund",
"NSM	Nationstar Mortgage Holdings Inc.",
"NSP	Insperity, Inc.",
"NSPH	Nanosphere, Inc.",
"NSR	Neustar, Inc.",
"NSSC	NAPCO Security Technologies, Inc.",
"NST	NSTAR",
"NSYS	Nortech Systems Incorporated",
"NTAP	NetApp, Inc.",
"NTC	Nuveen Connecticut Premium Income Municipal Fund",
"NTCT	NetScout Systems, Inc.",
"NTE	Nam Tai Electronics, Inc.",
"NTES	Netease.com, Inc.",
"NTG	Tortoise MLP Fund, Inc.",
"NTGR	NETGEAR, Inc.",
"NTIC	Northern Technologies International Corporation",
"NTK	Nortek Inc.",
"NTL	Nortel Inversora SA, ADR",
"NTLS	NTELOS Holdings Corp.",
"NTRI	NutriSystem Inc",
"NTRS	Northern Trust Corporation",
"NTSC	National Technical Systems, Inc.",
"NTSP	NetSpend Holdings, Inc.",
"NTT	Nippon Telegraph and Telephone Corporation",
"NTWK	NetSol Technologies Inc.",
"NTX	Nuveen Texas Quality Income Municipal Fund",
"NTZ	Natuzzi, S.p.A.",
"NU	Northeast Utilities",
"NUAN	Nuance Communications, Inc.",
"NUC	Nuveen California Quality Income Municipal Fund, Inc.",
"NUCL	iShares S&P Global Nuclear Index Fund",
"NUE	Nucor Corporation",
"NUM	Nuveen Michigan Quality Income Municipal Fund, Inc.",
"NUN	Nuveen New York Quality Income Municipal Fund, Inc.",
"NUO	Nuveen Ohio Quality Income Municipal Fund, Inc.",
"NURO	NeuroMetrix, Inc.",
"NUS	Nu Skin Enterprises, Inc.",
"NUTR	Nutraceutical International Corporation",
"NUV	Nuveen Municipal Value Fund, Inc.",
"NUVA	NuVasive, Inc.",
"NUW	Nuveen Municipal Value Fund, Inc.",
"NVAX	Novavax, Inc.",
"NVC	Nuveen California Select Quality Municipal Fund, Inc.",
"NVDA	NVIDIA Corporation",
"NVDQ	Novadaq Technologies Inc",
"NVE	NV Energy, Inc",
"NVEC	NVE Corporation",
"NVGN	Novogen Limited",
"NVLS	Novellus Systems, Inc.",
"NVMI	Nova Measuring Instruments Ltd.",
"NVN	Nuveen New York Select Quality Municipal Fund, Inc.",
"NVO	Novo Nordisk A/S",
"NVR	NVR, Inc.",
"NVS	Novartis AG",
"NVSL	Naugatuck Valley Financial Corporation",
"NVTL	Novatel Wireless, Inc.",
"NWBI	Northwest Bancshares, Inc.",
"NWE	NorthWestern Corporation",
"NWFL	Norwood Financial Corp.",
"NWK	Network Equipment Technologies, Inc.",
"NWL	Newell Rubbermaid Inc.",
"NWLI	National Western Life Insurance Company",
"NWN	Northwest Natural Gas Company",
"NWPX	Northwest Pipe Company",
"NWS	News Corporation",
"NWSA	News Corporation",
"NWY	New York & Company, Inc.",
"NX	Quanex Building Products Corporation",
"NXC	Nuveen Insured California Select Tax-Free Income Portfolio",
"NXN	Nuveen Insured New York Select Tax-Free Income Portfolio",
"NXP	Nuveen Select Tax Free Income Portfolio",
"NXPI	NXP Semiconductors N.V.",
"NXQ	Nuveen Select Tax Free Income Portfolio II",
"NXR	Nuveen Select Tax Free Income Portfolio III",
"NXST	Nexstar Broadcasting Group, Inc.",
"NXTM	NxStage Medical, Inc.",
"NXY	Nexen, Inc.",
"NYB	New York Community Bancorp, Inc.",
"NYMT	New York Mortgage Trust, Inc.",
"NYMX	Nymox Pharmaceutical Corporation",
"NYNY	Empire Resorts, Inc.",
"NYT	New York Times Company (The)",
"NYX	NYSE Euronext, Inc.",
"NZT	Telecom Corporation of New Zealand Limited",
"O	Realty Income Corporation",
"OABC	OmniAmerican Bancorp, Inc.",
"OAS	Oasis Petroleum Inc.",
"OB	OneBeacon Insurance Group, Ltd.",
"OBAF	OBA Financial Services, Inc.",
"OBAS	Optibase Ltd.",
"OBCI	Ocean Bio-Chem, Inc.",
"OC	Owens Corning Inc",
"OC/WS/B	Owens Corning Inc",
"OCC	Optical Cable Corporation",
"OCFC	OceanFirst Financial Corp.",
"OCLR	Oclaro, Inc.",
"OCLS	Oculus Innovative Sciences, Inc.",
"OCN	Ocwen Financial Corporation",
"OCR	Omnicare, Inc.",
"OCZ	OCZ Technology Group Inc",
"ODC	Oil-Dri Corporation Of America",
"ODFL	Old Dominion Freight Line, Inc.",
"ODP	Office Depot, Inc.",
"OEH	Orient-Express Hotels Ltd.",
"OFC	Corporate Office Properties Trust",
"OFED	Oconee Federal Financial Corp.",
"OFG	Oriental Financial Group, Inc.",
"OFIX	Orthofix International N.V.",
"OFLX	Omega Flex, Inc.",
"OGE	OGE Energy Corporation",
"OGXI	OncoGenex Pharmaceuticals Inc.",
"OHI	Omega Healthcare Investors, Inc.",
"OI	Owens-Illinois, Inc.",
"OIA	Invesco Municipal Income Opportunities Trust",
"OIB	Invesco Municipal Income Opportunities Trust II",
"OIC	Invesco Municipal Income Opportunities Trust III",
"OII	Oceaneering International, Inc.",
"OIIM	O2Micro International Limited",
"OILT	Oiltanking Partners, L.P.",
"OINK	Tianli Agritech, Inc.",
"OIS	Oil States International, Inc.",
"OKE	ONEOK, Inc.",
"OKS	ONEOK Partners, L.P.",
"OKSB	Southwest Bancorp, Inc.",
"OKSBP	Southwest Bancorp, Inc.",
"OLBK	Old Line Bancshares, Inc.",
"OLCB	Ohio Legacy Corporation",
"OLN	Olin Corporation",
"OLP	One Liberty Properties, Inc.",
"OMAB	Grupo Aeroportuario del Centro Norte S.A.B. de C.V.",
"OMC	Omnicom Group Inc.",
"OMCL	Omnicell, Inc.",
"OME	Omega Protein Corporation",
"OMER	Omeros Corporation",
"OMEX	Odyssey Marine Exploration, Inc.",
"OMG	OM Group, Inc.",
"OMI	Owens & Minor, Inc.",
"OMN	OMNOVA Solutions Inc.",
"OMPI	Obagi Medical Products, Inc.",
"OMX	Officemax Incorporated",
"ONB	Old National Bancorp Capital Trust I",
"ONCY	Oncolytics Biotech, Inc.",
"ONE	Higher One Holdings, Inc.",
"ONEQ	Fidelity Nasdaq Composite Index Tracking Stock",
"ONFC	Oneida Financial Corp.",
"ONNN	ON Semiconductor Corporation",
"ONSM	Onstream Media Corporation",
"ONTY	Oncothyreon Inc.",
"ONVI	Onvia, Inc.",
"ONXX	ONYX Pharmaceuticals, Inc.",
"OPAY	Official Payments Holdings, Inc.",
"OPEN	OpenTable, Inc.",
"OPHC	OptimumBank Holdings, Inc.",
"OPK	Opko Health Inc",
"OPLK	Oplink Communications, Inc.",
"OPNT	OPNET Technologies Inc.",
"OPOF	Old Point Financial Corporation",
"OPTR	Optimer Pharmaceuticals, Inc.",
"OPTT	Ocean Power Technologies, Inc.",
"OPWV	Openwave Systems Inc",
"OPXA	Opexa Therapeutics, Inc.",
"OPXAW	Opexa Therapeutics, Inc.",
"OPXT	Opnext, Inc.",
"OPY	Oppenheimer Holdings, Inc.",
"ORA	Ormat Technologies, Inc.",
"ORB	Orbital Sciences Corporation",
"ORBC	ORBCOMM Inc.",
"ORBK	Orbotech Ltd.",
"ORBT	Orbit International Corporation",
"ORCC	Online Resources Corporation",
"ORCL	Oracle Corporation",
"ORCT	Orckit Communications, Limited",
"OREX	Orexigen Therapeutics, Inc.",
"ORI	Old Republic International Corporation",
"ORIG	Ocean Rig UDW Inc.",
"ORIT	Oritani Financial Corp.",
"ORLY	O'Reilly Automotive, Inc.",
"ORN	Orion Marine Group Inc",
"ORRF	Orrstown Financial Services Inc",
"OSBC	Old Second Bancorp, Inc.",
"OSBCP	Old Second Bancorp, Inc.",
"OSG	Overseas Shipholding Group, Inc.",
"OSH	Orchard Supply Hardware Stores Corporation",
"OSHC	Ocean Shore Holding Co.",
"OSIR	Osiris Therapeutics, Inc.",
"OSIS	OSI Systems, Inc.",
"OSK	Oshkosh Truck Corporation",
"OSM	SLM Corporation",
"OSN	Ossen Innovation Co., Ltd.",
"OSTK	Overstock.com, Inc.",
"OSUR	OraSure Technologies, Inc.",
"OTEX	Open Text Corporation",
"OTIV	On Track Innovations Ltd",
"OTT	Otelco, Inc.",
"OTTR	Otter Tail Corporation",
"OUTD	Outdoor Channel Holdings, Inc.",
"OVBC	Ohio Valley Banc Corp.",
"OVLY	Oak Valley Bancorp (CA)",
"OVRL	Overland Storage, Inc.",
"OVTI	OmniVision Technologies, Inc.",
"OWW	Orbitz Worldwide, Inc.",
"OXBT	Oxygen Biotherapeutics, Inc.",
"OXF	Oxford Resource Partners, LP",
"OXGN	OXiGENE, Inc.",
"OXLC	Oxford Lane Capital Corp.",
"OXM	Oxford Industries, Inc.",
"OXY	Occidental Petroleum Corporation",
"OYOG	OYO Geospace Corporation",
"OZM	Och-Ziff Capital Management Group LLC",
"OZRK	Bank of the Ozarks",
"P	Pandora Media, Inc.",
"PAA	Plains All American Pipeline, L.P.",
"PAAS	Pan American Silver Corp.",
"PAC	Grupo Aeroportuario Del Pacifico, S.A. de C.V.",
"PACB	Pacific Biosciences of California, Inc.",
"PACD	Pacific Drilling S.A.",
"PACQ	Prime Acquisition Corp.",
"PACQU	Prime Acquisition Corp.",
"PACQW	Prime Acquisition Corp.",
"PACR	Pacer International, Inc.",
"PACW	PacWest Bancorp",
"PAG	Penske Automotive Group, Inc.",
"PAGG	PowerShares Global Agriculture Portfolio",
"PAI	Pacific American Income Shares, Inc.",
"PAM	Pampa Energia S.A.",
"PANL	Universal Display Corporation",
"PAR	PAR Technology Corporation",
"PARL	Parlux Fragrances, Inc.",
"PATH	NuPathe Inc.",
"PATK	Patrick Industries, Inc.",
"PATR	Patriot Transportation Holding, Inc.",
"PAY	Verifone Systems, Inc.",
"PAYX	Paychex, Inc.",
"PB	Prosperity Bancshares, Inc.",
"PBCT	People's United Financial, Inc.",
"PBH	Prestige Brand Holdings, Inc.",
"PBHC	Pathfinder Bancorp, Inc.",
"PBI	Pitney Bowes Inc",
"PBIB	Porter Bancorp, Inc.",
"PBIO	Pressure BioSciences, Inc.",
"PBIP	Prudential Bancorp, Inc. of Pennsylvania",
"PBNY	Provident New York Bancorp",
"PBR	Petroleo Brasileiro S.A.- Petrobras",
"PBR/A	Petroleo Brasileiro S.A.- Petrobras",
"PBSK	Poage Bankshares, Inc.",
"PBT	Permian Basin Royalty Trust",
"PBY	Pep Boys-Manny, Moe & Jack (The)",
"PC	Panasonic Corporation",
"PCAR	PACCAR Inc.",
"PCBC	Pacific Capital Bancorp",
"PCBK	Pacific Continental Corporation (Ore)",
"PCCC	PC Connection, Inc.",
"PCF	Putnam High Income Bond Fund",
"PCG	Pacific Gas & Electric Co.",
"PCH	Potlatch Corporation",
"PCK	Pimco California Municipal Income Fund II",
"PCL	Plum Creek Timber Company, Inc.",
"PCLN	priceline.com Incorporated",
"PCM	PIMCO Commercial Mortgage Securities Trust, Inc.",
"PCN	Pimco Corporate & Income Stategy Fund",
"PCO	Pendrell Corporation",
"PCOM	Points International, Ltd.",
"PCP	Precision Castparts Corporation",
"PCQ	PIMCO California Municipal Income Fund",
"PCRX	Pacira Pharmaceuticals, Inc.",
"PCS	MetroPCS Communications, Inc.",
"PCTI	PC-Tel, Inc.",
"PCX	Patriot Coal Corporation",
"PCYC	Pharmacyclics, Inc.",
"PCYO	Pure Cycle Corporation",
"PDCO	Patterson Companies, Inc.",
"PDEX	Pro-Dex, Inc.",
"PDFS	PDF Solutions, Inc.",
"PDII	PDI, Inc.",
"PDLI	PDL BioPharma, Inc.",
"PDM	Piedmont Office Realty Trust, Inc.",
"PDS	Precision Drilling Corporation",
"PDT	John Hancock Premium Dividend Fund",
"PEB	Pebblebrook Hotel Trust",
"PEBK	Peoples Bancorp of North Carolina, Inc.",
"PEBO	Peoples Bancorp Inc.",
"PEDH	Peoples Educational Holdings, Inc.",
"PEER	IntelePeer, Inc.",
"PEET	Peet's Coffee & Tea, Inc.",
"PEG	Public Service Enterprise Group Incorporated",
"PEGA	Pegasystems Inc.",
"PEI	Pennsylvania Real Estate Investment Trust",
"PEIX	Pacific Ethanol, Inc.",
"PENN	Penn National Gaming, Inc.",
"PENX	Penford Corporation",
"PEO	Petroleum Resources Corporation",
"PEOP	Peoples Federal Bancshares, Inc.",
"PEP	Pepsico, Inc.",
"PER	SandRidge Permian Trust",
"PERF	Perfumania Holdings, Inc",
"PERI	Perion Network Ltd",
"PERY	Perry Ellis International Inc.",
"PESI	Perma-Fix Environmental Services, Inc.",
"PETD	Petroleum Development Corporation",
"PETM	PetSmart, Inc",
"PETS	PetMed Express, Inc.",
"PFBC	Preferred Bank",
"PFBI	Premier Financial Bancorp, Inc.",
"PFBX	Peoples Financial Corporation",
"PFCB	P.F.Chang's China Bistro, Inc.",
"PFD	Flaherty & Crumrine Preferred Income Fund Incorporated",
"PFE	Pfizer, Inc.",
"PFG	Principal Financial Group Inc",
"PFH	CABCO Series 2004-101 Trust",
"PFIN	P & F Industries, Inc.",
"PFK	Prudential Financial, Inc.",
"PFL	PIMCO Income Strategy Fund",
"PFLT	PennantPark Floating Rate Capital Ltd.",
"PFN	PIMCO Income Strategy Fund II",
"PFO	Flaherty & Crumrine Preferred Income Opportunity Fund Inc",
"PFS	Provident Financial Services, Inc",
"PFSW	PFSweb, Inc.",
"PFX	Phoenix Companies, Inc. (The)",
"PG	Procter & Gamble Company (The)",
"PGC	Peapack-Gladstone Financial Corporation",
"PGH	Pengrowth Energy Corporation",
"PGI	PTEK Holdings, Inc.",
"PGN	Progress Energy, Inc.",
"PGNX	Progenics Pharmaceuticals Inc.",
"PGP	Pimco Global Stocksplus & Income Fund",
"PGR	Progressive Corporation (The)",
"PGTI	PGT, Inc.",
"PH	Parker-Hannifin Corporation",
"PHA	PulteGroup, Inc.",
"PHD	Pioneer Floating Rate Trust",
"PHG	Koninklijke Philips Electronics, N.V.",
"PHH	PHH Corp",
"PHI	Philippine Long Distance Telephone Company",
"PHII	PHI, Inc.",
"PHIIK	PHI, Inc.",
"PHK	Pimco High Income Fund",
"PHM	PulteGroup, Inc.",
"PHMD	PhotoMedex, Inc.",
"PHR	Prudential Financial, Inc.",
"PHT	Pioneer High Income Trust",
"PHX	Panhandle Royalty Company",
"PIA	Invesco Municipal Premium Income Trust",
"PICO	PICO Holdings Inc.",
"PII	Polaris Industries Inc.",
"PIJ	Merrill Lynch Depositor, Inc.",
"PIKE	Pike Electric Corp.",
"PIM	Putnam Master Intermediate Income Trust",
"PIR	Pier 1 Imports, Inc.",
"PIS	Merrill Lynch Depositor, Inc.",
"PIY	Merrill Lynch Depositor, Inc.",
"PJA	Preferred Plus Trust Ser QWS 2 Tr Ctf",
"PJC	Piper Jaffray Companies",
"PJI	PPlus Trust",
"PJL	Preferred Plus Trust Ser QWS 2 Tr Ctf",
"PJR	Merrill Lynch Depositor, Inc.",
"PJS	Preferred Plus Trust Ser QWS 2 Tr Ctf",
"PKBK	Parke Bancorp, Inc.",
"PKD	Parker Drilling Company",
"PKE	Park Electrochemical Corporation",
"PKG	Packaging Corporation of America",
"PKH	Merrill Lynch Depositor, Inc.",
"PKI	PerkinElmer, Inc.",
"PKJ	Merrill Lynch Depositor, Inc.",
"PKK	Merrill Lynch Depositor, Inc.",
"PKO	Pimco Income Opportunity Fund",
"PKOH	Park-Ohio Holdings Corp.",
"PKOL	PowerShares Global Coal Portfolio",
"PKT	Procera Networks, Inc.",
"PKX	POSCO",
"PKY	Parkway Properties, Inc.",
"PL	Protective Life Corporation",
"PLAB	Photronics, Inc.",
"PLBC	Plumas Bancorp",
"PLCC	Paulson Capital Corp.",
"PLCE	The Children's Place Retail Stores, Inc.",
"PLCM	Polycom, Inc.",
"PLD	AMB Property Corporation",
"PLFE	Presidential Life Corporation",
"PLL	Pall Corporation",
"PLMT	Palmetto Bancshares, Inc. (SC)",
"PLNR	Planar Systems, Inc.",
"PLOW	Douglas Dynamics, Inc.",
"PLP	Protective Life Corporation",
"PLPC	Preformed Line Products Company",
"PLT	Plantronics, Inc.",
"PLTM	First Trust Exchange-Traded Fund II First Trust ISE Global Platinum Index Fund",
"PLUG	Plug Power, Inc.",
"PLUS	Eplus Inc.",
"PLV	PPL Corporation",
"PLXS	Plexus Corp.",
"PLXT	PLX Technology, Inc.",
"PM	Philip Morris International Inc",
"PMBC	Pacific Mercantile Bancorp",
"PMC	Pharmerica Corporation",
"PMCS	PMC - Sierra, Inc.",
"PMD	Psychemedics Corporation",
"PMF	PIMCO Municipal Income Fund",
"PMFG	PMFG, Inc.",
"PML	Pimco Municipal Income Fund II",
"PMM	Putnam Managed Municipal Income Trust",
"PMNA	PowerShares MENA Frontier Countries Portfolio",
"PMO	Putnam Municipal Opportunities Trust",
"PMT	PennyMac Mortgage Investment Trust",
"PMTC	Parametric Technology Corporation",
"PMTI	Palomar Medical Technologies, Inc.",
"PMX	PIMCO Municipal Income Fund III",
"PNBC	Princeton National Bancorp, Inc.",
"PNBK	Patriot National Bancorp Inc.",
"PNC	PNC Financial Services Group, Inc. (The)",
"PNC/WS	PNC Financial Services Group, Inc. (The)",
"PNCL	Pinnacle Airlines Corp.",
"PNF	PIMCO New York Municipal Income Fund",
"PNFP	Pinnacle Financial Partners, Inc.",
"PNG	PAA Natural Gas Storage, L.P.",
"PNH	PNC Cap Tr E",
"PNI	Pimco New York Municipal Income Fund II",
"PNK	Pinnacle Entertainment, Inc.",
"PNM	PNM Resources, Inc. (Holding Co.)",
"PNNT	PennantPark Investment Corporation",
"PNQI	PowerShares NASDAQ Internet Portfolio",
"PNR	Pentair, Inc.",
"PNRA	Panera Bread Company",
"PNRG	PrimeEnergy Corporation",
"PNSN	Penson Worldwide, Inc.",
"PNTR	Pointer Telocation Ltd.",
"PNU	PNC Financial Services Group, Inc. (The)",
"PNW	Pinnacle West Capital Corporation",
"PNX	Phoenix Companies, Inc. (The)",
"PNY	Piedmont Natural Gas Company, Inc.",
"PODD	Insulet Corporation",
"POL	PolyOne Corporation",
"POM	Potomac Electric Power Company",
"POOL	Pool Corporation",
"POPE	Pope Resources",
"POR	Portland General Electric Company",
"POST	Post Holdings, Inc.",
"POT	Potash Corporation of Saskatchewan Inc.",
"POWI	Power Integrations, Inc.",
"POWL	Powell Industries, Inc.",
"POWR	PowerSecure International, Inc",
"POZN	Pozen, Inc.",
"PPBI	Pacific Premier Bancorp Inc",
"PPC	Pilgrim's Pride Corporation",
"PPG	PPG Industries, Inc.",
"PPHM	Peregrine Pharmaceuticals Inc.",
"PPL	PPL Corporation",
"PPO	Polypore International Inc",
"PPP	Primero Mining Corp",
"PPR	ING Prime Rate Trust",
"PPS	Post Properties, Inc.",
"PPT	Putnam Premier Income Trust",
"PQ	Petroquest Energy Inc",
"PRA	ProAssurance Corporation",
"PRAA	Portfolio Recovery Associates, Inc.",
"PRAN	Prana Biotechnology Ltd",
"PRCP	Perceptron, Inc.",
"PRE	PartnerRe Ltd.",
"PRFT	Perficient, Inc.",
"PRFZ	PowerShares FTSE RAFI US 1500 Small-Mid Portfolio",
"PRGN	Paragon Shipping Inc.",
"PRGO	Perrigo Company",
"PRGS	Progress Software Corporation",
"PRGX	PRGX Global, Inc.",
"PRI	Primerica, Inc.",
"PRIM	Primoris Services Corporation",
"PRIS	Promotora De Informaciones SA",
"PRIS/B	Promotora De Informaciones SA",
"PRKR	ParkerVision, Inc.",
"PRLB	Proto Labs, Inc.",
"PRLS	Peerless Systems Corporation",
"PRMW	Primo Water Corporation",
"PRO	PROS Holdings, Inc.",
"PROJ	Deltek, Inc.",
"PROV	Provident Financial Holdings, Inc.",
"PRPH	ProPhase Labs, Inc.",
"PRSC	The Providence Service Corporation",
"PRST	Presstek, Inc.",
"PRTS	U.S. Auto Parts Network, Inc.",
"PRU	Prudential Financial, Inc.",
"PRWT	Premier West Bancorp",
"PRX	Pharmaceutical Resources, Inc.",
"PRXI	Premier Exhibitions, Inc.",
"PRXL	PAREXEL International Corporation",
"PSA	Public Storage",
"PSAU	PowerShares Global Gold & Precious Metals Portfolio",
"PSB	PS Business Parks, Inc.",
"PSBH	PSB Holdings, Inc.",
"PSCC	PowerShares Exchange-Traded Fund Trust II PowerShares S&P SmallCap Consumer Staples Portfolio",
"PSCD	PowerShares Exchange-Traded Fund Trust II PowerShares S&P SmallCap Consumer Discretionary Portfolio",
"PSCE	PowerShares Exchange-Traded Fund Trust II PowerShares S&P SmallCap Energy Portfolio",
"PSCH	PowerShares Exchange-Traded Fund Trust II PowerShares S&P SmallCap Health Care Portfolio",
"PSCI	PowerShares Exchange-Traded Fund Trust II PowerShares S&P SmallCap Industrials Portfolio",
"PSCT	PowerShares Exchange-Traded Fund Trust II PowerShares S&P SmallCap Information Technology Portfolio",
"PSCU	PowerShares Exchange-Traded Fund Trust II PowerShares S&P SmallCap Utilities Portfolio",
"PSDV	pSivida Corp.",
"PSE	Pioneer Southwest Energy Partners L.P.",
"PSEC	Prospect Capital Corporation",
"PSEM	Pericom Semiconductor Corporation",
"PSF	Cohen & Steers Select Preferred and Income Fund, Inc.",
"PSMT	PriceSmart, Inc.",
"PSO	Pearson, Plc",
"PSOF	Pansoft Company Limited",
"PSS	Collective Brands, Inc.",
"PSSI	PSS World Medical Inc.",
"PSTB	Park Sterling Bank",
"PSTI	Pluristem Therapeutics, Inc.",
"PSTL	PowerShares Global Steel Portfolio",
"PSTR	PostRock Energy Corporation",
"PSUN	Pacific Sunwear of California, Inc.",
"PSW	Blackrock Preferred and Corporate Income Strategies Fund Inc",
"PSY	BlackRock Credit Allocation Income Trust I, Inc",
"PT	Portugal Telecom SGPS, S.A .",
"PTEK	PokerTek, Inc.",
"PTEN	Patterson-UTI Energy, Inc.",
"PTGI	Primus Telecommunications Group Inc.",
"PTI	Patni Computer Systems Limited",
"PTIE	Pain Therapeutics",
"PTIX	Performance Technologies, Incorporated",
"PTNR	Partner Communications Company Ltd.",
"PTNT	Internet Patents Corporation",
"PTP	Platinum Underwriters Holdings, Ltd",
"PTR	PetroChina Company Limited",
"PTRY	The Pantry, Inc.",
"PTSI	P.A.M. Transportation Services, Inc.",
"PTSX	Point.360",
"PTY	Pimco Corporate & Income Opportunity Fund",
"PUK	Prudential Public Limited Company",
"PULB	Pulaski Financial Corp.",
"PULS	Pulse Electronics Corporation",
"PURE	PURE Bioscience, Inc.",
"PVA	Penn Virginia Corporation",
"PVD	Administradora de Fondos de Pensiones-Provida, S.A.",
"PVFC	PVF Capital Corp.",
"PVG	Pretium Resources, Inc.",
"PVH	PVH Corp.",
"PVR	Penn Virginia Resource Partners LP",
"PVSW	Pervasive Software Inc.",
"PVTB	PrivateBancorp, Inc.",
"PVTBP	PrivateBancorp, Inc.",
"PVX	Provident Energy Ltd.",
"PWAV	Powerwave Technologies, Inc.",
"PWE	Penn West Petroleum Ltd",
"PWER	Power-One, Inc.",
"PWND	PowerShares Global Wind Energy Portfolio",
"PWOD	Penns Woods Bancorp, Inc.",
"PWR	Quanta Services, Inc.",
"PWRD	Perfect World Co., Ltd.",
"PWX	Providence and Worcester Railroad Company",
"PX	Praxair, Inc.",
"PXD	Pioneer Natural Resources Company",
"PXLW	Pixelworks, Inc.",
"PXP	Plains Exploration & Production Company",
"PYA	PPlus Trust",
"PYB	PPlus Trust",
"PYC	PPlus Trust",
"PYG	PPlus Trust",
"PYJ	PPlus Trust",
"PYK	PPlus Trust",
"PYL	PPlus Trust",
"PYN	PIMCO New York Municipal Income Fund III",
"PYS	PPlus Trust",
"PYT	PPlus Trust",
"PYV	PPlus Trust",
"PYY	Merrill Lynch Depositor, Inc.",
"PZB	Merrill Lynch Depositor, Inc.",
"PZC	PIMCO California Municipal Income Fund III",
"PZE	Petrobras Argentina S.A.",
"PZN	Pzena Investment Management Inc",
"PZZA	Papa John'S International, Inc.",
"PZZI	Pizza Inn Holdings, Inc.",
"QABA	First Trust NASDAQ ABA Community Bank Index Fund",
"QADA	QAD Inc.",
"QADB	QAD Inc.",
"QBAK	Qualstar Corporation",
"QCCO	QC Holdings, Inc.",
"QCLN	First Trust NASDAQ Clean Edge U.S. Liquid Series Index Fund",
"QCOM	QUALCOMM Incorporated",
"QCOR	Questcor Pharmaceuticals, Inc.",
"QCRH	QCR Holdings, Inc.",
"QDEL	Quidel Corporation",
"QEP	QEP Resources, Inc.",
"QGEN	Qiagen N.V.",
"QIHU	Qihoo 360 Technology Co. Ltd.",
"QKLS	QKL Stores, Inc.",
"QLGC	QLogic Corporation",
"QLIK	Qlik Technologies Inc.",
"QLTI	QLT Inc.",
"QLTY	Quality Distribution, Inc.",
"QNST	QuinStreet, Inc.",
"QQEW	First Trust NASDAQ-100 Equal Weighted Index Fund",
"QQQ	PowerShares QQQ Trust, Series 1",
"QQQC	Global X NASDAQ China Technology ETF",
"QQQM	Global X Funds Global X NASDAQ 400 Mid Cap ETF",
"QQQV	Global X Funds Global X NASDAQ 500 ETF",
"QQQX	NASDAQ Premium Income and Growth Fund Inc.",
"QQXT	First Trust NASDAQ-100 Ex-Technology Sector Index Fund",
"QRE	QR Energy, LP",
"QSFT	Quest Software, Inc.",
"QSII	Quality Systems, Inc.",
"QTEC	First Trust NASDAQ-100-Technology Sector Index Fund",
"QTM	Quantum Corporation",
"QTWW	Quantum Fuel Systems Technologies Worldwide, Inc.",
"QUAD	Quad Graphics, Inc",
"QUIK	QuickLogic Corporation",
"QXM	Qiao Xing Mobile Communication Co., Ltd.",
"R	Ryder System, Inc.",
"RA	RailAmerica, Inc.",
"RAD	Rite Aid Corporation",
"RADA	Rada Electronics Industries Limited",
"RAH	Ralcorp Holdings, Inc.",
"RAI	Reynolds American Inc",
"RAIL	Freightcar America, Inc.",
"RAND	Rand Capital Corporation",
"RAS	RAIT Financial Trust",
"RATE	Bankrate, Inc.",
"RAVN	Raven Industries, Inc.",
"RAX	Rackspace Hosting, Inc",
"RBA	Ritchie Bros. Auctioneers Incorporated",
"RBC	Regal Beloit Corporation",
"RBCAA	Republic Bancorp, Inc.",
"RBCN	Rubicon Technology, Inc.",
"RBN	Robbins & Myers, Inc.",
"RBNF	Rurban Financial Corp",
"RBPAA	Royal Bancshares of Pennsylvania, Inc.",
"RBS	Royal Bank Scotland Group Plc",
"RC	Grupo Radio Centro, S.A. de C.V.",
"RCI	Rogers Communication, Inc.",
"RCII	Rent-A-Center Inc.",
"RCKB	Rockville Financial, Inc.",
"RCKY	Rocky Brands, Inc.",
"RCL	Royal Caribbean Cruises Ltd.",
"RCMT	RCM Technologies, Inc.",
"RCON	Recon Technology, Ltd.",
"RCS	RCM Strategic Global Government Fund, Inc.",
"RDA	RDA Microelectronics, Inc.",
"RDC	Rowan Companies, Inc.",
"RDCM	Radcom Ltd.",
"RDEA	Ardea Biosciences, Inc.",
"RDEN	Elizabeth Arden, Inc.",
"RDI	Reading International Inc",
"RDIB	Reading International Inc",
"RDK	Ruddick Corporation",
"RDN	Radian Group Inc.",
"RDNT	RadNet, Inc.",
"RDS/A	Royal Dutch Shell PLC",
"RDS/B	Royal Dutch Shell PLC",
"RDWR	Radware Ltd.",
"RDY	Dr. Reddy's Laboratories Ltd",
"RE	Everest Re Group, Ltd.",
"RECN	Resources Connection, Inc.",
"RECV	Recovery Energy, Inc.",
"REDF	Rediff.com India Limited",
"REED	Reeds, Inc.",
"REFR	Research Frontiers Incorporated",
"REG	Regency Centers Corporation",
"REGI	Renewable Energy Group, Inc.",
"REGN	Regeneron Pharmaceuticals, Inc.",
"REIS	Reis, Inc",
"RELL	Richardson Electronics, Ltd.",
"RELV	Reliv' International, Inc.",
"REN	Resolute Energy Corporation",
"REN/WS	Resolute Energy Corporation",
"RENN	Renren Inc.",
"RENT	Rentrak Corporation",
"RES	RPC, Inc.",
"REV	Revlon, Inc.",
"REVU	The Princeton Review, Inc.",
"REX	REX American Resources Corporation",
"REXI	Resource America, Inc.",
"REXX	Rex Energy Corporation",
"RF	Regions Financial Corporation",
"RFI	Cohen & Steers Total Return Realty Fund, Inc.",
"RFIL	RF Industries, Ltd.",
"RFMD	RF Micro Devices, Inc.",
"RFMI	RF Monolithics, Inc.",
"RGA	Reinsurance Group of America, Incorporated",
"RGC	Regal Entertainment Group",
"RGCO	RGC Resources Inc.",
"RGDX	Response Genetics, Inc.",
"RGEN	Repligen Corporation",
"RGLD	Royal Gold, Inc.",
"RGP	Regency Energy Partners LP",
"RGR	Sturm, Ruger & Company, Inc.",
"RGS	Regis Corporation",
"RHI	Robert Half International Inc.",
"RHT	Red Hat, Inc.",
"RICK	Rick's Cabaret International, Inc.",
"RIG	Transocean Inc.",
"RIGL	Rigel Pharmaceuticals, Inc.",
"RIMG	Rimage Corporation",
"RIMM	Research in Motion Limited",
"RIO	Rio Tinto Plc",
"RIT	LMP Real Estate Income Fund Inc",
"RITT	RIT Technologies Ltd.",
"RIVR	River Valley Bancorp.",
"RJET	Republic Airways Holdings, Inc.",
"RJF	Raymond James Financial, Inc.",
"RKT	Rock-Tenn Company",
"RL	Ralph Lauren Corporation",
"RLD	RealD Inc",
"RLH	Red Lion Hotels Corporation",
"RLI	RLI Corp.",
"RLJ	RLJ Lodging Trust",
"RLOC	ReachLocal, Inc.",
"RLOG	Rand Logistics, Inc.",
"RMBS	Rambus, Inc.",
"RMCF	Rocky Mountain Chocolate Factory, Inc.",
"RMD	ResMed Inc.",
"RMKR	Rainmaker Systems, Inc.",
"RMT	Royce Micro-Cap Trust, Inc.",
"RMTI	Rockwell Medical Technologies, Inc.",
"RMTR	Ramtron International Corporation",
"RNDY	Roundy's, Inc.",
"RNE	Morgan Stanley Eastern Europe Fund, Inc.",
"RNET	RigNet, Inc.",
"RNF	Rentech Nitrogen Partners, L.P.",
"RNIN	Wireless Ronin Technologies, Inc.",
"RNO	Rhino Resource Partners LP",
"RNP	Cohen & Steers Reit and Preferred Income Fund Inc",
"RNR	RenaissanceRe Holdings Ltd.",
"RNST	Renasant Corporation",
"RNWK	RealNetworks, Inc.",
"ROC	Rockwood Holdings, Inc.",
"ROCK	Gibraltar Industries, Inc.",
"ROCM	Rochester Medical Corporation",
"RODM	Rodman & Renshaw Capital Group, Inc.",
"ROG	Rogers Corporation",
"ROIA	Radio One, Inc.",
"ROIAK	Radio One, Inc.",
"ROIC	Retail Opportunity Investments Corp.",
"ROICU	Retail Opportunity Investments Corp.",
"ROICW	Retail Opportunity Investments Corp.",
"ROIQU	ROI Acquisition Corp.",
"ROK	Rockwell Automation, Inc.",
"ROL	Rollins, Inc.",
"ROLL	RBC Bearings Incorporated",
"ROMA	Roma Financial Corporation",
"ROP	Roper Industries, Inc.",
"ROSE	Rosetta Resources Inc.",
"ROSG	Rosetta Genomics Ltd.",
"ROST	Ross Stores, Inc.",
"ROVI	Rovi Corporation",
"ROYL	Royale Energy, Inc.",
"RP	RealPage, Inc.",
"RPM	RPM International Inc.",
"RPRX	Repros Therapeutics Inc.",
"RPRXW	Repros Therapeutics Inc.",
"RPRXZ	Repros Therapeutics Inc.",
"RPT	Ramco-Gershenson Properties Trust",
"RPTP	Raptor Pharmaceutical Corp.",
"RPXC	RPX Corporation",
"RQI	Cohen & Steers Quality Income Realty Fund Inc",
"RRC	Range Resources Corporation",
"RRD	R.R. Donnelley & Sons Company",
"RRGB	Red Robin Gourmet Burgers, Inc.",
"RRMS	Rose Rock Midstream, L.P.",
"RRR	RSC Holdings Inc.",
"RRST	RRSat Global Communications Network Ltd.",
"RRTS	Roadrunner Transportation Systems, Inc",
"RS	Reliance Steel & Aluminum Co.",
"RSE	Rouse Properties, Inc.",
"RSG	Republic Services, Inc.",
"RSH	Radioshack Corporation",
"RSO	Resource Capital Corp.",
"RSOL	Real Goods Solar, Inc.",
"RST	Rosetta Stone",
"RSTI	Rofin-Sinar Technologies, Inc.",
"RSYS	RadiSys Corporation",
"RT	Ruby Tuesday, Inc.",
"RTEC	Rudolph Technologies, Inc.",
"RTI	RTI International Metals, Inc.",
"RTIX	RTI Biologics, Inc.",
"RTLX	Retalix Ltd.",
"RTN	Raytheon Company",
"RUE	rue21, inc.",
"RUK	Reed Elsevier PLC",
"RUSHA	Rush Enterprises, Inc.",
"RUSHB	Rush Enterprises, Inc.",
"RUTH	Ruth's Hospitality Group, Inc.",
"RVBD	Riverbed Technology, Inc.",
"RVSB	Riverview Bancorp Inc",
"RVSN	RADVision Ltd.",
"RVT	Royce Value Trust, Inc.",
"RWT	Redwood Trust, Inc.",
"RY	Royal Bank Of Canada",
"RYAAY	Ryanair Holdings plc",
"RYL	Ryland Group, Inc. (The)",
"RYN	Rayonier Inc. REIT",
"S	Sprint  Nextel Corporation",
"SAAS	inContact, Inc.",
"SAB	Grupo Casa Saba, S.A. de C.V.",
"SABA	Saba Software, Inc.",
"SAFM	Sanderson Farms, Inc.",
"SAFT	Safety Insurance Group, Inc.",
"SAH	Sonic Automotive, Inc.",
"SAI	SAIC Inc",
"SAIA	Saia, Inc.",
"SALM	Salem Communications Corporation",
"SAM	Boston Beer Company, Inc. (The)",
"SAN	Banco Santiago, S.A.",
"SANM	Sanmina-SCI Corporation",
"SANW	S&W Seed Company",
"SANWW	S&W Seed Company",
"SANWZ	S&W Seed Company",
"SAP	SAP AG",
"SAPE	Sapient Corporation",
"SAPX	Seven Arts Entertainment, Inc.",
"SAR	Saratoga Investment Corp",
"SASR	Sandy Spring Bancorp, Inc.",
"SATC	SatCon Technology Corporation",
"SATS	EchoStar Corporation",
"SAVB	The Savannah Bancorp, Inc.",
"SAVE	Spirit Airlines, Inc.",
"SB	Safe Bulkers, Inc",
"SBAC	SBA Communications Corporation",
"SBBX	Sussex Bancorp",
"SBCF	Seacoast Banking Corporation of Florida",
"SBGI	Sinclair Broadcast Group, Inc.",
"SBH	Sally Beauty Holdings, Inc.",
"SBLK	Star Bulk Carriers Corp.",
"SBNY	Signature Bank",
"SBNYW	Signature Bank",
"SBR	Sabine Royalty Trust",
"SBRA	Sabra Healthcare REIT, Inc.",
"SBS	Companhia de saneamento Basico Do Estado De Sao Paulo - Sabesp",
"SBSA	Spanish Broadcasting System, Inc.",
"SBSI	Southside Bancshares, Inc.",
"SBUX	Starbucks Corporation",
"SBW	Western Asset Worldwide Income Fund Inc.",
"SBX	SeaBright Holdings, Inc.",
"SCBT	SCBT Financial Corporation",
"SCCO	Southern Copper Corporation",
"SCD	LMP Capital and Income Fund Inc.",
"SCEI	Sino Clean Energy Inc.",
"SCG	Scana Corporation",
"SCHL	Scholastic Corporation",
"SCHN	Schnitzer Steel Industries, Inc.",
"SCHS	School Specialty, Inc.",
"SCHW	The Charles Schwab Corporation",
"SCI	Service Corporation International",
"SCIL	Scientific Learning Corporation",
"SCKT	Socket Mobile, Inc.",
"SCL	Stepan Company",
"SCLN	SciClone Pharmaceuticals, Inc.",
"SCLP	Russell Exchange Traded Funds Trust Russell Small Cap Low P/E ETF",
"SCMF	Southern Community Financial Corporation",
"SCMFO	Southern Community Financial Corporation",
"SCMP	Sucampo Pharmaceuticals, Inc.",
"SCMR	Sycamore Networks, Inc.",
"SCOG	Russell Exchange Traded Funds Trust Russell Small Cap Consistent Growth ETF",
"SCOK	SinoCoking Coal and Coke Chemical Industries, Inc",
"SCON	Superconductor Technologies Inc.",
"SCOR	comScore, Inc.",
"SCR	Simcere Pharmaceutical Group",
"SCS	Steelcase Inc.",
"SCSC	ScanSource, Inc.",
"SCSS	Select Comfort Corporation",
"SCTR	Russell Exchange Traded Funds Trust Russell Small Cap Contrarian ETF",
"SCU	Scana Corporation",
"SCVL	Shoe Carnival, Inc.",
"SCX	L.S. Starrett Company (The)",
"SD	Sandridge Energy Inc.",
"SDBT	SoundBite Communications, Inc.",
"SDIX	Strategic Diagnostics Inc.",
"SDRL	Seadrill Limited",
"SDT	SandRidge Mississippian Trust I",
"SE	Spectra Energy Corp",
"SEAC	SeaChange International, Inc.",
"SEE	Sealed Air Corporation",
"SEED	Origin Agritech Limited",
"SEH	Spartech Corporation",
"SEIC	SEI Investments Company",
"SEM	Select Medical Holdings Corporation",
"SEMG	Semgroup Corporation",
"SEMG/WS	Semgroup Corporation",
"SENEA	Seneca Foods Corp.",
"SENEB	Seneca Foods Corp.",
"SEP	Spectra Energy Partners, LP",
"SEV	Sevcon, Inc.",
"SF	Stifel Financial Corporation",
"SFB	Stifel Financial Corporation",
"SFD	Smithfield Foods, Inc.",
"SFE	Safeguard Scientifics, Inc.",
"SFG	StanCorp Financial Group, Inc.",
"SFI	iStar Financial Inc.",
"SFL	Ship Finance International Limited",
"SFLY	Shutterfly, Inc.",
"SFNC	Simmons First National Corporation",
"SFST	Southern First Bancshares, Inc.",
"SFUN	SouFun Holdings Limited",
"SFY	Swift Energy Company",
"SGC	Superior Uniform Group, Inc.",
"SGEN	Seattle Genetics, Inc.",
"SGF	Singapore Fund, Inc. (The)",
"SGGG	Russell Exchange Traded Funds Trust Russell Small Cap Aggressive Growth ETF",
"SGI	Silicon Graphics International Corp",
"SGK	Schawk, Inc.",
"SGL	Strategic Global Income Fund, Inc.",
"SGMA	SigmaTron International, Inc.",
"SGMO	Sangamo BioSciences, Inc.",
"SGMS	Scientific Games Corp",
"SGNT	Sagent Pharmaceuticals, Inc.",
"SGOC	SGOCO Group, Ltd",
"SGRP	SPAR Group, Inc.",
"SGU	Star Gas Partners, L.P.",
"SGY	Stone Energy Corporation",
"SGYP	Synergy Pharmaceuticals, Inc.",
"SGYPU	Synergy Pharmaceuticals, Inc.",
"SGYPW	Synergy Pharmaceuticals, Inc.",
"SGZ	Selective Insurance Group, Inc.",
"SHAW	Shaw Group Inc. (The)",
"SHBI	Shore Bancshares Inc",
"SHEN	Shenandoah Telecommunications Co",
"SHFL	Shuffle Master, Inc.",
"SHG	Shinhan Financial Group Co Ltd",
"SHI	SINOPEC Shangai Petrochemical Company, Ltd.",
"SHIP	Seanergy Maritime Holdings Corp",
"SHLD	Sears Holdings Corporation",
"SHLM	A. Schulman, Inc.",
"SHLO	Shiloh Industries, Inc.",
"SHO	Sunstone Hotel Investors, Inc.",
"SHOO	Steven Madden, Ltd.",
"SHOR	ShoreTel, Inc.",
"SHP	ShangPharma Corporation",
"SHPGY	Shire plc",
"SHS	Sauer-Danfoss Inc.",
"SHW	Sherwin-Williams Company (The)",
"SI	Siemens AG",
"SIAL	Sigma-Aldrich Corporation",
"SIBC	State Investors Bancorp, Inc.",
"SID	National Steel Company",
"SIEB	Siebert Financial Corp.",
"SIFI	SI Financial Group, Inc.",
"SIFY	Sify Technologies Limited",
"SIG	Signet Jewelers Limited",
"SIGA	SIGA Technologies Inc.",
"SIGI	Selective Insurance Group, Inc.",
"SIGM	Sigma Designs, Inc.",
"SILC	Silicom Ltd",
"SIMG	Silicon Image, Inc.",
"SIMO	Silicon Motion Technology Corporation",
"SINA	Sina Corporation",
"SINO	Sino-Global Shipping America, Ltd.",
"SIR	Select Income REIT",
"SIRI	Sirius XM Radio Inc.",
"SIRO	Sirona Dental Systems, Inc.",
"SIVB	SVB Financial Group",
"SIVBO	SVB Financial Group",
"SIX	Six Flags Entertainment Corporation New",
"SJI	South Jersey Industries, Inc.",
"SJM	J.M. Smucker Company (The)",
"SJR	Shaw Communications Inc.",
"SJT	San Juan Basin Royalty Trust",
"SJW	SJW Corporation",
"SKBI	Skystar Bio-Pharmaceutical Company",
"SKH	Skilled Healthcare Group, Inc.",
"SKM	SK Telecom Corporation, Ltd.",
"SKS	Saks Incorporated",
"SKT	Tanger Factory Outlet Centers, Inc.",
"SKUL	Skullcandy, Inc.",
"SKX	Skechers U.S.A., Inc.",
"SKY	Skyline Corporation",
"SKYW	SkyWest, Inc.",
"SKYY	First Trust Exchange-Traded Fund II First Trust ISE Cloud Computing Index Fund",
"SLA	American Select Portfolio, Inc.",
"SLAB	Silicon Laboratories, Inc.",
"SLB	Schlumberger N.V.",
"SLCA	U.S. Silica Holdings, Inc.",
"SLE	Sara Lee Corporation",
"SLF	Sun Life Financial Inc.",
"SLG	SL Green Realty Corporation",
"SLGN	Silgan Holdings, Inc.",
"SLH	Solera Holdings, Inc.",
"SLM	SLM Corporation",
"SLMAP	SLM Corporation",
"SLMBP	SLM Corporation",
"SLP	Simulations Plus, Inc.",
"SLRC	Solar Capital Ltd.",
"SLT	Sterlite Industries (India) Limited",
"SLTC	Selectica, Inc.",
"SLTM	Solta Medical, Inc",
"SLW	Silver Wheaton Corp",
"SLXP	Salix Pharmaceuticals, Ltd.",
"SM	SM Energy Company",
"SMA	Symmetry Medical Inc",
"SMBC	Southern Missouri Bancorp, Inc.",
"SMBL	Smart Balance Inc",
"SMCG	Millenium India Acquisition Company Inc.",
"SMCI	Super Micro Computer, Inc.",
"SMED	Sharps Compliance Corp",
"SMF	Salient MLP and Energy Infrastructure Fund",
"SMFG	Sumitomo Mitsui Financial Group Inc",
"SMG	Scotts Miracle-Gro Company (The)",
"SMI	Semiconductor  Manufacturing International Corporation",
"SMIT	Schmitt Industries, Inc.",
"SMMF	Summit Financial Group, Inc.",
"SMP	Standard Motor Products, Inc.",
"SMRT	Stein Mart, Inc.",
"SMS	Sims Metal Management Limited",
"SMSC	Standard Microsystems Corporation",
"SMSI	Smith Micro Software, Inc.",
"SMT	SMART Technologies Inc.",
"SMTC	Semtech Corporation",
"SMTX	SMTC Corporation",
"SN	Sanchez Energy Corporation",
"SNA	Snap-On Incorporated",
"SNAK	Inventure Foods, Inc.",
"SNBC	Sun Bancorp, Inc.",
"SNCR	Synchronoss Technologies, Inc.",
"SNDK	SanDisk Corporation",
"SNE	Sony Corp Ord",
"SNFCA	Security National Financial Corporation",
"SNH	Senior Housing Properties Trust",
"SNHY	Sun Hydraulics Corporation",
"SNI	Scripps Networks Interactive, Inc",
"SNMX	Senomyx, Inc.",
"SNN	Smith & Nephew SNATS, Inc.",
"SNP	China Petroleum & Chemical Corporation",
"SNPS	Synopsys, Inc.",
"SNSS	Sunesis Pharmaceuticals, Inc.",
"SNTA	Synta Pharmaceuticals Corp.",
"SNTS	Santarus, Inc.",
"SNV	Synovus Financial Corp.",
"SNX	Synnex Corporation",
"SNY	Sanofi",
"SO	Southern Company (The)",
"SOA	Solutia Inc",
"SOA/WS	Solutia Inc",
"SOCB	Southcoast Financial Corporation",
"SOCL	Global X Funds Global X Social Media Index ETF",
"SODA	SodaStream International Ltd.",
"SOFO	Sonic Foundry, Inc.",
"SOHU	Sohu.com Inc.",
"SOL	Renesola Ltd.",
"SOMH	Somerset Hills Bancorp",
"SOMX	Somaxon Pharmaceuticals, Inc.",
"SON	Sonoco Products Company",
"SONA	Southern National Bancorp of Virginia, Inc.",
"SONC	Sonic Corp.",
"SONO	SonoSite, Inc.",
"SONS	Sonus Networks, Inc.",
"SOR	Source Capital, Inc.",
"SORL	SORL Auto Parts, Inc.",
"SOXX	iShares Goldman Sachs Semiconductor Index Fund",
"SPA	Sparton Corporation",
"SPAN	Span-America Medical Systems, Inc.",
"SPAR	Spartan Motors, Inc.",
"SPB	Spectrum Brands Holdings, Inc.",
"SPBC	SP Bancorp, Inc.",
"SPCHA	Sport Chalet, Inc.",
"SPCHB	Sport Chalet, Inc.",
"SPE	Special Opportunities Fund Inc.",
"SPEX	Spherix Incorporated",
"SPF	Standard Pacific Corp",
"SPG	Simon Property Group, Inc.",
"SPH	Suburban Propane Partners, L.P.",
"SPIL	Siliconware Precision Industries Company, Ltd.",
"SPIR	Spire Corporation",
"SPLS	Staples, Inc.",
"SPMD	SuperMedia Inc.",
"SPN	Superior Energy Services, Inc.",
"SPNC	The Spectranetics Corporation",
"SPNS	Sapiens International Corporation N.V.",
"SPP	Sappi Limited",
"SPPI	Spectrum Pharmaceuticals, Inc.",
"SPPR	Supertel Hospitality, Inc.",
"SPPRO	Supertel Hospitality, Inc.",
"SPPRP	Supertel Hospitality, Inc.",
"SPR	Spirit Aerosystems Holdings, Inc.",
"SPRD	Spreadtrum Communications, Inc.",
"SPRO	SmartPros Ltd.",
"SPRT	support.com, Inc.",
"SPSC	SPS Commerce, Inc.",
"SPTN	Spartan Stores, Inc.",
"SPU	SkyPeople Fruit Juice, Inc.",
"SPW	SPX Corporation",
"SPWR	SunPower Corporation",
"SQI	SciQuest, Inc.",
"SQM	Sociedad Quimica y Minera S.A.",
"SQNM	Sequenom, Inc.",
"SQNS	Sequans Communications S.A.",
"SQQQ	ProShares UltraPro Short QQQ",
"SR	Standard Register Company (The)",
"SRCE	1st Source Corporation",
"SRCL	Stericycle, Inc.",
"SRDX	SurModics, Inc.",
"SRE	Sempra Energy",
"SREV	ServiceSource International, Inc.",
"SRF	The Cushing Royalty & Income Fund",
"SRI	Stoneridge, Inc.",
"SRLS	SeraCare Life Sciences Inc",
"SRSL	SRS Labs, Inc.",
"SRT	StarTek, Inc.",
"SRV	The Cushing MLP Total Return Fund",
"SRZ	Sunrise Senior Living, Inc.",
"SSBI	Summit State Bank",
"SSD	Simpson Manufacturing Company, Inc.",
"SSFN	Stewardship Financial Corp",
"SSH	Sunshine Heart Inc",
"SSI	Stage Stores, Inc.",
"SSL	Sasol Ltd.",
"SSNC	SS&C Technologies Holdings, Inc.",
"SSP	E.W. Scripps Company (The)",
"SSRI	Silver Standard Resources, Inc",
"SSRX	3SBio Inc.",
"SSS	Sovran Self Storage, Inc.",
"SSW	Seaspan Corporation",
"SSYS	Stratasys, Inc.",
"ST	Sensata Technologies Holding N.V.",
"STAA	STAAR Surgical Company",
"STAG	Stag Industrial, Inc.",
"STAN	Standard Parking Corporation",
"STB	Student Transportation Inc",
"STBA	S&T Bancorp, Inc.",
"STBZ	State Bank Financial Corporation.",
"STC	Stewart Information Services Corporation",
"STD	Banco Santander, S.A.",
"STE	STERIS Corporation",
"STEC	STEC, Inc.",
"STEI	Stewart Enterprises, Inc.",
"STEL	StellarOne Corporation",
"STEM	StemCells, Inc.",
"STFC	State Auto Financial Corporation",
"STI	SunTrust Banks, Inc.",
"STI/WS/A	SunTrust Banks, Inc.",
"STI/WS/B	SunTrust Banks, Inc.",
"STJ	St. Jude Medical, Inc.",
"STK	Columbia Seligman Premium Technology Growth Fund, Inc",
"STKL	SunOpta, Inc.",
"STL	Sterling Bancorp",
"STLD	Steel Dynamics, Inc.",
"STLY	Stanley Furniture Company, Inc.",
"STM	STMicroelectronics N.V.",
"STMP	Stamps.com Inc.",
"STN	Stantec Inc",
"STND	Standard Financial Corp.",
"STNG	Scorpio Tankers Inc.",
"STNR	Steiner Leisure Limited",
"STO	Statoil ASA",
"STON	StoneMor Partners L.P.",
"STP	Suntech Power Holdings Co., LTD.",
"STR	Questar Corporation",
"STRA	Strayer Education, Inc.",
"STRC	SRI/Surgical Express, Inc.",
"STRI	STR Holdings, Inc",
"STRL	Sterling Construction Company Inc",
"STRM	Streamline Health Solutions, Inc.",
"STRN	Sutron Corporation",
"STRS	Stratus Properties, Inc.",
"STRT	Strattec Security Corporation",
"STSA	Sterling Financial Corporation",
"STT	State Street Corporation",
"STV	China Digital TV Holding Co., Ltd.",
"STWD	STARWOOD PROPERTY TRUST, INC.",
"STX	Seagate Technology.",
"STXS	Stereotaxis, Inc.",
"STZ	Constellation Brands Inc",
"STZ/B	Constellation Brands Inc",
"SU	Suncor Energy  Inc.",
"SUBK	Suffolk Bancorp",
"SUG	Southern Union Company",
"SUI	Sun Communities, Inc.",
"SUMR	Summer Infant, Inc.",
"SUN	Sunoco, Inc.",
"SUNH	Sun Healthcare Group, Inc.",
"SUNS	Solar Senior Capital Ltd.",
"SUP	Superior Industries International, Inc.",
"SUPX	Supertex, Inc.",
"SURG	Synergetics USA, Inc.",
"SURW	SureWest Communications",
"SUSQ	Susquehanna Bancshares, Inc.",
"SUSS	Susser Holdings Corporation",
"SUTR	Sutor Technology Group Limited",
"SVA	Sinovac Biotech, Ltd.",
"SVBI	Severn Bancorp Inc",
"SVM	Silvercorp Metals Inc",
"SVN	7 Days Group Holdings Limited",
"SVNT	Savient Pharmaceuticals Inc",
"SVU	SuperValu Inc.",
"SVVC	Firsthand Technology Value Fund, Inc.",
"SWC	Stillwater Mining Company",
"SWFT	Swift Transportation Company",
"SWHC	Smith & Wesson Holding Corporation",
"SWI	Solarwinds, Inc.",
"SWIR	Sierra Wireless, Inc.",
"SWK	Stanley Black & Decker, Inc.",
"SWKS	Skyworks Solutions, Inc.",
"SWM	Schweitzer-Mauduit International, Inc.",
"SWN	Southwestern Energy Company",
"SWS	SWS Group, Inc.",
"SWSH	Swisher Hygiene, Inc.",
"SWU	Stanley Black & Decker, Inc.",
"SWX	Southwest Gas Corporation",
"SWY	Safeway Inc.",
"SWZ	Swiss Helvetia Fund, Inc. (The)",
"SXC	SunCoke Energy, Inc.",
"SXCI	SXC Health Solutions Corp.",
"SXI	Standex International Corporation",
"SXL	Sunoco Logistics Partners LP",
"SXT	Sensient Technologies Corporation",
"SYA	Symetra Financial Corporation",
"SYBT	S.Y. Bancorp, Inc.",
"SYBTP	S.Y. Bancorp, Inc.",
"SYK	Stryker Corporation",
"SYKE	Sykes Enterprises, Incorporated",
"SYMC	Symantec Corporation",
"SYMM	Symmetricom, Inc.",
"SYMX	Synthesis Energy Systems, Inc.",
"SYNA	Synaptics Incorporated",
"SYNC	Synacor, Inc.",
"SYNL	Synalloy Corporation",
"SYNM	Syntroleum Corporation",
"SYNT	Syntel, Inc.",
"SYPR	Sypris Solutions, Inc.",
"SYSW	SYSWIN Inc.",
"SYT	Syngenta AG",
"SYUT	Synutra International, Inc.",
"SYX	Systemax Inc.",
"SYY	Sysco Corporation",
"SZYM	Solazyme, Inc.",
"T	AT&T Inc.",
"TAC	TransAlta Corporation",
"TACT	TransAct Technologies Incorporated",
"TAI	Transamerica Income Shares, Inc.",
"TAIT	Taitron Components Incorporated",
"TAL	TAL International Group, Inc.",
"TAM	TAM S.A.",
"TAOM	Taomee Holdings Limited",
"TAP	Molson Coors Brewing  Company",
"TAP/A	Molson Coors Brewing  Company",
"TASR	TASER International, Inc.",
"TAST	Carrols Restaurant Group, Inc.",
"TATT	TAT Technologies Ltd.",
"TAXI	Medallion Financial Corp.",
"TAYC	Taylor Capital Group, Inc.",
"TAYCP	Taylor Capital Group, Inc.",
"TAYD	Taylor Devices, Inc.",
"TBAC	Tandy Brands Accessories, Inc.",
"TBBK	The Bancorp, Inc.",
"TBET	Tibet Pharmaceuticals, Inc.",
"TBI	TrueBlue, Inc.",
"TBNK	Territorial Bancorp Inc.",
"TBOW	Trunkbow International Holdings Ltd.",
"TC	Thompson Creek Metals Company Inc.",
"TCAP	Triangle Capital Corporation",
"TCB	TCF Financial Corporation",
"TCB/WS	TCF Financial Corporation",
"TCBI	Texas Capital Bancshares, Inc.",
"TCBIW	Texas Capital Bancshares, Inc.",
"TCBK	TriCo Bancshares",
"TCC	Triangle Capital Corporation",
"TCCO	Technical Communications Corporation",
"TCHC	21st Century Holding Company",
"TCI	Transcontinental Realty Investors, Inc.",
"TCK	Teck Resources Ltd",
"TCL	Tata Communications Limited",
"TCO	Taubman Centers, Inc.",
"TCP	TC PipeLines, LP",
"TCRD	THL Credit, Inc.",
"TD	Toronto Dominion Bank (The)",
"TDC	Teradata Corporation",
"TDE	Telephone and Data Systems, Inc.",
"TDF	Templeton Dragon Fund, Inc.",
"TDG	Transdigm Group Incorporated",
"TDI	Telephone and Data Systems, Inc.",
"TDJ	Telephone and Data Systems, Inc.",
"TDS	Telephone and Data Systems, Inc.",
"TDW	Tidewater Inc.",
"TDY	Teledyne Technologies Incorporated",
"TE	TECO Energy, Inc.",
"TEA	Teavana Holdings, Inc.",
"TEAR	TearLab Corporation",
"TECD	Tech Data Corporation",
"TECH	Techne Corporation",
"TECUA	Tecumseh Products Company",
"TECUB	Tecumseh Products Company",
"TEF	Telefonica SA",
"TEG	Integrys Energy Group",
"TEI	Templeton Emerging Markets Income Fund, Inc.",
"TEL	TE Connectivity Ltd.",
"TELK	Telik, Inc.",
"TEN	Tenneco Automotive, Inc.",
"TEO	Telecom Argentina Stet - France Telecom S.A.",
"TER	Teradyne, Inc.",
"TESO	Tesco Corporation",
"TESS	TESSCO Technologies Incorporated",
"TEU	Box Ships Inc.",
"TEVA	Teva Pharmaceutical Industries Limited",
"TEX	Terex Corporation",
"TFCO	Tufco Technologies, Inc.",
"TFG	Goldman Sachs Group, Inc. (The)",
"TFM	The Fresh Market, Inc.",
"TFSL	TFS Financial Corporation",
"TFX	Teleflex Incorporated",
"TG	Tredegar Corporation",
"TGA	Transglobe Energy Corp",
"TGAL	Tegal Corporation",
"TGE	TGC Industries, Inc.",
"TGH	Textainer Group Holdings Limited",
"TGI	Triumph Group, Inc.",
"TGP	Teekay LNG Partners L.P.",
"TGS	Transportadora De Gas Sa Ord B",
"TGT	Target Corporation",
"TGX	Theragenics Corporation",
"THC	Tenet Healthcare Corporation",
"THER	Theratechnologies Inc.",
"THFF	First Financial Corporation Indiana",
"THG	The Hanover Insurance Group, Inc.",
"THI	Tim Hortons Inc.",
"THLD	Threshold Pharmaceuticals, Inc.",
"THO	Thor Industries, Inc.",
"THOR	Thoratec Corporation",
"THQI	THQ Inc.",
"THR	Thermon Group Holdings, Inc.",
"THRD	TF Financial Corporation",
"THRX	Theravance, Inc.",
"THS	Treehouse Foods, Inc.",
"THTI	THT Heat Transfer Technology, Inc.",
"TI	Telecom Italia S.P.A.",
"TI/A	Telecom Italia S.P.A.",
"TIBB	TIB Financial Corporation",
"TIBX	TIBCO Software, Inc.",
"TICC	TICC Capital Corp.",
"TIE	Titanium Metals Corporation",
"TIF	Tiffany & Co.",
"TIGR	TigerLogic Corporation",
"TIII	Tii Network Technologies, Inc.",
"TINY	Harris & Harris Group, Inc.",
"TISA	Top Image Systems, Ltd.",
"TISI	Team, Inc.",
"TITN	Titan Machinery Inc.",
"TIVO	TiVo Inc.",
"TJX	TJX Companies, Inc. (The)",
"TK	Teekay Corporation",
"TKC	Turkcell Iletisim Hizmetleri AS",
"TKF	Turkish Investment Fund, Inc. (The)",
"TKMR	Tekmira Pharmaceuticals Corp",
"TKR	Timken Company (The)",
"TLAB	Tellabs, Inc.",
"TLB	Talbots, Inc. (The)",
"TLEO	Taleo Corporation",
"TLF	Tandy Leather Factory, Inc.",
"TLI	LMP Corporate Loan Fund Inc",
"TLK	P.T. Telekomunikasi Indonesia, Tbk.",
"TLLP	Tesoro Logistics LP",
"TLM	Talisman Energy Inc.",
"TLP	Transmontaigne Partners L.P.",
"TM	Toyota Motor Corp Ltd Ord",
"TMH	Team Health Holdings, Inc.",
"TMK	Torchmark Corporation",
"TMM	Grupo TMM, S.A.",
"TMNG	The Management Network Group, Inc.",
"TMO	Thermo Fisher Scientific Inc",
"TMS	TMS International Corp.",
"TNAV	TeleNav, Inc.",
"TNB	Thomas & Betts Corporation",
"TNC	Tennant Company",
"TNE	Tele Norte Leste Participacoes S.A.",
"TNGN	Tengion, Inc.",
"TNGO	Tangoe, Inc.",
"TNH	Terra Nitrogen Company, L.P.",
"TNK	Teekay Tankers Ltd.",
"TNP	Tsakos Energy Navigation Ltd",
"TNS	TNS, Inc.",
"TOFC	Tower Financial Corporation",
"TOL	Toll Brothers Inc.",
"TOO	Teekay Offshore Partners L.P.",
"TOPS	TOP Ships Inc.",
"TORM	TOR Minerals International Inc",
"TOT	TotalFinaElf, S.A.",
"TOWN	Towne Bank",
"TOWR	Tower International, Inc.",
"TPC	Tutor Perini Corporation",
"TPCG	TPC Group, Inc.",
"TPGI	Thomas Properties Group, Inc.",
"TPL	Texas Pacific Land Trust",
"TPX	Tempur-pedic International Inc",
"TPZ	Tortoise Power and Energy Infrastructure Fund, Inc",
"TQNT	TriQuint Semiconductor, Inc.",
"TQQQ	ProShares UltraPro QQQ",
"TR	Tootsie Roll Industries, Inc.",
"TRAK	DealerTrack Holdings, Inc.",
"TRC	Tejon Ranch Co",
"TRCR	Transcend Services, Inc.",
"TREE	Tree.com, Inc.",
"TREX	Trex Company, Inc.",
"TRF	Templeton Russia Fund, Inc.",
"TRGP	Targa Resources, Inc.",
"TRGT	Targacept, Inc.",
"TRI	Thomson Reuters Corp",
"TRIB	Trinity Biotech plc",
"TRIP	TripAdvisor, Inc.",
"TRIT	Tri-Tech Holding Inc.",
"TRK	Speedway Motorsports, Inc.",
"TRLG	True Religion Apparel, Inc.",
"TRMB	Trimble Navigation Limited",
"TRMD	TORM A/S",
"TRMK	Trustmark Corporation",
"TRN	Trinity Industries, Inc.",
"TRNO	Terreno Realty Corporation",
"TRNS	Transcat, Inc.",
"TRNX	Tornier N.V.",
"TROW	T. Rowe Price Group, Inc.",
"TRP	Transcanada Pipelines, Ltd.",
"TRR	TRC Companies, Inc.",
"TRS	TriMas Corporation",
"TRST	TrustCo Bank Corp NY",
"TRU	Torch Energy Royalty Trust",
"TRV	The Travelers Companies, Inc.",
"TRW	TRW Automotive Holdings Corporation",
"TS	Tenaris S.A.",
"TSBK	Timberland Bancorp, Inc.",
"TSCO	Tractor Supply Company",
"TSEM	Tower Semiconductor Ltd.",
"TSI	TCW Strategic Income Fund, Inc.",
"TSL	Trina Solar Limited",
"TSLA	Tesla Motors, Inc.",
"TSM	Taiwan Semiconductor Manufacturing Company Limited",
"TSN	Tyson Foods, Inc.",
"TSO	Tesoro Petroleum Corporation",
"TSON	TranS1 Inc.",
"TSPT	Transcept Pharmaceuticals, Inc.",
"TSRA	Tessera Technologies, Inc.",
"TSRI	TSR, Inc.",
"TSRX	Trius Therapeutics, Inc.",
"TSS	Total System Services, Inc.",
"TST	TheStreet, Inc.",
"TSTC	Telestone Technologies Corp.",
"TSTF	TeamStaff, Inc.",
"TSU	Tele Celular Sul Participacoes S.A.",
"TSYS	TeleCommunication Systems, Inc.",
"TTC	Toro Company (The)",
"TTEC	TeleTech Holdings, Inc.",
"TTEK	Tetra Tech, Inc.",
"TTF	Thai Fund, Inc. (The)",
"TTGT	TechTarget, Inc.",
"TTHI	Transition Therapeutics, Inc.",
"TTI	Tetra Technologies, Inc.",
"TTM	Tata Motors Ltd",
"TTMI	TTM Technologies, Inc.",
"TTO	Tortoise Capital Resources Corporation",
"TTP	Tortoise Pipeline & Energy Fund, Inc.",
"TTWO	Take-Two Interactive Software, Inc.",
"TU	TELUS Corporation",
"TUC	Mac-Gray Corporation",
"TUDO	Tudou Holdings Limited",
"TUES	Tuesday Morning Corp.",
"TUP	Tupperware Corporation",
"TV	Grupo Televisa S.A.",
"TVC	Tennessee Valley Authority",
"TVE	Tennessee Valley Authority",
"TVL	LIN TV Corp",
"TW	Towers Watson & Co",
"TWC	Time Warner Cable Inc",
"TWER	Towerstream Corporation",
"TWGP	Tower Group, Inc.",
"TWI	Titan International, Inc.",
"TWIN	Twin Disc, Incorporated",
"TWMC	Trans World Entertainment Corp.",
"TWN	Taiwan Fund, Inc. (The)",
"TWO	Two Harbors Investments Corp",
"TWTC	tw telecom inc.",
"TWX	Time Warner Inc.",
"TX	Ternium S.A.",
"TXCC	TranSwitch Corporation",
"TXI	Texas Industries, Inc.",
"TXN	Texas Instruments Incorporated",
"TXRH	Texas Roadhouse, Inc.",
"TXT	Textron Inc.",
"TY	Tri Continental Corporation",
"TYC	Tyco International, Ltd. (Switzerland)",
"TYG	Tortoise Energy Infrastructure Corporation",
"TYL	Tyler Technologies, Inc.",
"TYN	Tortoise North American Energy Corporation",
"TYPE	Monotype Imaging Holdings Inc.",
"TYY	Tortoise Energy Capital Corporation",
"TZF	Bear Stearns Depositor, Inc.",
"TZK	Trust Ctfs 2002 1 Bear Stearns Depositor Inc Acting as Deposit",
"TZOO	Travelzoo Inc",
"TZYM	Tranzyme, Inc.",
"UA	Under Armour, Inc.",
"UACL	Universal Truckload Services, Inc.",
"UAL	United Continental Holdings, Inc.",
"UAM	Universal American Corp.",
"UAN	CVR Partners, LP",
"UBA	Urstadt Biddle Properties Inc.",
"UBCP	United Bancorp, Inc.",
"UBFO	United Security Bancshares",
"UBNK	United Financial Bancorp, Inc.",
"UBNT	Ubiquiti Networks, Inc.",
"UBOH	United Bancshares, Inc.",
"UBP	Urstadt Biddle Properties Inc.",
"UBPS	Universal Business Payment Solutions Acquisition Corporation",
"UBPSU	Universal Business Payment Solutions Acquisition Corporation",
"UBPSW	Universal Business Payment Solutions Acquisition Corporation",
"UBS	UBS AG",
"UBSH	Union First Market Bankshares Corporation",
"UBSI	United Bankshares, Inc.",
"UCBA	United Community Bancorp",
"UCBI	United Community Banks, Inc.",
"UCFC	United Community Financial Corp.",
"UCTT	Ultra Clean Holdings, Inc.",
"UDR	United Dominion Realty Trust, Inc.",
"UDRL	Union Drilling, Inc.",
"UEIC	Universal Electronics Inc.",
"UEPS	Net 1 UEPS Technologies, Inc.",
"UFCS	United Fire Group, Inc",
"UFI	Unifi, Inc.",
"UFPI	Universal Forest Products, Inc.",
"UFPT	UFP Technologies, Inc.",
"UFS	Domtar Corporation",
"UG	United-Guardian, Inc.",
"UGI	UGI Corporation",
"UGP	Ultrapar Participacoes S.A.",
"UHAL	Amerco",
"UHS	Universal Health Services, Inc.",
"UHT	Universal Health Realty Income Trust",
"UIL	UIL Holdings Corporation",
"UIS	Unisys Corporation",
"UL	Unilever PLC",
"ULBI	Ultralife Corporation",
"ULGX	Urologix, Inc.",
"ULTA	Ulta Salon, Cosmetics & Fragrance, Inc.",
"ULTI	The Ultimate Software Group, Inc.",
"ULTR	Ultrapetrol (Bahamas) Limited",
"UMBF	UMB Financial Corporation",
"UMC	United Microelectronics Corporation",
"UMH	UMH Properties, Inc.",
"UMPQ	Umpqua Holdings Corporation",
"UN	Unilever NV",
"UNAM	Unico American Corporation",
"UNB	Union Bankshares, Inc.",
"UNF	Unifirst Corporation",
"UNFI	United Natural Foods, Inc.",
"UNH	UnitedHealth Group Incorporated",
"UNIS	Unilife Corporation",
"UNM	Unum Group",
"UNP	Union Pacific Corporation",
"UNS	UniSource Energy Corporation",
"UNT	Unit Corporation",
"UNTD	United Online, Inc.",
"UNTK	UniTek Global Services, Inc.",
"UNTY	Unity Bancorp, Inc.",
"UNXL	Uni-Pixel, Inc.",
"UPI	Uroplasty, Inc.",
"UPL	Ultra Petroleum Corp.",
"UPS	United Parcel Service, Inc.",
"URBN	Urban Outfitters, Inc.",
"URI	United Rentals, Inc.",
"URRE	Uranium Resources, Inc.",
"URS	URS Corporation",
"USA	Liberty All-Star Equity Fund",
"USAK	USA Truck, Inc.",
"USAP	Universal Stainless & Alloy Products, Inc.",
"USAT	USA Technologies, Inc.",
"USATP	USA Technologies, Inc.",
"USATZ	USA Technologies, Inc.",
"USB	U.S. Bancorp",
"USBI	United Security Bancshares, Inc.",
"USCR	U S Concrete, Inc.",
"USEG	U.S. Energy Corp.",
"USG	USG Corporation",
"USHS	U.S. Home Systems, Inc.",
"USLM	United States Lime & Minerals, Inc.",
"USM	United States Cellular Corporation",
"USMO	USA Mobility, Inc.",
"USNA	USANA Health Sciences, Inc.",
"USPH	U.S. Physical Therapy, Inc.",
"USTR	United Stationers Inc.",
"USU	USEC Inc.",
"UTA	Universal Travel Group",
"UTEK	Ultratech, Inc.",
"UTF	Cohen & Steers Infrastructure Fund, Inc",
"UTHR	United Therapeutics Corporation",
"UTI	Universal Technical Institute Inc",
"UTIW	UTi Worldwide Inc.",
"UTL	UNITIL Corporation",
"UTMD	Utah Medical Products, Inc.",
"UTSI	UTStarcom Holdings Corp",
"UTX	United Technologies Corporation",
"UVSP	Univest Corporation of Pennsylvania",
"UVV	Universal Corporation",
"UZA	United States Cellular Corporation",
"V	Visa Inc.",
"VAC	Marriot International",
"VAL	Valspar Corporation (The)",
"VALE	VALE S.A.",
"VALE/P	VALE S.A.",
"VALU	Value Line, Inc.",
"VALV	Shengkai Innovations, Inc.",
"VAR	Varian Medical Systems, Inc.",
"VASC	Vascular Solutions, Inc.",
"VBF	Invesco Van Kampen Bond Fund",
"VBFC	Village Bank and Trust Financial Corp.",
"VC	Visteon Corporation",
"VCBI	Virginia Commerce Bancorp",
"VCI	Valassis Communications, Inc.",
"VCIT	Vanguard Intermediate-Term Corporate Bond ETF",
"VCLK	ValueClick, Inc.",
"VCLT	Vanguard Long-Term Corporate Bond ETF",
"VCO	Vina Concha Y Toro",
"VCSH	Vanguard Short-Term Corporate Bond ETF",
"VCV	Invesco Van Kampen California Value Municipal Income Trust",
"VDSI	VASCO Data Security International, Inc.",
"VE	Veolia Environnement",
"VECO	Veeco Instruments Inc.",
"VELT	Velti plc",
"VFC	V.F. Corporation",
"VG	Vonage Holdings Corp.",
"VGI	Virtus Global Multi-Sector Income Fund",
"VGIT	Vanguard Intermediate -Term Government Bond ETF",
"VGLT	Vanguard Long-Term Government Bond ETF",
"VGM	Invesco Van Kampen Trust for Investment Grade Municipals",
"VGR	Vector Group Ltd.",
"VGSH	Vanguard Short Term Government Bond ETF",
"VHI	Valhi, Inc.",
"VHS	Vanguard Health Systems, Inc.",
"VIA	Viacom Inc.",
"VIAB	Viacom Inc.",
"VIAS	Viasystems Group, Inc.",
"VICL	Vical Incorporated",
"VICR	Vicor Corporation",
"VIDE	Video Display Corporation",
"VIFL	Food Technology Service, Inc.",
"VIM	Invesco Van Kampen Trust for Value Municipals",
"VIMC	Vimicro International Corporation",
"VIP	Open Joint Stock Company &quot;Vimpel-Communications&quot;",
"VIRC	Virco Manufacturing Corporation",
"VISN	VisionChina Media, Inc.",
"VIST	VIST Financial Corp",
"VIT	Vanceinfo Technologies Inc",
"VITC	Vitacost.com, Inc.",
"VIV	Telefonica Brasil S.A.",
"VIVO	Meridian Bioscience Inc.",
"VKQ	Invesco Van Kampen Municipal Trust",
"VLCCF	Knightsbridge Tankers Limited",
"VLGEA	Village Super Market, Inc.",
"VLNC	Valence Technology, Inc.",
"VLO	Valero Energy Corporation",
"VLT	Invesco Van Kampen High Income Corporate Bond Fund",
"VLTR	Volterra Semiconductor Corporation",
"VLY	Valley National Bancorp",
"VLYWW	Valley National Bancorp",
"VMBS	Vanguard Mortgage-Backed Securities ETF",
"VMC	Vulcan Materials Company",
"VMED	Virgin Media Inc.",
"VMI	Valmont Industries, Inc.",
"VMO	Invesco Van Kampen Municipal Opportunity Trust",
"VMW	Vmware, Inc.",
"VNDA	Vanda Pharmaceuticals Inc.",
"VNET	21Vianet Group, Inc.",
"VNO	Vornado Realty Trust",
"VNOD	Vornado Realty L.P.",
"VNQI	Vanguard International Equity Index Funds Vanguard Global ex-U.S. Real Estate ETF",
"VNR	Vanguard Natural Resources LLC",
"VOC	VOC Energy Trust",
"VOCS	Vocus, Inc.",
"VOD	Vodafone Group Plc",
"VOLC	Volcano Corporation",
"VONE	Vanguard Scottsdale Funds Vanguard Russell 1000 ETF",
"VONG	Vanguard Scottsdale Funds Vanguard Russell 1000 Growth ETF",
"VONV	Vanguard Scottsdale Funds Vanguard Russell 1000 Value ETF",
"VOQ	Invesco Van Kampen Ohio Quality Municipal Trust",
"VOXX	VOXX International Corporation",
"VPFG	ViewPoint Financial Group, Inc.",
"VPG	Vishay Precision Group, Inc.",
"VPHM	ViroPharma Incorporated",
"VPRT	Vistaprint N.V.",
"VPV	Invesco Van Kampen Pennsylvania Value Municipal Income Trust",
"VQ	Venoco, Inc.",
"VR	Validus Holdings, Ltd.",
"VRA	Vera Bradley, Inc.",
"VRML	Vermillion, Inc.",
"VRNM	Verenium Corporation",
"VRNT	Verint Systems Inc.",
"VRS	Verso Paper Corp.",
"VRSK	Verisk Analytics, Inc.",
"VRSN	VeriSign, Inc.",
"VRTA	Vestin Realty Mortgage I, Inc.",
"VRTB	Vestin Realty Mortgage II, Inc.",
"VRTS	Virtus Investment Partners, Inc.",
"VRTU	Virtusa Corporation",
"VRTX	Vertex Pharmaceuticals Incorporated",
"VRX	Valeant Pharmaceuticals International, Inc.",
"VSAT	ViaSat, Inc.",
"VSBN	VSB Bancorp, Inc. (NY)",
"VSCI	Vision-Sciences, Inc.",
"VSCP	VirtualScopics, Inc.",
"VSEC	VSE Corporation",
"VSH	Vishay Intertechnology, Inc.",
"VSI	Vitamin Shoppe, Inc",
"VSNT	Versant Corporation",
"VSTM	Verastem, Inc.",
"VTA	Invesco Van Kampen Dynamic Credit Opportunities Fund",
"VTHR	Vanguard Scottsdale Funds Vanguard Russell 3000 ETF",
"VTJ	Invesco Van Kampen Trust for Investment Grade N J Municipals",
"VTN	Invesco Van Kampen Trt  for Investment Grade New York Municipa",
"VTNC	Vitran Corporation, Inc.",
"VTR	Ventas, Inc.",
"VTSS	Vitesse Semiconductor Corporation",
"VTUS	Ventrus Biosciences, Inc.",
"VTWG	Vanguard Scottsdale Funds Vanguard Russell 2000 Growth ETF",
"VTWO	Vanguard Scottsdale Funds Vanguard Russell 2000 ETF",
"VTWV	Vanguard Scottsdale Funds Vanguard Russell 2000 Value ETF",
"VVC	Vectren Corporation",
"VVI	Viad Corp",
"VVR	Invesco Van Kampen Senior Income Trust",
"VVTV	ValueVision Media, Inc.",
"VVUS	VIVUS, Inc.",
"VXUS	Vanguard STAR Funds Vanguard Total International Stock ETF",
"VYFC	Valley Financial Corporation",
"VZ	Verizon Communications Inc.",
"WAB	Westinghouse Air Brake Technologies Corporation",
"WABC	Westamerica Bancorporation",
"WACLY	Wacoal Holdings Corporation",
"WAFD	Washington Federal, Inc.",
"WAFDW	Washington Federal, Inc.",
"WAG	Walgreen Co.",
"WAIR	Wesco Aircraft Holdings, Inc.",
"WAL	Western Alliance Bancorporation",
"WASH	Washington Trust Bancorp, Inc.",
"WAT	Waters Corporation",
"WAVX	Wave Systems Corp.",
"WAYN	Wayne Savings Bancshares Inc.",
"WBC	Wabco Holdings Inc.",
"WBCO	Washington Banking Company",
"WBK	Westpac Banking Corporation",
"WBKC	Wolverine Bancorp, Inc.",
"WBMD	WebMD Health Corp",
"WBS	Webster Financial Corporation",
"WBS/WS	Webster Financial Corporation",
"WBSN	Websense, Inc.",
"WCAA	WCA Waste Corporation",
"WCBO	West Coast Bancorp",
"WCC	WESCO International, Inc.",
"WCG	WellCare Helath Plans, Inc.",
"WCN	Waste Connections, Inc.",
"WCRX	Warner Chilcott plc",
"WD	Walker & Dunlop, Inc.",
"WDC	Western Digital Corporation",
"WDFC	WD-40 Company",
"WDR	Waddell & Reed Financial, Inc.",
"WEA	Western Asset Bond Fund",
"WEBK	Wellesley Bancorp, Inc.",
"WEBM	WebMediaBrands Inc",
"WEC	Wisconsin Energy Corporation",
"WEN	Wendy's Company (The)",
"WERN	Werner Enterprises, Inc.",
"WES	Western Gas Partners, LP",
"WEST	Westinghouse Solar, Inc.",
"WETF	WisdomTree Investments, Inc.",
"WEYS	Weyco Group, Inc.",
"WF	Woori Finance Holdings Co Ltd",
"WFC	Wells Fargo & Company",
"WFC/WS	Wells Fargo & Company",
"WFD	Westfield Financial, Inc.",
"WFM	Whole Foods Market, Inc.",
"WFR	MEMC Electronic Materials, Inc.",
"WFT	Weatherford International, Ltd",
"WG	Willbros Group, Inc.",
"WGL	WGL Holdings Inc",
"WGO	Winnebago Industries, Inc.",
"WH	WSP Holdings Limited",
"WHG	Westwood Holdings Group Inc",
"WHR	Whirlpool Corporation",
"WHRT	World Heart Corporation",
"WHX	Whiting USA Trust I",
"WIA	Western Asset/Claymore U.S. Treasury Inflation Prot Secs Fd",
"WIBC	Wilshire Bancorp, Inc.",
"WIFI	Boingo Wireless, Inc.",
"WILC	G. Willi-Food International,  Ltd.",
"WILN	Wi-Lan Inc",
"WIN	Windstream Corporation",
"WINA	Winmark Corporation",
"WINN	Winn-Dixie Stores, Inc.",
"WIRE	Encore Wire Corporation",
"WIT	Wipro Limited",
"WIW	Western Asset/Claymore U.S Treasury Inflation Prot Secs Fd 2",
"WLB	Westmoreland Coal Company",
"WLBC	Western Liberty Bancorp",
"WLBPZ	Westmoreland Coal Company",
"WLDN	Willdan Group, Inc.",
"WLFC	Willis Lease Finance Corporation",
"WLFCP	Willis Lease Finance Corporation",
"WLK	Westlake Chemical Corporation",
"WLL	Whiting Petroleum Corporation",
"WLP	WellPoint Inc.",
"WLT	Walter Energy, Inc.",
"WM	Waste Management, Inc.",
"WMAR	West Marine, Inc.",
"WMB	Williams Companies, Inc. (The)",
"WMGI	Wright Medical Group, Inc.",
"WMK	Weis Markets, Inc.",
"WMS	WMS Industries Inc.",
"WMT	Wal-Mart Stores, Inc.",
"WNC	Wabash National Corporation",
"WNI	Schiff Nutrition International, Inc.",
"WNR	Western Refining, Inc.",
"WNS	WNS (Holdings) Limited",
"WOLF	Great Wolf Resorts, Inc.",
"WOOD	iShares S&P Global Timber &Forestry Index Fund",
"WOOF	VCA Antech, Inc.",
"WOR	Worthington Industries, Inc.",
"WPC	W.P. Carey & Co. LLC",
"WPCS	WPCS International Incorporated",
"WPI	Watson Pharmaceuticals, Inc.",
"WPK	Wells Fargo & Company",
"WPO	Washington Post Company (The)",
"WPP	Wausau Paper Corp.",
"WPPGY	WPP plc",
"WPRT	Westport Innovations Inc",
"WPX	WPX Energy, Inc.",
"WPZ	Williams Partners L.P.",
"WR	Westar Energy, Inc.",
"WRB	W.R. Berkley Corporation",
"WRC	Warnaco Group Inc (The)",
"WRD	Weingarten Realty Investors",
"WRE	Washington Real Estate Investment Trust",
"WRES	Warren Resources, Inc.",
"WRI	Weingarten Realty Investors",
"WRLD	World Acceptance Corporation",
"WRLS	Telular Corporation",
"WRS	Westar Energy, Inc.",
"WSB	WSB Holdings, Inc.",
"WSBC	WesBanco, Inc.",
"WSBF	Waterstone Financial, Inc.",
"WSCI	WSI Industries Inc.",
"WSFS	WSFS Financial Corporation",
"WSH	Willis Group Holdings Limited",
"WSM	Williams-Sonoma, Inc.",
"WSO	Watsco, Inc.",
"WST	West Pharmaceutical Services, Inc.",
"WSTG	Wayside Technology Group, Inc.",
"WSTL	Westell Technologies, Inc.",
"WTBA	West Bancorporation",
"WTFC	Wintrust Financial Corporation",
"WTFCW	Wintrust Financial Corporation",
"WTI	W&T Offshore, Inc.",
"WTM	White Mountains Insurance Group, Ltd.",
"WTR	Aqua America, Inc.",
"WTS	Watts Water Technologies, Inc.",
"WTSLA	The Wet Seal, Inc.",
"WTW	Weight Watchers International Inc",
"WU	Western Union Company (The)",
"WUHN	Wuhan General Group (China), Inc.",
"WVFC	WVS Financial Corp.",
"WVVI	Willamette Valley Vineyards, Inc.",
"WWAY	Westway Group, Inc.",
"WWD	Woodward, Inc.",
"WWE	World Wrestling Entertainment, Inc.",
"WWIN	Winner Medical Group Inc.",
"WWVY	Warwick Valley Telephone Company",
"WWW	Wolverine World Wide, Inc.",
"WWWW	Web.com Group, Inc",
"WX	Wuxi Pharmatech (Cayman) Inc.",
"WXS	Wright Express Corporation",
"WY	Weyerhaeuser Company",
"WYN	Wyndham Worldwide Corp",
"WYNN	Wynn Resorts, Limited",
"X	United States Steel Corporation",
"XAA	American Municipal Income Portfolio",
"XATA	XATA Corporation",
"XBKS	Xenith Bankshares, Inc.",
"XCJ	Xcel Energy Inc.",
"XCO	EXCO Resources NL",
"XEC	Cimarex Energy Co",
"XEL	Xcel Energy Inc.",
"XFD	Lehman ABS Corporation",
"XFH	Lehman ABS Corporation",
"XFP	Lehman ABS Corporation",
"XFR	Lehman ABS Corporation",
"XIDE	Exide Technologies",
"XIN	Xinyuan Real Estate Co Ltd",
"XING	Qiao Xing Universal Resources, Inc.",
"XKE	Lehman ABS Corporation",
"XKN	Lehman ABS Corporation",
"XKO	Lehman ABS Corporation",
"XL	XL Group plc",
"XLNX	Xilinx, Inc.",
"XLS	ITT Corporation",
"XNPT	XenoPort, Inc.",
"XNY	China Xiniya Fashion Limited",
"XOM	Exxon Mobil Corporation",
"XOMA	XOMA Corporation",
"XOXO	The Knot, Inc.",
"XRAY	DENTSPLY International Inc.",
"XRIT	X-Rite, Incorporated",
"XRM	Xerium Technologies, Inc.",
"XRS	TAL Education Group",
"XRTX	Xyratex Ltd.",
"XRX	Xerox Corporation",
"XTEX	Crosstex Energy, L.P.",
"XTXI	Crosstex Energy, Inc.",
"XUE	Xueda Education Group",
"XVG	Lehman ABS Corporation",
"XWES	World Energy Solutions Inc (DE)",
"XXIA	Ixia",
"XYL	ITT Corporation",
"Y	Alleghany Corporation",
"YAVY	Yadkin Valley Financial Corporation",
"YDNT	Young Innovations, Inc.",
"YELP	Yelp Inc.",
"YGE	Yingli Green Energy Holding Company Limited",
"YHOO	Yahoo! Inc.",
"YNDX	Yandex N.V.",
"YOKU	Youku Inc.",
"YONG	Yongye International, Inc.",
"YORW	The York Water Company",
"YPF	YPF Sociedad Anonima",
"YRCW	YRC Worldwide, Inc.",
"YTEC	Yucheng Technologies Limited",
"YUM	Yum! Brands, Inc.",
"YZC	Yanzhou Coal Mining Company Limited",
"Z	Zillow, Inc.",
"ZA	Zuoan Fashion Limited",
"ZAGG	ZAGG Inc",
"ZAZA	ZaZa Energy Corporation",
"ZBRA	Zebra Technologies Corporation",
"ZEP	Zep Inc.",
"ZEUS	Olympic Steel, Inc.",
"ZF	Zweig Fund, Inc. (The)",
"ZGNX	Zogenix, Inc.",
"ZHNE	Zhone Technologies, Inc.",
"ZIGO	Zygo Corporation",
"ZINC	Horsehead Holding Corp.",
"ZION	Zions Bancorporation",
"ZIONW	Zions Bancorporation",
"ZIOP	ZIOPHARM Oncology Inc",
"ZIP	Zipcar, Inc.",
"ZIPR	ZipRealty, Inc.",
"ZIXI	Zix Corporation",
"ZLC	Zale Corporation",
"ZLCS	Zalicus Inc.",
"ZLTQ	ZELTIQ Aesthetics, Inc.",
"ZMH	Zimmer Holdings, Inc.",
"ZN	Zion Oil & Gas Inc",
"ZNGA	Zynga Inc.",
"ZNH	China Southern Airlines Company Limited",
"ZNWAL	Zion Oil & Gas Inc",
"ZNWAW	Zion Oil & Gas Inc",
"ZNWAZ	Zion Oil & Gas Inc",
"ZOLL	Zoll Medical Corporation",
"ZOLT	Zoltek Companies, Inc.",
"ZOOM	Zoom Technologies, Inc.",
"ZQK	Quiksilver, Inc.",
"ZSTN	ZST Digital Networks, Inc.",
"ZTR	Zweig Total Return Fund, Inc. (The)",
"ZUMZ	Zumiez Inc.",
"ZX	China Zenix Auto International Limited",
"ZZ	Sealy Corporation",
"ZZC	Sealy Corporation"}
            End If

            Return _SymbolNames
        End Get
    End Property
End Class